theory Composition
imports Projections
begin

definition compose :: "('a, 's)nds_monad \<Rightarrow> ('e, 's)nds_monad \<Rightarrow> ('s \<Rightarrow> 's set) \<Rightarrow>
    ('a, 'e, 's)re_monad" where
  "compose nn ne r \<equiv> \<lambda>s.
    {(Some (Inr v), s')|v s'. (v, s') \<in> nn s}
    \<union> {(Some (Inl e), s')|e s'. (e, s') \<in> ne s}
    \<union> {(None, s')|s'. s' \<in> r s}
  "

lemma compose_projectNN:
  "(compose nn ne r)\<Down>NN = nn"
  by(auto simp add: compose_def projectNN_def)

lemma compose_projectNE:
  "(compose nn ne r)\<Down>NE = ne"
  by(auto simp add: compose_def projectNE_def)

lemma compose_projectR:
  "(compose nn ne r)\<Down>R = r"
  by(auto simp add: compose_def projectR_def)

lemmas compose_project = compose_projectNN compose_projectNE compose_projectR

lemma proj_subset:
  "\<lbrakk> \<forall>s. (m\<Down>R) s \<subseteq> (m'\<Down>R) s; \<forall>s. (m\<Down>NN) s \<subseteq> (m'\<Down>NN) s;\<forall>s. (m\<Down>NE) s \<subseteq> (m'\<Down>NE) s \<rbrakk> \<Longrightarrow>
    m s \<subseteq> m' s"
  apply(clarsimp simp add: project_defs)
  apply(case_tac a)
  apply(blast)
  apply(case_tac aa)
  apply(blast)+
  done

lemma proj_subset':
  "\<lbrakk> (m\<Down>NN) s \<subseteq> (m'\<Down>NN) s; (m\<Down>NE) s \<subseteq> (m'\<Down>NE) s; (m\<Down>R) s \<subseteq> (m'\<Down>R) s \<rbrakk> \<Longrightarrow>
    m s \<subseteq> m' s"
  apply(rule subsetI)
  apply(case_tac x, simp)
  apply(case_tac[!] a, simp)
  apply(force simp add: projectR_def)
  apply(case_tac[!] aa, auto simp add: projectNN_def projectNE_def)
  done

lemma proj_compose_subset:
  "\<lbrakk> \<forall>s. (m\<Down>R) s \<subseteq> r s; \<forall>s. (m\<Down>NN) s \<subseteq> nn s; \<forall>s. (m\<Down>NE) s \<subseteq> ne s \<rbrakk> \<Longrightarrow>
    m s \<subseteq> (compose nn ne r) s"
  apply(rule proj_subset)
  apply(auto simp add: compose_project)
  done

end
