theory Misc_Lemmas
imports Main
begin

lemma not_all_different[simp]: "(\<forall>x. y \<noteq> x) = False"
  by(auto)

lemma exist_simps[simp]:
  "(\<exists>x. (x = a \<or> x = b \<or> x = c \<or> x = d) \<and> P x) = (P a \<or> P b \<or> P c \<or> P d)"
  "(\<exists>x. ((\<exists>y. x = f1 y) \<or> (\<exists>y. x = f2 y) \<or> (\<exists>y. x = f3 y)) \<and> P x) =
    (\<exists>y. P (f1 y) \<or> P (f2 y) \<or> P (f3 y))"
  "(\<exists>x. (\<exists>y. x = f y) \<and> P x) = (\<exists>y. P (f y))"
  "(\<exists>x. (x = y \<or> x = z) \<and> P x) = (P y \<or> P z)"
  "(\<exists>x. (x = y \<or> x = z \<and> Q x) \<and> P x) = (P y \<or> P z \<and> Q z)"
  by(auto)

lemma UNIV_times_Collect: "UNIV \<times> {y. P y} = {(x, y). P y}"
  by(auto)

lemma Int_Collects: "{x. P x} \<inter> {x. Q x} = {x. P x \<and> Q x}"
  by(auto)

lemma Collect_subset: "({x. P x} \<subseteq> {x. Q x}) = (\<forall>x. P x \<longrightarrow> Q x)"
  by(auto)

lemma pull_ex_out: "(\<exists>x. (\<exists>y. P x y) \<and> Q x) = (\<exists>y x. P x y \<and> Q x)"
  by(auto)

lemma All_impE': "\<lbrakk> \<forall>x. P \<longrightarrow> Q x; P \<rbrakk> \<Longrightarrow> \<forall>x. Q x"
  by(blast)

lemma All2_impE':
  "\<lbrakk> \<forall>x y. P \<longrightarrow> Q x y; P \<rbrakk> \<Longrightarrow> \<forall>x y. Q x y"
  by blast

lemma All_imp_ball: "\<forall>x. P x \<Longrightarrow> \<forall>x\<in>S. P x"
  by simp

lemma ball_impE: "\<lbrakk> \<forall>x \<in> S. P x \<longrightarrow> Q x; (\<And>x. x \<in> S \<Longrightarrow> P x) \<rbrakk> \<Longrightarrow> \<forall>x \<in> S. Q x"
  by(blast)

lemma ball_impE': "\<lbrakk> \<forall>x \<in> S. P \<longrightarrow> Q x; P \<rbrakk> \<Longrightarrow> \<forall>x \<in> S. Q x"
  by(blast)

lemma ball_decompose_All:
  "\<lbrakk> (\<forall>x. A x \<longrightarrow> P x); (\<And>x. x \<in> S \<Longrightarrow> A x) \<rbrakk> \<Longrightarrow> \<forall>x\<in>S. P x"
  by blast

lemma ball_decompose_All':
  "\<lbrakk> (\<forall>x. A \<longrightarrow> P x); A \<rbrakk> \<Longrightarrow> \<forall>x\<in>S. P x"
  by blast

lemma ex_conj_distribs:
  "(\<exists>x. P x \<and> Q) = ((\<exists>x. P x) \<and> Q)"
  "(\<exists>x. Q \<and> P x) = ((\<exists>x. P x) \<and> Q)"
  "(\<exists>x. P x \<and> (Q \<and> R x)) = (Q \<and> (\<exists>x. P x \<and> R x))"
  "(\<exists>x. P x \<and> (R x \<and> Q)) = ((\<exists>x. P x \<and> R x) \<and> Q)"
  "(\<exists>x. P x \<and> (R x \<and> (S x \<and> T))) = ((\<exists>x. P x \<and> R x \<and> S x) \<and> T)"
  by(auto)

lemma all_conj: "(\<forall>x. P x \<and> Q x) = ((\<forall>x. P x) \<and> (\<forall>x. Q x))"
  by(auto)

lemma ball_conj:
  "(\<forall>x\<in>A. P x \<and> Q x) = ((\<forall>x\<in>A. P x) \<and> (\<forall>x\<in>A. Q x))"
  by(auto)
 
lemma insert_UNIV:
  "insert x UNIV = UNIV"
  by(auto)

end
