theory Pmm_Lemmas
imports PmmDefs Projections Pmm_Tacs HoareLogic
begin

lemma exc_exhaust:
  "\<lbrakk> e \<noteq> FailWrite; e \<noteq> FailLLRead; e \<noteq> FailRead; e \<noteq> FailMode; e \<noteq> InvalidInput;
  \<forall>c. e \<noteq> Degraded c; e \<noteq> StartedExc
   \<rbrakk> \<Longrightarrow> False"
  by(case_tac e, auto)

lemma card_mode_exhaust:
  "\<lbrakk> cm \<noteq> CNormal; cm \<noteq> CDegraded; cm \<noteq> CDegradedP; cm \<noteq> CDegradedH; cm \<noteq> CFail \<rbrakk> \<Longrightarrow> False"
  by(case_tac cm, simp_all)

lemma FailLLRead_exhaust:
  "\<lbrakk> e \<noteq> FailWrite; e \<noteq> FailRead; e \<noteq> FailMode; e \<noteq> InvalidInput;
  \<forall>c. e \<noteq> Degraded c; e \<noteq> StartedExc
   \<rbrakk> \<Longrightarrow> (e = FailLLRead) = True"
  "\<lbrakk> e \<noteq> FailWrite; e \<noteq> FailRead; e \<noteq> FailMode; e \<noteq> InvalidInput;
  \<forall>c. e \<noteq> Degraded c; e \<noteq> StartedExc
   \<rbrakk> \<Longrightarrow> (FailLLRead = e) = True"
  by(case_tac[!] e, auto)

lemma FailMode_exhaust:
  "\<lbrakk> e \<noteq> FailWrite; e \<noteq> FailRead; e \<noteq> FailLLRead; e \<noteq> InvalidInput;
  \<forall>c. e \<noteq> Degraded c; e \<noteq> StartedExc
   \<rbrakk> \<Longrightarrow> (e = FailMode) = True"
  "\<lbrakk> e \<noteq> FailWrite; e \<noteq> FailRead; e \<noteq> FailLLRead; e \<noteq> InvalidInput;
  \<forall>c. e \<noteq> Degraded c; e \<noteq> StartedExc
   \<rbrakk> \<Longrightarrow> (FailMode = e) = True"
  by(case_tac[!] e, auto)

lemma FailMode_exhaust':
  "\<lbrakk> e \<noteq> FailWrite; e \<noteq> FailRead; e \<noteq> FailLLRead; e \<noteq> InvalidInput;
  \<forall>c. e \<noteq> Degraded c; e \<noteq> StartedExc
   \<rbrakk> \<Longrightarrow> e = FailMode"
  by(case_tac[!] e, auto)

lemma FailWrite_exhaust:
  "\<lbrakk> e \<noteq> FailLLRead; e \<noteq> FailRead; e \<noteq> FailMode; e \<noteq> InvalidInput;
  \<forall>c. e \<noteq> Degraded c; e \<noteq> StartedExc
   \<rbrakk> \<Longrightarrow> (e = FailWrite) = True"
  "\<lbrakk> e \<noteq> FailLLRead; e \<noteq> FailRead; e \<noteq> FailMode; e \<noteq> InvalidInput; 
  \<forall>c. e \<noteq> Degraded c; e \<noteq> StartedExc
   \<rbrakk> \<Longrightarrow> (FailWrite = e) = True"
  by(case_tac[!] e, auto)

lemma FailRead_exhaust:
  "\<lbrakk> e \<noteq> FailWrite; e \<noteq> FailLLRead; e \<noteq> FailMode; e \<noteq> InvalidInput;
  \<forall>c. e \<noteq> Degraded c; e \<noteq> StartedExc
   \<rbrakk> \<Longrightarrow> (e = FailRead) = True"
  "\<lbrakk> e \<noteq> FailWrite; e \<noteq> FailLLRead; e \<noteq> FailMode; e \<noteq> InvalidInput;
  \<forall>c. e \<noteq> Degraded c; e \<noteq> StartedExc
   \<rbrakk> \<Longrightarrow> (FailRead = e) = True"
  by(case_tac[!] e, auto)

lemma Degraded_exhaust:
  "\<lbrakk> e \<noteq> FailWrite; e \<noteq> FailLLRead; e \<noteq> FailMode; e \<noteq> InvalidInput;
    e \<noteq> FailRead; e \<noteq> StartedExc
   \<rbrakk> \<Longrightarrow> (\<forall>v. e = Degraded v \<longrightarrow> P v) = (\<exists>v. e = Degraded v \<and> P v)"
  "\<lbrakk> e \<noteq> FailWrite; e \<noteq> FailLLRead; e \<noteq> FailMode; e \<noteq> InvalidInput;
    e \<noteq> FailRead; e \<noteq> StartedExc
   \<rbrakk> \<Longrightarrow> (\<forall>v. Degraded v = e \<longrightarrow> P v) = (\<exists>v. e = Degraded v \<and> P v)"
  by(case_tac[!] e, auto)

lemma fun_upd_second_idem_iff:
  "(fun_upd_second f x y z = f) = (z = f x y)"
  by (metis fun_upd_idem_iff)

lemma fun_upd_second_idem_iff':
  "(f = fun_upd_second f x y z) = (z = f x y)"
  by (metis fun_upd_idem_iff)

lemma fun_upd_second_same:
  "(fun_upd_second f x y z = fun_upd_second f x y z') = (z = z')"
  by (metis fun_upd_same)

lemma vol_ops_project_simps:
  "init_vars\<Down>NE = empty"
  "init_vars\<Down>R = empty"
  "get_mode\<Down>NE = empty"
  "get_mode\<Down>R = empty"
  "set_degraded\<Down>NE = empty"
  "set_degraded\<Down>R = empty"
  "set_degraded_p\<Down>NE = empty"
  "set_degraded_p\<Down>R = empty"
  "set_degraded_h\<Down>NE = empty"
  "set_degraded_h\<Down>R = empty"
  "set_failed\<Down>NE = empty"
  "set_failed\<Down>R = empty"
  "get_updated\<Down>NE = empty"
  "get_updated\<Down>R = empty"
  "(set_updated upd)\<Down>NE = empty"
  "(set_updated upd)\<Down>R = empty"
  "(add_to_updated ind)\<Down>NE = empty"
  "(add_to_updated ind)\<Down>R = empty"
  by(auto simp add: vol_ops_defs project_defs unfold_monad getters_setters)

lemma restart_mangle_sv_proj_simps:
  "restart_mangle_sv\<Down>NN = empty"
  "restart_mangle_sv\<Down>NE = empty"
  by(auto simp add: restart_mangle_sv_raw unfold_monad project_defs)

lemma HoareNE_vol_ops:
  "\<lbrace>P\<rbrace> set_failed \<lbrace>@N Q\<rbrace>"
  "\<lbrace>P\<rbrace> set_degraded \<lbrace>@N Q\<rbrace>"
  "\<lbrace>P\<rbrace> set_updated pinds \<lbrace>@N Q\<rbrace>"
  "\<lbrace>P\<rbrace> get_mode \<lbrace>@N Q\<rbrace>"
  "\<lbrace>P\<rbrace> add_to_updated pind \<lbrace>@N Q\<rbrace>"
  "\<lbrace>P\<rbrace> get_updated \<lbrace>@N Q\<rbrace>"
  by(auto simp add: HoareNE_alt Hoare_def Box_def vol_ops_defs project_defs getters_setters unfold_monad)

lemma HoareNN_get_mode:
  "\<lbrace>P\<rbrace> get_mode \<lbrace>>N K P\<rbrace>"
  by(auto simp add: HoareNN_alt Hoare_def Box_def vol_ops_defs project_defs getters_setters unfold_monad)

lemma get_updated_post_NN:
  "\<lbrace>P\<rbrace> get_updated \<lbrace>>N updated_equals \<rbrace>"
  by(auto simp add: HoareNN_alt Hoare_def Box_def vol_ops_defs getters_setters unfold_monad
    project_defs updated_equals_def)

lemma fun_upd_second_is_upd_iff:
    "(f(x := g) = fun_upd_second f x y z) = (g = (f x)(y := z))"
  by (metis fun_upd_same)

lemma fun_upd_second_is_triv_iff:
  "(f = fun_upd_second f x y z) = (z = f x y)"
  "(fun_upd_second f x y z = f) = (z = f x y)"
  apply(auto simp add: fun_upd_def split: split_if_asm split_if intro!: ext
    dest: arg_cong2[where a=x and b=x and c=y and d=y])
  apply(smt)+
  done

lemma fun_upd_eq_iff:
  "(f(x := y) = f(x := z)) = (y = z)"
  by(auto dest: fun_cong[where x=x])

lemma fun_upd_is_triv_iff:
  "(f = f(x:=y)) = (y = f x)"
  by(auto dest: fun_cong[where x=x])

lemma ball_bind_mono2:
  "\<forall>v s'. (v, s') \<in> (m\<Down>NN) s \<longrightarrow> f v s' \<subseteq> f' v s' \<Longrightarrow>
    (m \<guillemotright>= f) s \<subseteq> (m \<guillemotright>= f') s"
  apply(auto)
  apply(case_tac a)
  apply(force simp add: bind_none_decompose projectNN_def)
  apply(case_tac aa)
  apply(force simp add: bind_exc_decompose projectNN_def)
  apply(force simp add: bind_norm_decompose projectNN_def)
  done

lemma sv_mode_eq_neq_subset: "m \<noteq> m' \<Longrightarrow> sv_mode_equals m \<subseteq> sv_mode_neq m'"
  by(auto simp add: sv_mode_equals_def sv_mode_neq_def)

lemma parse_serialize_htable:
  "parse_htable (serialize_htable ht) = ht"
  by (metis inj_serialize_htable inv_f_eq parse_htable_spec)

lemma parse_serialize_hinst:
  "parse_hinst (serialize_hinst c) = c"
  by (metis inv_f_eq bij_serialize_hinst[THEN bij_is_inj] parse_hinst_spec)

lemma parse_serialize_ptr:
  "parse_ptr (serialize_ptr ptr_set) = ptr_set"
  by (metis inv_f_eq inj_serialize_ptr parse_ptr_spec)

lemma parse_hinst_htable_to_hinst_cnt:
  "fst (parse_hinst (htable_to_hinst_cnt (ht :: ('c :: contents_cl)htable))) = serialize_htable ht"
  by(auto simp add: htable_to_hinst_cnt_def parse_serialize_hinst)

lemma parse_written_ht:
  "parse_htable (fst (parse_hinst (htable_to_hinst_cnt (ht :: ('c :: contents_cl)htable)))) = ht"
  by(auto simp add: htable_to_hinst_cnt_def parse_serialize_hinst parse_serialize_htable)

lemma hash_of_parse_written_ht:
  "snd (parse_hinst (htable_to_hinst_cnt (ht :: ('c :: contents_cl)htable))) 
    = Hash (serialize_htable ht)"
  by(auto simp add: htable_to_hinst_cnt_def parse_serialize_hinst)

lemma mapM'_not_empty:
  "\<forall>x \<in> set l. ((f x)\<Down>R = empty) \<Longrightarrow> ((mapM' f l)\<Down>R) = empty"
  apply(induct l)
  apply(auto simp add: unfold_monad project_defs intro!: ext split: option.split_asm sum.split_asm)
  apply (metis empty_iff mem_Collect_eq)+
  done

lemma None_not_in_check_sizes:
  "(None, s') \<notin> check_sizes upd_f s"
proof-
  { 
    fix l
    have "\<forall>x \<in> set l. (((\<lambda>pind. if capacity (Public pind) < size (the (upd_f pind))
                         then throw InvalidInput else return ()) x)\<Down>R) = empty"
      by(auto simp add: unfold_monad project_defs)
  }
  note e_prec=this
  have 
    "(check_sizes upd_f)\<Down>R = empty"
    apply(auto simp add: check_sizes_def project_simps first_stage intro!: ext)
    apply(simp add: unfold_monad choose_def)
    apply(simp add: mapM'_not_empty[OF e_prec])
    done
  from this[THEN fun_cong, where x=s] show ?thesis
    by(auto simp add: project_defs)
qed

lemma sefR_singleton':
  "\<lbrakk> sefR m; (v, s') \<in> m s \<rbrakk> \<Longrightarrow> s' = s"
  by(force simp add: image_def dest!: sefR_singleton[where s=s])

lemma sefR_None':
  "\<lbrakk> sefR m; (None, s') \<in> m s \<rbrakk> \<Longrightarrow> False"
  by(force simp add: image_def dest!: sefR_None[where s=s])

lemma sef_mapM_D:
  assumes sef: "\<forall>x :: 'a \<in> set l. sefR (f x)"
  and inM: "((r, s') \<in> mapM' f l s) "
  shows 
    "s' = s 
        \<and> ((r = Some (Inr ()) \<and> (\<forall>x \<in> set l. \<exists>v. (Some (Inr v), s) \<in> f x s))
            \<or> (\<exists>e x. r = Some (Inl e) \<and> x \<in> set l \<and> (Some (Inl e), s) \<in> f x s)
        )
    "
proof(safe del: disjCI)
  show "s' = s" using inM sef
  proof(induct l)
    case (Cons y ys)
    hence sef_y: "sefR (f y)" using sef
      by(auto)
    show "s' = s" using Cons
      by(clarsimp simp add: unfold_monad dest!: sefR_singleton'[OF sef_y] 
        split: option.split_asm sum.split_asm)
  qed(auto simp add: return_defs)
next
  show
    "(r = Some (Inr ()) \<and> (\<forall>x\<in>set l. \<exists>v. (Some (Inr v), s) \<in> f x s)) 
    \<or> (\<exists>e x. r = Some (Inl e) \<and> x \<in> set l \<and> (Some (Inl e), s) \<in> f x s)"
    using sef inM
  proof(induct l)
    case (Cons y ys)
    hence sef_y: "sefR (f y)" using sef
      by(auto)
    thus "(r = Some (Inr ()) \<and> (\<forall>x\<in>set (y # ys). \<exists>v. (Some (Inr v), s) \<in> f x s)) 
        \<or> (\<exists>e x. r = Some (Inl e) \<and> x \<in> set (y # ys) \<and> (Some (Inl e), s) \<in> f x s)"
      using Cons
      apply(clarsimp simp add: unfold_monad split: sum.split_asm option.split_asm
        dest!: sefR_None'[OF sef_y]
      )
      apply (metis sefR_singleton')+
      done
  qed(auto simp add: return_defs)
qed

    
lemma order_set_hd:
  "\<lbrakk> finite A; x # xs \<in> order_set A \<rbrakk> \<Longrightarrow> xs \<in> order_set (A - {x})"
  apply(unfold order_set_def, simp_all)
  by (metis Diff_insert_absorb fold_graph.cases list.distinct(1) list.inject)

lemma exc_in_check_sizes_iff:
  "((Some (Inl e), s') \<in> check_sizes upd_f s) = 
    (s' = s \<and> e = InvalidInput \<and> (\<exists>ind \<in> dom upd_f. size (the (upd_f ind)) > capacity (Public ind)))"
proof-
  have ex_ord: "\<exists>l. l \<in> order_set (dom upd_f)" (is "\<exists>x. ?P x")
    by(auto simp add: order_set_def intro!: finite_imp_fold_graph)
  then obtain l where l_def: "l \<in> order_set (dom upd_f)" ..
  
  {
    fix A ind cnt
    assume 
      "A \<subseteq> dom upd_f"
      "l \<in> order_set A" 
      "capacity (Public ind) < size cnt"
      "upd_f ind = Some cnt" 
      "ind \<in> set l"
    hence "(Some (Inl InvalidInput), s)
          \<in> mapM'
             (\<lambda>pind. if capacity (Public pind) < size (the (upd_f pind))
                     then throw InvalidInput else return ())
             l s"
      apply(induct l arbitrary: A)
      apply(clarsimp)
      apply(auto simp add: unfold_monad project_defs)
      apply(subgoal_tac "l \<in> order_set (A - {a})") 
      apply (metis Diff_subset subset_trans)
      apply(auto intro!: order_set_hd)
      done
  } note subs_g = this

  have oversized_imp_exc:
    "\<exists>ind \<in> dom upd_f. size (the (upd_f ind)) > capacity (Public ind) \<Longrightarrow>
    (Some (Inl InvalidInput), s) \<in> check_sizes upd_f s" using l_def
    apply(clarsimp simp add: check_sizes_def chooseN_def unfold_monad choose_def)
    apply(rule_tac bexI[OF _ l_def])
    apply(subgoal_tac "ind \<in> set l")
    apply(auto elim!: subs_g[OF order_refl])[1]
    apply (metis domI finite order_set_set)
    done

  show ?thesis
    apply(auto simp add: unfold_monad split: split_if_asm)
    prefer 4
    apply(rule_tac ind1=ind in oversized_imp_exc[OF bexI])
    apply(clarsimp)
    apply(clarsimp)
    apply(auto simp add: check_sizes_def chooseN_def choose_def unfold_monad)
    apply(auto dest!: sef_mapM_D[rotated 1])
    apply(auto simp add: sefR_def unfold_monad order_set_set split: split_if_asm)
    done
qed

lemma norm_in_check_sizes_iff:
  "(Some (Inr ()), s') \<in> check_sizes upd_f s
    = (s' = s \<and> (\<forall>ind \<in> dom upd_f. size (the (upd_f ind)) \<le> capacity (Public ind)))"
proof-
  have ex_ord: "\<exists>l. l \<in> order_set (dom upd_f)" (is "\<exists>x. ?P x")
    by(auto simp add: order_set_def intro!: finite_imp_fold_graph)
  then obtain l where l_def: "l \<in> order_set (dom upd_f)" ..

  {
    fix A ind cnt
    assume assms:
      "A \<subseteq> dom upd_f"
      "l \<in> order_set A" 
      "\<forall>ind\<in>dom upd_f. size (the (upd_f ind)) \<le> capacity (Public ind)"
    hence finA: "finite A"
      by auto

    have "(Some (Inr ()), s) \<in> 
        mapM' (\<lambda>pind. if capacity (Public pind) < size (the (upd_f pind)) 
                then throw InvalidInput else return ())
       l s" using assms
      apply(induct l arbitrary: A)
      apply(simp add: return_defs)
      apply(auto simp add: unfold_monad)
      apply(drule order_set_set)
      apply(simp)
      apply(simp)
      apply(subgoal_tac "a \<in> dom (upd_f)")
      apply(smt)
      apply(clarsimp)
      apply(subgoal_tac "l \<in> order_set (A - {a})")
      apply (metis Diff_subset order_trans) 
      apply(simp add: order_set_hd)
      done

  } note norm_in_mapM=this

  have ok_imp_norm:
    "(\<forall>ind\<in>dom upd_f. size (the (upd_f ind)) \<le> capacity (Public ind)) \<Longrightarrow>
    (Some (Inr ()), s) \<in> check_sizes upd_f s"
    apply(auto simp add: check_sizes_def unfold_monad choose_def chooseN_def)
    apply(rule_tac bexI[OF _ l_def])
    apply(simp add: norm_in_mapM[OF order_refl l_def])
    done

  show ?thesis
    apply(auto simp add: unfold_monad split: split_if_asm)
    prefer 3
    apply(drule ok_imp_norm, simp)
    apply(auto simp add: check_sizes_def chooseN_def choose_def unfold_monad)
    apply(auto dest!: sef_mapM_D[rotated 1])
    apply(auto simp add: sefR_def unfold_monad order_set_set split: split_if_asm)
    by (metis domI not_less the.simps)
qed

definition check_sizes' where
  "check_sizes' upd_f \<equiv> if (\<forall>ind \<in> dom upd_f. size (the (upd_f ind)) \<le> capacity (Public ind))
        then return ()
        else throw InvalidInput"

lemma None_not_in_check_sizes':
  "(None, s') \<notin> check_sizes' upd_f s"
  by(auto simp add: check_sizes'_def unfold_monad)

lemma check_sizes_alt: 
  "check_sizes upd_f = check_sizes' upd_f"
  apply(auto intro!: ext)
  apply(rename_tac[!] s v s')
  apply(case_tac[!] v)
  apply(clarsimp_all)
  apply(simp_all add: None_not_in_check_sizes None_not_in_check_sizes')
  apply(case_tac[!] a, clarsimp_all)
  apply(simp_all add: exc_in_check_sizes_iff norm_in_check_sizes_iff)
  apply(auto simp add: check_sizes'_def unfold_monad dest: leD split: split_if_asm)
  apply(force)
  done

end