theory RMonad_Decomposition
imports RMonad
begin

lemma bindN_compose:
  "((c, u) \<in> (p \<guillemotright>=N q) s) =
  (\<exists>b t. (b, t) \<in> p s \<and> (c, u) \<in> q b t)"
  by(auto simp add: bindN_def bindS_def)

lemma bindR_some_decompose:
  "((Some r, u) \<in> (p \<guillemotright>=R q) s) =
   (\<exists> b t. (Some b, t) \<in> (p s) \<and> (Some r, u) \<in> (q b t))" 
  apply(auto simp add: bindR_def liftR_def bindN_compose)
  apply(case_tac b)
  apply(force simp add: restart_def returnN_def returnS_def)+
  done

lemma bindR_none_decompose:
  "((None, u) \<in> (p \<guillemotright>=R q) s) =
  ((None, u) \<in> p s \<or> (\<exists>b t. (Some b, t) \<in> p s \<and> (None, u) \<in> q b t))"
  apply(auto simp add: bindR_def liftR_def bindN_compose)
  apply(case_tac b)
  apply(force simp add: restart_def returnN_def returnS_def)+
  done

lemma bind_none_decompose:
  "((None, u) \<in> (p \<guillemotright>= q) s)=
    ((None, u) \<in> p s \<or> (\<exists>b t. (Some (Inr b), t) \<in> p s \<and> (None, u) \<in> q b t))"
  by(auto simp add: bind_def bindR_none_decompose liftE_def throw_def 
    returnR_def returnN_def returnS_def
    split: sum.split_asm)

lemma bind_norm_decompose:
  "((Some (Inr r), u) \<in> (p \<guillemotright>= q) s) =
   (\<exists> b t. (Some (Inr b), t) \<in> (p s) \<and> (Some (Inr r), u) \<in> (q b t))" 
  apply(auto simp add: bind_def liftE_def bindR_some_decompose split: sum.split)
  apply(case_tac b)
  apply(force simp add: throw_def returnR_def returnN_def returnS_def)+
  done

lemma bind_exc_decompose:
  "((Some (Inl e), u) \<in> (p \<guillemotright>= q) s) =
  ((Some (Inl e), u) \<in> p s \<or> (\<exists>b t. (Some (Inr b), t) \<in> p s \<and> (Some (Inl e), u) \<in> q b t))"
  apply(auto simp add: bind_def liftE_def bindR_some_decompose split: sum.split)
  apply(case_tac b)
  apply(force simp add: throw_def returnR_def returnN_def returnS_def)+
  done

lemma try_catchR_some_decompose: 
  "((Some x, t) \<in> (try_catchR p q s)) =
   ((Some x, t) \<in> p s \<or> (\<exists> u. (None, u) \<in> (p s) \<and> (Some x, t) \<in> (q u)))"
  by (force simp add: try_catchR_def liftR2_def split: option.split_asm option.split)

lemma try_catchR_none_decompose: 
  "((None, t) \<in> (try_catchR p q s)) =
   (\<exists> u. (None, u) \<in> (p s) \<and> (None, t) \<in> (q u))"
  by (force simp add: try_catchR_def liftR2_def split: option.split_asm option.split)

lemma try_catch_norm_decompose: 
  "((Some (Inr x), t) \<in> (try_catch p q s)) =
   ((Some (Inr x), t) \<in> p s \<or> (\<exists> e u. (Some (Inl e), u) \<in> (p s) \<and> (Some (Inr x), t) \<in> (q e u)))"
  apply(auto simp add: try_catch_def bindR_some_decompose liftE2_def  
    return_defs
    split: sum.split sum.split_asm)
  apply(case_tac b, auto)
  done

lemma try_catch_exc_decompose: 
  "((Some (Inl x), t) \<in> (try_catch p q s)) =
   ((\<exists> e u. (Some (Inl e), u) \<in> (p s) \<and> (Some (Inl x), t) \<in> (q e u)))"
  apply(auto simp add: try_catch_def bindR_some_decompose liftE2_def  
    return_defs
    split: sum.split sum.split_asm)
  apply(case_tac b, auto)
  done

lemma try_catch_none_decompose:
  "(None, s') \<in> try_catch m1 m2 s = 
    ((None, s') \<in> m1 s \<or> (\<exists>e s''. (Some (Inl e), s'') \<in> m1 s \<and> (None, s') \<in> m2 e s''))"
  apply(auto simp add: try_catch_def liftE2_def bindR_none_decompose
    return_defs
    split: option.split option.split_asm sum.split sum.split_asm)
  apply(case_tac b, auto)
  done


end
