theory Snippets
imports Full_Ref Specification
begin

lemma HoareR_decompose:
  "\<lbrakk> \<lbrace>P\<rbrace> m \<lbrace>>N K Q\<rbrace>; \<lbrace>P\<rbrace> m \<lbrace>@N K Q\<rbrace> \<rbrakk> \<Longrightarrow> \<lbrace>P\<rbrace> m \<lbrace>>R K Q\<rbrace>"
  apply(clarsimp simp add: HoareN_alt HoareNN_alt HoareNE_alt Hoare_def Box_def project_defs K_def)
  apply(case_tac a)
  apply(auto)
  done

lemma transaction_property:
  "\<lbrace>memory_eq mem\<rbrace>
    (<tryR> update upd_f <catchR> startup)
  \<lbrace>>R K (memory_eq (fun_map_override_on mem upd_f (dom upd_f))
        \<union> memory_eq mem)
  \<rbrace>"
  apply(auto intro!: HoareR_decompose transaction_property_NE 
    conseqNN_rule[OF _ transaction_property_NN])
  apply(auto simp add: K_def)
  done

definition sp_memory_eq where
  "sp_memory_eq mem \<equiv> {sp. memory sp = mem }"

lemma
  "obs abs6_spec -` (UNIV \<times> sp_memory_eq (Some mem)) \<subseteq> memory_eq mem"
  by(auto simp add: abs6_spec_def abs6_ts_def sp_memory_eq_def memory_eq_def image_def
    TS.extend_def spec.fields_def split: split_if_asm)

lemma
  "memory_eq mem \<subseteq> obs abs6_spec -` (UNIV \<times> (sp_memory_eq (Some mem) \<union> sp_memory_eq None))"
  by(auto simp add: abs6_spec_def abs6_ts_def sp_memory_eq_def memory_eq_def image_def
    TS.extend_def spec.fields_def split: split_if_asm)

text_raw {*\DefineSnippet{Hoare}{ *}
  term "\<lbrace>P\<rbrace> m \<lbrace>>N Q\<rbrace>"
text_raw {*}%EndSnippet*}

text_raw {*\DefineSnippet{DataAQ}{ *}
text {* @{datatype "exceptions"} *}
text_raw {*}%EndSnippet*}

use "record_antiquot.ML"

ML {* Context.>> (Context.map_theory antiq_setup) *}

hide_const Relation.trans

declare [[thy_output_break]]
declare [[ML_trace = true]]

text_raw {*\DefineSnippet{TS_record}{ *}
text {* @{record "TS"} *}
text_raw {*}%EndSnippet*}

ML {*
  val t = @{term "init"};
  pprint (Syntax.pretty_term_global @{theory} t);
  tracing (Syntax.string_of_term @{context} t);

*}

term "init"

(*
ML {*
  pprint (Syntax.pretty_term @{context} 
  (Const ("Snippets.TSR.init", "'a Set.set")))

*}

ML {*
  @{typ "'a TSR"}
*}
  *)

typ "('v, 'e, 's)re_monad"

text {* @{type re_monad} *}

(*
lemma reach_char: "reach TS = ((trans TS)\<^sup>* ) `` (init_trans TS `` init TS)"
proof(rule Set.equalityI, rule_tac[!] subsetI)
  fix s
  assume "s \<in> reach TS"
  thus "s \<in> (TS.trans TS)\<^sup>* `` init_trans TS `` init TS"
    apply(induct rule: reach.induct)
    apply(auto)
    by (metis rev_ImageI rtrancl.rtrancl_into_rtrancl)
next
  fix s
  assume "s \<in> (TS.trans TS)\<^sup>* `` init_trans TS `` init TS"
  thus "s \<in> reach TS"
  proof(clarsimp)
    fix s' s''
    assume "(s', s) \<in> (TS.trans TS)\<^sup>*" "(s'', s') \<in> init_trans TS" "s'' \<in> init TS"
    thus "s \<in> reach TS"
      by(induct rule: rtrancl.induct, auto)
  qed
qed

text {*
 \DefineSnippet{reach}{
    @{thm[display] reach_char}
 }%EndSnippet
*}

  *)

end