theory Snippets_Abs6
imports "~~/src/HOL/Library/LaTeXsugar" Abs6Defs Abs6_FetchDefs Abs6_Lemmas
begin

ML_file "record_antiquot.ML"

ML {* Context.>> (Context.map_theory antiq_setup) *}

declare [[names_short]]

text_raw {*\DefineSnippet{logstate}{ *}
text {* @{datatype "log_state"} *}
text_raw {*}%EndSnippet*}

text_raw {*\DefineSnippet{absmode}{ *}
text {* @{datatype "abs_card_mode"} *}
text_raw {*}%EndSnippet*}

text_raw {*\DefineSnippet{abs6state}{ *}
text {* @{typ "(abs_card_mode \<times> 'c abs_mem)"} *}
text_raw {*}%EndSnippet*}

record 'c obs_abs_mem =
  memory :: "(pub_indx \<Rightarrow> 'c)option"
  reg_state :: "pub_indx \<Rightarrow> log_state"
  admin_state :: log_state

text_raw {*\DefineSnippet{abs6obsstate}{ *}
text {* @{typ "(abs_card_mode \<times> 'c obs_abs_mem)"} *}
text_raw {*}%EndSnippet*}

declare [[thy_output_break]]

text_raw {*\DefineSnippet{abs6record}{ *}
text {* @{record "abs_mem"} *}
text_raw {*}%EndSnippet*}

definition fail_if_fail_mode where
  "fail_if_fail_mode \<equiv> fail_if_failed"

definition skip where
  "skip \<equiv> return ()"

type_notation option ("(_)\<^sub>\<bottom>" [100])

text_raw {*\DefineSnippet{abs6obsmem}{ *}
text {* @{typ "(pub_indx \<Rightarrow> 'c)\<^sub>\<bottom>"} *}
text_raw {*}%EndSnippet*}

text_raw {*\DefineSnippet{abs6fetch}{ *}
definition fetch where "fetch ind \<equiv> do {
    fail_if_fail_mode; (
    (do {
            cnt \<leftarrow> read_success ind;
            (abs6_degrade [+] skip);
            throw_mode_error (EC cnt);
            return cnt
    }) [+] abs6_fail [+] restart_mangle_sp
  )}"
text_raw {*}%EndSnippet*}

fun abs6_obs where
  "abs6_obs (sv, sp) = (sv,
    \<lparr>
        memory = (if LDead \<in> range (abs_mem.reg_state sp)
                    then None 
                    else Some (abs_mem.memory sp)
                 )
        , reg_state = abs_mem.reg_state sp
        , admin_state = abs_mem.admin_state sp
    \<rparr>
  )"

notation vimage ("_\<^sup>-\<^sup>1[_]" [60, 60])
notation HoareN ("(3\<lbrace>_\<rbrace> _ \<lbrace>>/ _\<rbrace>\<^sub>N)" [0, 0, 0] 90)

notation None ("\<bottom>")

definition memory_in where
  "memory_in S \<equiv> {(sv, sp). obs_abs_mem.memory sp \<in> S }"

text_raw {*\DefineSnippet{abs6memin}{ *}
text {* @{thm[display] "memory_in_def"} *}
text_raw {*}%EndSnippet*}

definition fun_map_override ("_ \<lhd> _") where
  "fun_map_override f m \<equiv> fun_map_override_on f m (dom m)"

(*
term image

notation image ("_[{_}]" [60])

term "Some [{{mem \<lhd> upd_f, mem}}] \<union> {\<bottom>}"
  *)

text_raw {*\DefineSnippet{abs6updpost}{ *}
term "
upd_post mem upd_f = (\<lambda>v. case v of 
  Inl _ \<Rightarrow> memory_in {Some (mem \<lhd> upd_f), Some mem, \<bottom>}
  | Inr _ \<Rightarrow> memory_in {Some (mem \<lhd> upd_f)})
"
text_raw {*}%EndSnippet*}

text_raw {*\DefineSnippet{abs6r1}{ *}
term "
\<lbrace>obs\<^isub>7\<^sup>-\<^sup>1[memory_in {Some mem}]\<rbrace>
  (<tryR> update\<^isub>7 upd_f <catchR> startup\<^isub>7)
\<lbrace>> \<lambda>v. obs\<^isub>7\<^sup>-\<^sup>1[upd_post mem upd_f v]\<rbrace>\<^sub>N
"
text_raw {*}%EndSnippet*}

consts sc :: 'a
notation sc ("S\<^sub>c")

text_raw {*\DefineSnippet{concr1}{ *}
term "
\<lbrace>obs\<^isub>0\<^sup>-\<^sup>1[\<pi>\<^sup>-\<^sup>1[memory_in {Some mem}]] \<inter> reach(S\<^sub>c)\<rbrace>
  (<tryR> update\<^isub>0 upd_f <catchR> rec_tryR startup\<^isub>0)
\<lbrace>> \<lambda>v. obs\<^isub>0\<^sup>-\<^sup>1[\<pi>\<^sup>-\<^sup>1[upd_post mem upd_f v]]\<rbrace>\<^sub>N
"
text_raw {*}%EndSnippet*}

end

