theory SpecRef_Lemmas
  imports "abs1/HTable2" Pmm_Specification Pmm_Refinement
begin

lemma relhoare_set_fun_choice_lockstep:
  "\<lbrakk> { pre } set_fun_into_rel ma, set_fun_into_rel mc {> post};
    { pre } set_fun_into_rel ma', set_fun_into_rel mc' {> post} \<rbrakk> \<Longrightarrow>
    { pre } set_fun_into_rel (ma [+] ma'), set_fun_into_rel (mc [+] mc') {> post}"
  by(force simp add: PO_rhoare_def set_fun_into_rel_def choice_def)

lemma projectS_mono:
  "m s \<subseteq> m' s \<Longrightarrow> (m\<Down>S) s \<subseteq> (m'\<Down>S) s"
  by(auto simp add: projectS_def)

lemma init_conc_mono_cond:
  "\<lbrakk> set_fun_into_rel mc' `` Sc \<subseteq> R `` set_fun_into_rel ma `` Sa; \<forall>sc \<in> Sc. mc sc \<subseteq> mc' sc \<rbrakk> \<Longrightarrow>
  set_fun_into_rel mc `` Sc \<subseteq> R `` set_fun_into_rel ma `` Sa
  "
  by(auto simp add: set_fun_into_rel_def Image_def) (blast)

lemma fin_imp_NN_incl:
  "\<lbrakk> sim_norm Id m' (try_catchR m m'); (Some v, s') \<in> m s \<rbrakk> \<Longrightarrow> (Some v, s') \<in> m' s"
  apply(case_tac v)
  apply(force simp add: sim_norm_def sim_norm_ext_def force_same_and_def 
    simN_wpc_def project_defs try_catchR_some_decompose split: split_if_asm)+
  done

lemma fin_imp_bind_NN_incl:
  "sim_norm Id m' (try_catchR m m') \<Longrightarrow>
    ((m \<guillemotright>= f)\<Down>N) s \<subseteq> ((m' \<guillemotright>= f)\<Down>N) s"
  apply(auto simp add: projectN_def)
  apply(case_tac a)
  apply(auto simp add: bind_norm_decompose bind_exc_decompose)
  apply(auto dest!: fin_imp_NN_incl)
  done

lemma sim_norm_ext_try_catchRI:
  "\<lbrakk> sim_ext R ma mc Sn Se Sr; sim_norm_ext Sr ha hc Sn Se \<rbrakk> \<Longrightarrow>
    sim_norm_ext R (try_catchR ma ha) (try_catchR mc hc) Sn Se"
  by(auto simp add: sim_exts_defs all_conj project_simps
    intro!: simN_wpc_choice_lockstep simS_wpc_choice_lockstep
    simN_wpc_bindN_set simS_wpc_bindN_set simN_wpc_bindS
    del: subsetI)
 
end