theory Abs1Defs
  imports "../RMonad" "../PmmDefs" "../Inst_State" HTable2
begin

record 'a abs1_state =
  hash1_state :: ec_state
  hash2_state :: ec_state
  hash1 :: "'a htable2"
  hash2 :: "'a htable2"

  ptr1 :: "pub_indx set"
  ptr1_state :: hw_state
  ptr2 :: "pub_indx set"
  ptr2_state :: hw_state

  memory :: "pub_indx \<Rightarrow> INST \<Rightarrow> 'a"
  hw_state :: "pub_indx \<Rightarrow> INST \<Rightarrow> hw_state"

fun hash_by_inst :: "INST \<Rightarrow> 'c abs1_state \<Rightarrow> 'c htable2" where
  "hash_by_inst Primary = hash1"
  | "hash_by_inst Secondary = hash2"

fun log_state_by_inst :: "INST \<Rightarrow> 'c abs1_state \<Rightarrow> ec_state" where
  "log_state_by_inst Primary sp = hash1_state sp"
  | "log_state_by_inst Secondary sp = hash2_state sp"

fun ptr_by_inst :: "INST \<Rightarrow> 'c abs1_state \<Rightarrow> pub_indx set" where
  "ptr_by_inst Primary = ptr1"
  | "ptr_by_inst Secondary = ptr2"

fun ptr_state_by_inst :: "INST \<Rightarrow> 'c abs1_state \<Rightarrow> hw_state" where
  "ptr_state_by_inst Primary sp = ptr1_state sp"
  | "ptr_state_by_inst Secondary sp = ptr2_state sp"

type_synonym ('a, 'sv, 'c)abs1_monad = "('a, 'c exceptions, 'sv, 'c abs1_state)pre_monad"

definition abs1_same_hashes :: "'c abs1_state \<Rightarrow> 'c abs1_state \<Rightarrow> bool" where
  "abs1_same_hashes sp sp' \<equiv>
    hash1_state sp = hash1_state sp'
    \<and> hash2_state sp = hash2_state sp'
    \<and> hash1 sp = hash1 sp'
    \<and> hash2 sp = hash2 sp'
  "

 definition abs1_same_rest where
  "abs1_same_rest sp sp' \<equiv>
            ptr1 sp' = ptr1 sp
            \<and> ptr2 sp' = ptr2 sp
            \<and> ptr1_state sp' = ptr1_state sp
            \<and> ptr2_state sp' = ptr2_state sp
            \<and> memory sp' = memory sp
            \<and> hw_state sp' = hw_state sp
   "

definition abs1_doesnt_touch_hashes :: "('a \<times> 'b abs1_state \<Rightarrow> ('c \<times> 'a \<times> 'b abs1_state) set) \<Rightarrow> bool"
  where
  "abs1_doesnt_touch_hashes m \<equiv> \<forall>sv sp v sv' sp'.
    (v, sv', sp') \<in> m (sv, sp) \<longrightarrow> abs1_same_hashes sp sp'"

definition abs1_doesnt_touch_rest :: "('a \<times> 'b abs1_state \<Rightarrow> ('c \<times> 'a \<times> 'b abs1_state) set) \<Rightarrow> bool"
  where
  "abs1_doesnt_touch_rest m \<equiv> \<forall>sv sp v sv' sp'.
    (v, sv', sp') \<in> m (sv, sp) \<longrightarrow> abs1_same_rest sp sp'"

end
