theory Abs1_LLInterface_Lemmas
  imports Abs1_LLInterface "../Projections"
  "../Pmm_Tacs"
begin

lemmas brute_force =
  unfold_monad
  project_defs
  Abs1_LLInterface.ll_read_defs
  Abs1_LLInterface.ll_read_hinst_defs
  Abs1_LLInterface.ll_read_ptr_defs
  Abs1_LLInterface.write_f_defs
  Abs1_LLInterface.write_hinst_defs
  Abs1_LLInterface.write_ptr_ll_defs
  restart_mangle_sv_raw
  getters_setters

lemma ll_read_simps':
  "((ll_read_failure ind inst)\<Down>NN) = empty"
  "((ll_read_failure ind inst)\<Down>R) = empty"
  "((ll_read_any ind inst)\<Down>NE) = empty"
  "((ll_read_any ind inst)\<Down>R) = empty"
  "((ll_read_failure_hinst inst)\<Down>NN) = empty"
  "((ll_read_failure_hinst inst)\<Down>R) = empty"
  "((ll_read_success_hinst inst)\<Down>NE) = empty"
  "((ll_read_success_hinst inst)\<Down>R) = empty"
  "((ll_read_corrupt_hinst inst)\<Down>NE) = empty"
  "((ll_read_corrupt_hinst inst)\<Down>R) = empty"
  "((ll_read_corrupt_hinst inst)\<Down>NE) = empty"
  "((ll_read_corrupt_hinst inst)\<Down>R) = empty"
  by(auto simp add: project_defs unfold_monad ll_read_defs ll_read_hinst_defs split_if prod_case_beta)

lemma restart_mangle_sv_empty:
  "restart_mangle_sv\<Down>NN = empty"
  "restart_mangle_sv\<Down>NE = empty"
  apply(auto simp add: restart_mangle_sv_def unfold_monad choose_def getters_setters 
    modify_def put_def project_defs intro!: ext)
  done

(* Need explicit sort constraints here, otherwise the proof fails to complete with
    a "pending sort hypothesis" error *)
lemma ll_read_simps'': 
  "((ll_read_hinst inst) :: ('c :: contents_cl htable2, 'sv, 'c)abs1_monad)\<Down>NE = 
  (ll_read_failure_hinst inst)\<Down>NE"
  apply(simp add: ll_read_hinst_def project_simps ll_read_simps' first_stage restart_mangle_sv_empty)
  apply(rule ext)
  apply(auto simp add: unfold_monad project_defs ll_read_hinst_defs split: split_if_asm)
  done

lemmas ll_read_simps = 
  ll_read_simps'
  ll_read_simps''

lemma write_hinst_simps:
  "((write_hinst_fail_instance inst ht)\<Down>NN) = empty"
  "((write_hinst_corrupt_restart inst ht)\<Down>NN) = empty"
  "((write_hinst_success inst ht)\<Down>NE) = empty"
  "((write_hinst_fail_instance inst ht)\<Down>R) = empty"
  "((write_hinst_corrupt_restart inst ht)\<Down>NE) = empty"
  "((write_hinst_success inst ht)\<Down>R) = empty"
  by(auto simp add: project_defs unfold_monad write_hinst_defs split_if prod_case_beta)

lemma write_hinst_no_throw:
  "doesnt_throw_raw ((write_hinst inst cnt)\<Down>NE) FailLLRead"
  "doesnt_throw_raw ((write_hinst inst cnt)\<Down>NE) FailRead"
  "doesnt_throw_raw ((write_hinst inst cnt)\<Down>NE) FailMode"
  "\<forall>v. doesnt_throw_raw ((write_hinst inst cnt)\<Down>NE) (Degraded v)"
  apply(auto simp add: doesnt_throw_raw_def brute_force)
  done

declare write_hinst_no_throw[no_throw]

lemma write_f_no_throw:
  "doesnt_throw_raw ((write_f ind inst cnt)\<Down>NE) FailLLRead"
  "doesnt_throw_raw ((write_f ind inst cnt)\<Down>NE) FailRead"
  "doesnt_throw_raw ((write_f ind inst cnt)\<Down>NE) FailMode"
  "\<forall>v. doesnt_throw_raw ((write_f ind inst cnt)\<Down>NE) (Degraded v)"
  apply(auto simp add: doesnt_throw_raw_def brute_force)
  done

declare write_f_no_throw[no_throw]

lemma write_ptr_ll_alt:
  "write_ptr_ll inst cnt =  write_ptr_ll_success inst cnt
    [+] write_ptr_ll_fail_instance inst cnt
    [+] write_ptr_ll_corrupt_restart inst cnt
    [+] empty
    [+] restart_mangle_sv
    [+] do { write_ptr_ll_success inst cnt; restart_mangle_sv }
    [+] (<try> write_ptr_ll_fail_instance inst cnt <catch> K restart_mangle_sv)
    [+] (<try> empty <catch> K restart_mangle_sv)
  "
  by(simp add: write_ptr_ll_def choice_emptyl choice_emptyr try_empty_catch)

lemma ll_read_alt:
  "ll_read ind inst =
    ll_read_any ind inst 
    [+] ll_read_failure ind inst 
    [+] ll_read_any ind inst
    [+] restart_mangle_sv
    [+] do { ll_read_any ind inst; restart_mangle_sv }
    [+] (<try> ll_read_failure ind inst <catch> K restart_mangle_sv)
    [+] do { ll_read_any ind inst; restart_mangle_sv }
  "
  apply(simp add: ll_read_def choice_absorb)
  by (smt choice_absorb choice_assoc choice_comm)

lemma ll_read_ptr_alt:
  "ll_read_ptr inst =
    ll_read_ptr_any inst 
    [+] ll_read_ptr_failure inst 
    [+] ll_read_ptr_any inst
    [+] restart_mangle_sv
    [+] do { ll_read_ptr_any inst; restart_mangle_sv }
    [+] (<try> ll_read_ptr_failure inst <catch> K restart_mangle_sv)
    [+] do { ll_read_ptr_any inst; restart_mangle_sv }
  "
  apply(simp add: ll_read_ptr_def choice_absorb)
  by (smt choice_absorb choice_assoc choice_comm)

end

