theory Abs1_Specification
  imports "../Pmm_Specification" Abs1_UpdateDefs Abs1_StartupDefs Abs1_FetchDefs
begin

definition abs1_init :: "(pmm_vol_mem \<times> 'c :: contents_cl abs1_state)set" where
  "abs1_init \<equiv> {(sv, sp). (\<forall>inst.
    log_state_by_inst inst sp = EcOK \<longrightarrow> (
        (abs1_state.ptr1_state sp = IUnwr \<longrightarrow> 
            ptr_hashes2 (hash_by_inst inst sp) Primary \<noteq> abs1_state.ptr1 sp)
        \<and> (abs1_state.ptr2_state sp = IUnwr \<longrightarrow> 
            ptr_hashes2 (hash_by_inst inst sp) Secondary \<noteq> abs1_state.ptr2 sp)
    ))
    \<and> (\<forall>ind inst. size (memory sp ind inst) \<le> capacity (Public ind))
  }"

record 'c abs1_obs_state =
  hash1_state :: ec_state
  hash2_state :: ec_state
  hash1 :: "('c htable2) option"
  hash2 :: "('c htable2) option"

  ptr1 :: "pub_indx set"
  ptr1_state :: hw_state
  ptr2 :: "pub_indx set"
  ptr2_state :: hw_state

  memory :: "pub_indx \<Rightarrow> INST \<Rightarrow> 'c"
  hw_state :: "pub_indx \<Rightarrow> INST \<Rightarrow> hw_state"

definition abs1_trans 
  :: "((pmm_vol_mem \<times> ('c :: contents_cl) abs1_state) \<times> (pmm_vol_mem \<times> 'c abs1_state))set" where
  "abs1_trans \<equiv> \<Union>upd_f ind. set_fun_into_rel (
    ((try_rec_tryR (Abs1_UpdateDefs.update upd_f) Abs1_StartupDefs.startup)\<Down>SN)
    [+] ((try_rec_tryR (Abs1_FetchDefs.fetch ind) Abs1_StartupDefs.startup)\<Down>SN)
    [+] ((try_rec_tryR 
        (restart_mangle_sv :: (unit, pmm_vol_mem, 'c)abs1_monad)
        Abs1_StartupDefs.startup)\<Down>SN)
  )"

fun abs1_obs where
  "abs1_obs (sv, sp) = (sv,
    \<lparr>
        abs1_obs_state.hash1_state = abs1_state.hash1_state sp
        , abs1_obs_state.hash2_state = abs1_state.hash2_state sp
        , abs1_obs_state.hash1 = (if abs1_state.hash1_state sp \<noteq> EcOK then None 
            else Some (abs1_state.hash1 sp))
        , abs1_obs_state.hash2 = (if abs1_state.hash2_state sp \<noteq> EcOK then None 
            else Some (abs1_state.hash2 sp))
        , abs1_obs_state.ptr1 = abs1_state.ptr1 sp
        , abs1_obs_state.ptr1_state = abs1_state.ptr1_state sp
        , abs1_obs_state.ptr2 = abs1_state.ptr2 sp
        , abs1_obs_state.ptr2_state = abs1_state.ptr2_state sp
        , abs1_obs_state.memory = abs1_state.memory sp
        , abs1_obs_state.hw_state = abs1_state.hw_state sp
    \<rparr>
  )"

definition abs1_ts 
  :: "(pmm_vol_mem \<times> 'c :: contents_cl abs1_state)TS" where
  "abs1_ts \<equiv> \<lparr> 
    init = abs1_init, 
    init_trans = set_fun_into_rel 
        ((rec_tryR Abs1_StartupDefs.startup :: (unit, pmm_vol_mem, 'c)abs1_monad)\<Down>SN), 
    trans = abs1_trans 
  \<rparr>"

definition abs1_spec where
  "abs1_spec \<equiv> TS.extend abs1_ts (spec.fields abs1_obs)"

end