theory Abs1_UpdateDefs
  imports Abs1_CommonDefs
begin

definition write_secondary
  :: "(pub_indx \<rightharpoonup> 'c) \<Rightarrow> pub_indx \<Rightarrow> (unit, pmm_vol_mem, 'c :: contents_cl)abs1_monad" 
  where 
  write_secondary_def[monad_def]:
  "write_secondary upd_f pind \<equiv> do {
    write_instance pind Secondary ((the o upd_f) pind);
    add_to_updated pind
  }"

definition check_arrow_SEq
  :: "pub_indx \<Rightarrow> (bool, pmm_vol_mem, 'c :: contents_cl)abs1_monad"
  where check_arrow_SEq_def[monad_def]:
  "check_arrow_SEq ind \<equiv> do {
    dir \<leftarrow> get_sync_direction ind;
    return (dir = SEq)
  }"

definition sync_if_not_SEq
  :: "INST \<Rightarrow> INST \<Rightarrow> pub_indx \<Rightarrow> (unit, pmm_vol_mem, 'c :: contents_cl)abs1_monad"
  where sync_if_not_SEq_def[monad_def]:
  "sync_if_not_SEq to from ind \<equiv> do {
    is_Eq \<leftarrow> check_arrow_SEq ind;
    if is_Eq
    then return ()
    else just_sync_silence_deg to from ind
  }"

definition rollback 
  :: "(unit, pmm_vol_mem, 'c :: contents_cl)abs1_monad" where
  rollback_def[monad_def]:
  "rollback \<equiv> do {
    updated_s \<leftarrow> get_updated;
    updated \<leftarrow> chooseN (order_set updated_s);
    mapM' (sync_if_not_SEq Secondary Primary) updated;
    set_updated {};
    throw (Degraded (EB False))
  }"

definition pre_commit
  :: "(pub_indx \<rightharpoonup> 'c) \<Rightarrow> (unit, pmm_vol_mem, 'c :: contents_cl)abs1_monad" where
  pre_commit_def[monad_def]:
  "pre_commit upd_f \<equiv> do {
    set_updated {};
    ord \<leftarrow> chooseN (order_set (dom upd_f));
    <try>
        mapM' (write_secondary upd_f) ord
    <catch> (\<lambda>e. case e of
        Degraded _ \<Rightarrow> rollback
        | _ \<Rightarrow> throw e)
  }"

definition do_commit
  :: "(unit, pmm_vol_mem, 'c :: contents_cl)abs1_monad" where
  do_commit_def[monad_def]:
  "do_commit \<equiv> do {
    pinds \<leftarrow> get_updated;
    <try>
        set_ptr pinds
    <catch> (\<lambda>e. case e of
        Degraded v \<Rightarrow>
            if v = EB True
            then return ()
            else rollback
        | _ \<Rightarrow> throw e
    )
  }
  "

definition sync_if_not_SEq_remove_from_ptr
  where sync_if_not_SEq_remove_from_ptr_def[monad_def]:
  "sync_if_not_SEq_remove_from_ptr to from ind \<equiv> do {
    is_Eq \<leftarrow> check_arrow_SEq ind;
    if is_Eq
    then remove_from_ptr_silence_deg ind
    else sync_and_remove_from_ptr_silence_deg to from ind
  }"

definition rollforward where
  rollforward_def[monad_def]:
  "rollforward \<equiv> do {
    updated_s \<leftarrow> get_updated;
    pinds \<leftarrow> chooseN (order_set updated_s);
    mapM' (sync_if_not_SEq_remove_from_ptr Primary Secondary) pinds;
    set_updated {}
  }"

definition update :: "(pub_indx \<rightharpoonup> 'c) \<Rightarrow> (unit, pmm_vol_mem, 'c :: contents_cl)abs1_monad" where
  update_def[monad_def]:
  "update upd_f \<equiv> do {
    throw_mode_error (EB False);
    check_sizes upd_f;
    pre_commit upd_f;
    do_commit;
    rollforward;
    throw_mode_error (EB True)
  }"

end