theory HTable2
imports "../PmmDefs"
begin

datatype 'a htable2 = HTable2 "pub_indx \<times> INST \<Rightarrow> 'a hash" "INST \<Rightarrow> pub_indx set"

fun update_htable2 where
  "update_htable2 ht (Admin HASH_REG) _ _ = ht"
  | "update_htable2 (HTable2 pub_h ptr_h) (Admin PTR_REG) inst ptr_set = 
        HTable2 pub_h (ptr_h (inst := ptr_set))"
  | "update_htable2 (HTable2 pub_h ptr_h) (Public pind) inst cnt = 
        HTable2 (pub_h((pind, inst) := Hash cnt)) ptr_h"

fun pub_hashes2 :: "'c htable2 \<Rightarrow> pub_indx \<times> INST \<Rightarrow> 'c hash" where
  "pub_hashes2 (HTable2 pub_ht _) = pub_ht"

fun ptr_hashes2 :: "'c htable2 \<Rightarrow> INST \<Rightarrow> pub_indx set" where
  "ptr_hashes2 (HTable2 _ ptr_ht) = ptr_ht"

definition pub_matches_htable2 :: "'c htable2 \<Rightarrow> pub_indx \<Rightarrow> INST \<Rightarrow> 'c \<Rightarrow> bool" where
  "pub_matches_htable2 ht pind inst cnt \<equiv> Hash cnt = pub_hashes2 ht (pind, inst)"

definition ptr_matches_htable2 :: "'c htable2 \<Rightarrow> INST \<Rightarrow> pub_indx set \<Rightarrow> bool" where
  "ptr_matches_htable2 ht inst ptr_set \<equiv> ptr_set = ptr_hashes2 ht inst"

fun pub_update_htable2 :: "'c htable2 \<Rightarrow> pub_indx \<Rightarrow> INST \<Rightarrow> 'c \<Rightarrow> 'c htable2" where
  "pub_update_htable2 (HTable2 pub_h ptr_h) pind inst cnt = 
        HTable2 (pub_h((pind, inst) := Hash cnt)) ptr_h"

fun ptr_update_htable2 :: "'c htable2 \<Rightarrow> INST \<Rightarrow> pub_indx set \<Rightarrow> 'c htable2" where
  "ptr_update_htable2 (HTable2 pub_h ptr_h) inst ptr_set = 
        HTable2 pub_h (ptr_h (inst := ptr_set))"

fun htable2_to_htable :: "'c htable2 \<Rightarrow> 'c :: serialization_cl htable" where
  "htable2_to_htable (HTable2 pub_h ptr_h) =
    HTable pub_h (\<lambda>inst. Hash (serialize_ptr (ptr_h inst)))"

end
