theory Abs2Defs
imports "../RMonad" "../PmmDefs" "../Inst_State" "../abs1/HTable2"
begin

record 'a abs2_state =
  hstate :: log_state
  hash :: "'a htable2"

  ptr1 :: "pub_indx set"
  ptr1_state :: hw_state
  ptr2 :: "pub_indx set"
  ptr2_state :: hw_state

  memory :: "pub_indx \<Rightarrow> INST \<Rightarrow> 'a"
  hw_state :: "pub_indx \<Rightarrow> INST \<Rightarrow> hw_state"

type_synonym ('a, 'sv, 'c)abs2_monad = "('a, 'c exceptions, 'sv, 'c abs2_state)pre_monad"

fun ptr_by_inst :: "INST \<Rightarrow> 'c abs2_state \<Rightarrow> pub_indx set" where
  "ptr_by_inst Primary = ptr1"
  | "ptr_by_inst Secondary = ptr2"

fun ptr_state_by_inst :: "INST \<Rightarrow> 'c abs2_state \<Rightarrow> hw_state" where
  "ptr_state_by_inst Primary sp = ptr1_state sp"
  | "ptr_state_by_inst Secondary sp = ptr2_state sp"

definition abs2_same_hashes :: "'c abs2_state \<Rightarrow> 'c abs2_state \<Rightarrow> bool" where
  "abs2_same_hashes sp sp' \<equiv>
    hstate sp = hstate sp'
    \<and> hash sp = hash sp'
  "

definition abs2_same_rest :: "'c abs2_state \<Rightarrow> 'c abs2_state \<Rightarrow> bool" where
  "abs2_same_rest sp sp' \<equiv>
            ptr1 sp' = ptr1 sp
            \<and> ptr2 sp' = ptr2 sp
            \<and> ptr1_state sp' = ptr1_state sp
            \<and> ptr2_state sp' = ptr2_state sp
            \<and> memory sp' = memory sp
            \<and> hw_state sp' = hw_state sp
  "

definition abs2_doesnt_touch_hashes :: "('a \<times> 'b abs2_state \<Rightarrow> ('c \<times> 'a \<times> 'b abs2_state) set) \<Rightarrow> bool"
  where
  "abs2_doesnt_touch_hashes m \<equiv> \<forall>sv sp v sv' sp'.
    (v, sv', sp') \<in> m (sv, sp) \<longrightarrow> abs2_same_hashes sp sp'"

definition abs2_doesnt_touch_rest :: "('a \<times> 'b abs2_state \<Rightarrow> ('c \<times> 'a \<times> 'b abs2_state) set) \<Rightarrow> bool"
  where
  "abs2_doesnt_touch_rest m \<equiv> \<forall>sv sp v sv' sp'.
    (v, sv', sp') \<in> m (sv, sp) \<longrightarrow> abs2_same_rest sp sp'"

end
