theory Abs2_Lemmas
imports "../Projections" "../Pmm_Tacs" "../HoareLogic" "../Pmm_Hoare" "../Pmm_Refinement"
  "../Pmm_Lemmas"
  Abs2_CommonDefs Abs2_StartupDefs Abs2_FetchDefs
begin

lemmas brute_force =
  unfold_monad
  project_defs
  Abs2_LLInterface.ll_read_defs
  Abs2_LLInterface.ll_read_ptr_defs
  Abs2_LLInterface.write_f_defs
  Abs2_LLInterface.write_ptr_ll_defs
  restart_mangle_sv_raw
  getters_setters
  set_degraded_h_def

lemma write_hashes_simps:
  "((write_hashes_success ht)\<Down>R)  = empty"
  "((write_hashes_degrade ht)\<Down>R)  = empty"
  "((write_hashes_degrade_write ht)\<Down>R)   = empty"
  "((write_hashes_fail ht)\<Down>R)   = empty"
  "((write_hashes_success ht)\<Down>NE)  = empty"
  "((write_hashes_degrade ht)\<Down>NN)  = empty"
  "((write_hashes_degrade_write ht)\<Down>NN)   = empty"
  "((write_hashes_fail ht)\<Down>NN)   = empty"
  by(auto simp add: write_hashes_defs project_defs unfold_monad intro!: ext)

lemma restart_mangle_sv_simps:
  "bind restart_mangle_sv m = restart_mangle_sv"
  "try_catch restart_mangle_sv m' = restart_mangle_sv"
  apply(rule_tac[!] ext, rule_tac[!] Set.equalityI)
  apply(clarsimp_all simp add: restart_mangle_sv_def getters_setters
    modify_def put_def
    choose_def unfold_monad split: option.split sum.split)
  done

lemma[no_throw]:
  "doesnt_throw_raw (Abs2_CommonDefs.get_hashes\<Down>NE) InvalidInput"
  "doesnt_throw_raw (Abs2_CommonDefs.get_hashes\<Down>NE) FailLLRead"
  "doesnt_throw_raw (Abs2_CommonDefs.get_hashes\<Down>NE) FailRead"
  "doesnt_throw_raw (Abs2_CommonDefs.get_hashes\<Down>NE) FailWrite"
  "doesnt_throw_raw (Abs2_CommonDefs.get_hashes\<Down>NE) StartedExc"
  by(auto simp add: doesnt_throw_def doesnt_throw_raw_def Abs2_CommonDefs.get_hashes_defs brute_force)

lemma[no_throw]:
  "doesnt_throw_raw (Abs2_CommonDefs.get_hashes_degrade\<Down>NE) FailMode"
  "doesnt_throw_raw (Abs2_CommonDefs.get_hashes_degrade\<Down>NE) InvalidInput"
  by(auto simp add: doesnt_throw_def doesnt_throw_raw_def Abs2_CommonDefs.get_hashes_defs brute_force)

lemma[no_throw]:
  "doesnt_throw_raw ((Abs2_CommonDefs.write_hashes_degrade_write ht)\<Down>NE) FailMode"
  "doesnt_throw_raw ((Abs2_CommonDefs.write_hashes_degrade_write ht)\<Down>NE) InvalidInput"
  "doesnt_throw_raw ((Abs2_CommonDefs.write_hashes_degrade ht)\<Down>NE) FailMode"
  "doesnt_throw_raw ((Abs2_CommonDefs.write_hashes_degrade ht)\<Down>NE) InvalidInput"
  by(auto simp add: doesnt_throw_def doesnt_throw_raw_def Abs2_CommonDefs.write_hashes_defs brute_force)

lemma[no_throw]:
  "doesnt_throw_raw ((write_ptr_ll inst cnt)\<Down>NE) InvalidInput"
  "doesnt_throw_raw ((write_ptr_ll inst cnt)\<Down>NE) FailLLRead"
  "doesnt_throw_raw ((write_ptr_ll inst cnt)\<Down>NE) FailRead"
  "doesnt_throw_raw ((write_ptr_ll inst cnt)\<Down>NE) FailMode"
  "\<forall>v. doesnt_throw_raw ((write_ptr_ll inst cnt)\<Down>NE) InvalidInput"
  "\<forall>v. doesnt_throw_raw ((write_ptr_ll inst cnt)\<Down>NE) (Degraded v)"
  "\<forall>v. doesnt_throw_raw ((write_ptr_ll inst cnt)\<Down>NE) StartedExc"
  apply(auto simp add: doesnt_throw_raw_def)
  apply(auto simp add: write_ptr_ll_defs choice_def project_defs restart_mangle_sv_def unfold_monad)
  done

lemma ll_read_ptr_no_throw[no_throw]:
  "doesnt_throw_raw ((ll_read_ptr inst)\<Down>NE) InvalidInput"
  "doesnt_throw_raw ((ll_read_ptr inst)\<Down>NE) FailRead"
  "doesnt_throw_raw ((ll_read_ptr inst)\<Down>NE) FailWrite"
  "doesnt_throw_raw ((ll_read_ptr inst)\<Down>NE) FailMode"
  "\<forall>v. doesnt_throw_raw ((ll_read_ptr inst)\<Down>NE) (Degraded v)"
  "doesnt_throw_raw ((ll_read_ptr inst)\<Down>NE) StartedExc"
  by(auto simp add: brute_force doesnt_throw_raw_def)


lemma[no_throw]:
  "doesnt_throw_raw (Abs2_CommonDefs.get_hashes_DegradedH\<Down>NE) InvalidInput"
  "doesnt_throw_raw (Abs2_CommonDefs.get_hashes_DegradedH\<Down>NE) FailRead"
  "doesnt_throw_raw (Abs2_CommonDefs.get_hashes_DegradedH\<Down>NE) FailLLRead"
  "doesnt_throw_raw (Abs2_CommonDefs.get_hashes_DegradedH\<Down>NE) FailWrite"
  "doesnt_throw_raw (Abs2_CommonDefs.get_hashes_DegradedH\<Down>NE) StartedExc"
  "\<forall>v. doesnt_throw_raw (Abs2_CommonDefs.get_hashes_DegradedH\<Down>NE) (Degraded v)"
  by(auto simp add: Abs2_CommonDefs.get_hashes_DegradedH_defs brute_force doesnt_throw_raw_def)

lemma[no_throw]:
  "doesnt_throw_raw ((Abs2_CommonDefs.write_hashes ht)\<Down>NE) InvalidInput"
  "doesnt_throw_raw ((Abs2_CommonDefs.write_hashes ht)\<Down>NE) FailRead"
  "doesnt_throw_raw ((Abs2_CommonDefs.write_hashes ht)\<Down>NE) FailLLRead"
  "doesnt_throw_raw ((Abs2_CommonDefs.write_hashes ht)\<Down>NE) FailWrite"
  "doesnt_throw_raw ((Abs2_CommonDefs.write_hashes ht)\<Down>NE) StartedExc"
  by(auto simp add: Abs2_CommonDefs.write_hashes_defs brute_force doesnt_throw_raw_def)

lemma[no_throw]:
  "doesnt_throw_raw ((write_ptr_instance inst cnt)\<Down>NE) InvalidInput"
  "doesnt_throw_raw ((write_ptr_instance inst cnt)\<Down>NE) FailLLRead"
  "doesnt_throw_raw ((write_ptr_instance inst cnt)\<Down>NE) FailRead"
  "doesnt_throw_raw ((write_ptr_instance inst cnt)\<Down>NE) FailWrite"
  "doesnt_throw_raw ((write_ptr_instance inst cnt)\<Down>NE) StartedExc"
  apply(auto simp add: doesnt_throw_raw_def)
  apply(simp_all only: write_ptr_instance_def Let_def)
  apply(simp_all add: first_stage vol_ops_project_simps if_choice cong: exceptions.case_cong if_cong)
  apply(simp_all only: choice_def Un_iff, safe)
  apply(simp_all only: write_ptr_instance_def update_ptr_instance_hash_def Let_def)
  apply(simp_all add: first_stage vol_ops_project_simps if_choice cong: exceptions.case_cong if_cong)
  apply(simp_all only: choice_def Un_iff, safe)
  apply(simp_all only: read_ptr_DegradedH_def)
  apply(simp_all add: first_stage vol_ops_project_simps if_choice cong: exceptions.case_cong if_cong)
  apply(simp_all only: choice_def Un_iff, safe)
  using [[simp_depth_limit=1]]
  apply(clarsimp_all simp add: 
    vol_ops_defs
    write_hashes_defs get_hashes_all_defs choose_def chooseN_def modify_def put_def
    restart_mangle_sv_def brute_force split: split_if_asm exceptions.split_asm)
  apply (metis exceptions.exhaust)+
  done

lemma read_ptr_no_throw[no_throw]:
  "doesnt_throw (read_ptr inst) InvalidInput"
  "doesnt_throw (read_ptr inst) FailWrite"
  "\<forall>v. doesnt_throw (read_ptr inst) FailLLRead"
  "doesnt_throw (read_ptr inst) StartedExc"
  apply(auto simp add: doesnt_throw_def doesnt_throw_raw_def)
  apply(simp_all only: read_ptr_def Let_def)
  apply(simp_all add: first_stage if_choice vol_ops_project_simps cong: if_cong exceptions.case_cong)
  apply(simp_all only: choice_def Un_iff, safe)
  apply(clarsimp_all simp add: 
    write_hashes_defs get_hashes_all_defs choose_def chooseN_def modify_def put_def
    vol_ops_defs
    restart_mangle_sv_def brute_force split: split_if_asm exceptions.split_asm)
  apply (metis exceptions.exhaust)+
  done

lemma read_ptr_no_throw'[no_throw]:
  "doesnt_throw_raw ((read_ptr inst)\<Down>NE) InvalidInput"
  "doesnt_throw_raw ((read_ptr inst)\<Down>NE) FailWrite"
  "\<forall>v. doesnt_throw_raw ((read_ptr inst)\<Down>NE) FailLLRead"
  "doesnt_throw_raw ((read_ptr inst)\<Down>NE) StartedExc"
  by(simp_all add: read_ptr_no_throw[simplified doesnt_throw_def])

lemma read_ptr_DegradedH_no_throw[no_throw]:
  "doesnt_throw_raw ((read_ptr_DegradedH inst)\<Down>NE) InvalidInput"
  "doesnt_throw_raw ((read_ptr_DegradedH inst)\<Down>NE) FailWrite"
  "\<forall>v. doesnt_throw_raw ((read_ptr_DegradedH inst)\<Down>NE) FailLLRead"
  "doesnt_throw_raw ((read_ptr_DegradedH inst)\<Down>NE) StartedExc"
  apply(auto simp add: doesnt_throw_def doesnt_throw_raw_def)
  apply(simp_all only: read_ptr_DegradedH_def Let_def)
  apply(simp_all add: first_stage if_choice vol_ops_project_simps cong: if_cong exceptions.case_cong)
  apply(simp_all only: choice_def Un_iff, safe)
  apply(clarsimp_all simp add: 
    write_hashes_defs get_hashes_DegradedH_defs
    choose_def chooseN_def modify_def put_def vol_ops_defs
    restart_mangle_sv_def brute_force split: split_if_asm)
  done

lemma not_BothGone_le_OneGone:
  "st \<noteq> LDead
       \<Longrightarrow> LDegraded \<le> st"
  by(case_tac "st", auto)

lemmas hstate_simps = 
  min_is_EcOK
  less_eq_EcDead
  less_eq_EcUnwr
  EcBad_less_eq
  EcOK_less_eq
  less_eq_EcBad
  exhaust_EcOK
  exhaust_EcUnwr
  not_BothGone_le_OneGone

definition get_hashes_NE :: "('c exceptions, pmm_vol_mem \<times> 'c :: contents_cl abs2_state)nds_monad"
  where
  "get_hashes_NE \<equiv> ((get_hashes_fail [+] get_hashes_degrade) :: ('c htable2, pmm_vol_mem, 'c)abs2_monad)\<Down>NE"

definition get_hashes_NN :: "('c htable2, pmm_vol_mem \<times> 'c :: contents_cl abs2_state)nds_monad"
  where
  "get_hashes_NN \<equiv> (get_hashes_success :: ('c htable2, pmm_vol_mem, 'c)abs2_monad)\<Down>NN"

definition get_hashes_DegradedH_NN ::
  "('c htable2, pmm_vol_mem \<times> 'c :: contents_cl abs2_state)nds_monad"
  where
  "get_hashes_DegradedH_NN \<equiv> ((get_hashes_success [+] get_hashes_degrade')
    :: ('c htable2, pmm_vol_mem, 'c)abs2_monad)\<Down>NN"


definition get_hashes_DegradedH_NE ::
  "('c exceptions, pmm_vol_mem \<times> 'c :: contents_cl abs2_state)nds_monad"
  where
  "get_hashes_DegradedH_NE \<equiv> (get_hashes_fail  :: ('c htable2, pmm_vol_mem, 'c)abs2_monad)\<Down>NE"

lemma get_hashes_proj_simps:
  "(get_hashes)\<Down>NE = get_hashes_NE"
  "(get_hashes)\<Down>NN = get_hashes_NN"
  "(get_hashes_DegradedH)\<Down>NN = get_hashes_DegradedH_NN"
  "(get_hashes_DegradedH)\<Down>NE = get_hashes_DegradedH_NE"
  by(auto simp add: get_hashes_defs get_hashes_DegradedH_defs
    brute_force get_hashes_NE_def get_hashes_NN_def get_hashes_DegradedH_NN_def
    get_hashes_DegradedH_NE_def
    intro!: ext)

end