theory Abs2_Ref
imports "../Composition" Abs2_StartupDefs "../abs1/Abs1_StartupDefs" "../Pmm_Refinement"
  "../abs1/Abs1_Startup_Lemmas"  "../Pmm_Tacs" "../abs1/Abs1_LLInterface_Lemmas"
  "Abs2_Lemmas"
  "Abs2_LLInterface_Lemmas"
  "Abs2_UpdateDefs" "Abs2_FetchDefs"
  "../abs1/Abs1_UpdateDefs" "../abs1/Abs1_FetchDefs"
  "../Misc_Lemmas"
begin

lemmas brute_force =
  unfold_monad
  project_defs
  Abs1_LLInterface.ll_read_defs
  Abs1_LLInterface.ll_read_hinst_defs
  Abs1_LLInterface.ll_read_ptr_defs
  Abs1_LLInterface.write_f_defs
  Abs1_LLInterface.write_hinst_defs
  Abs1_LLInterface.write_ptr_ll_defs
  Abs2_LLInterface.ll_read_defs
  Abs2_LLInterface.ll_read_ptr_defs
  Abs2_LLInterface.write_f_defs
  Abs2_LLInterface.write_ptr_ll_defs
  restart_mangle_sv_raw
  getters_setters
  set_degraded_h_def
  force_same_and_def

definition abs2_abs1_strel_core ::"(('sv \<times> 'c :: contents_cl abs2_state) \<times> ('sv \<times> 'c abs1_state))set" 
  where
  "abs2_abs1_strel_core \<equiv> {((sva, spa), (svc, spc)). 
    sva = svc
    \<and> Abs2Defs.hw_state spa = Abs1Defs.hw_state spc
    \<and> Abs2Defs.memory spa = Abs1Defs.memory spc
    \<and> Abs2Defs.ptr1 spa = Abs1Defs.ptr1 spc
    \<and> Abs2Defs.ptr1_state spa = Abs1Defs.ptr1_state spc
    \<and> Abs2Defs.ptr2 spa = Abs1Defs.ptr2 spc
    \<and> Abs2Defs.ptr2_state spa = Abs1Defs.ptr2_state spc

    \<and> hstate spa = combine_ec_states (hash1_state spc) (hash2_state spc)
    \<and> (hash1_state spc = EcOK \<longrightarrow> hash1 spc = hash spa)
    \<and> (hash2_state spc = EcOK \<longrightarrow> hash2 spc = hash spa)
    \<and> (\<forall>ind inst. size (abs1_state.memory spc ind inst) \<le> capacity (Public ind))
  }"

definition abs2_abs1_strel ::
  "(('sv \<times> 'c :: contents_cl abs2_state) \<times> ('sv \<times> 'c abs1_state))set" 
  where
  "abs2_abs1_strel \<equiv> abs2_abs1_strel_core"

lemmas abs2_abs1_strel_defs =
  abs2_abs1_strel_def
  abs2_abs1_strel_core_def

definition min_one_good_hash :: "('sv \<times> 'c abs1_state) set" where
  "min_one_good_hash \<equiv> {(sv, spc). hash1_state spc = EcOK \<or> hash2_state spc = EcOK}"

lemma restart_mangle_sv_refines_itself:
  "sim abs2_abs1_strel
    restart_mangle_sv
    restart_mangle_sv
  "
  apply(auto simp only: sim_def sim_ext_def)
  apply(auto simp add: abs2_abs1_strel_defs brute_force simN_wpc_def simS_wpc_def
        split: split_if_asm
        intro!: ext
  )
  done

lemma fun_upd_second_same:
  "(fun_upd_second f x y r = fun_upd_second f x y r') = (r = r')"
  by (metis (lifting) fun_upd_same)

lemma write_f_ref:
  "sim abs2_abs1_strel
    (Abs2_LLInterface.write_f ind inst cnt)
    (Abs1_LLInterface.write_f ind inst cnt)
  "
  apply(auto simp only: Abs1_LLInterface.write_f_def Abs2_LLInterface.write_f_def K_def
    intro!: restart_mangle_sv_refines_itself sims_all_intros)
  apply(tactic {* distinct_subgoals_tac *})
  apply(auto simp only: sim_def sim_ext_def simN_wpc_def simS_wpc_def)
  apply(clarsimp_all simp add: sim_def sim_ext_def simN_wpc_def simS_wpc_def abs2_abs1_strel_defs
    brute_force force_same_and_def fun_upd_second_same
  )
  by (smt combine_ec_states.simps(10) combine_ec_states.simps(11) combine_ec_states.simps(12)
    combine_ec_states.simps(13) combine_ec_states.simps(14) combine_ec_states.simps(15)
    combine_ec_states.simps(16) combine_ec_states.simps(8) combine_ec_states.simps(9) exhaust_EcOK)+

lemma combine_ec_states_rev_cases:
  "(combine_ec_states x y = LDead) = (x \<noteq> EcOK \<and> y \<noteq> EcOK)"
  by(case_tac x, case_tac[!] y, simp_all)

lemma write_ptr_ll_ref:
  "sim abs2_abs1_strel
    (Abs2_LLInterface.write_ptr_ll inst cnt)
    (Abs1_LLInterface.write_ptr_ll inst cnt)
  "
  apply(auto simp only: Abs1_LLInterface.write_ptr_ll_def Abs2_LLInterface.write_ptr_ll_def
    K_def intro!: restart_mangle_sv_refines_itself sims_all_intros)
  apply(tactic {* distinct_subgoals_tac *})
  apply(auto simp only: sim_def sim_ext_def simN_wpc_def simS_wpc_def)
  apply(clarsimp_all simp add: sim_def sim_ext_def simN_wpc_def simS_wpc_def abs2_abs1_strel_defs
    brute_force force_same_and_def 
  )  
  apply(case_tac[!] inst, clarsimp_all simp add: combine_ec_states_rev_cases)
  done

lemma ll_read_ref:
  "sim abs2_abs1_strel
    (Abs2_LLInterface.ll_read ind inst)
    (Abs1_LLInterface.ll_read ind inst)
  "
  apply(auto simp only: Abs1_LLInterface.ll_read_def Abs2_LLInterface.ll_read_def
    K_def intro!: restart_mangle_sv_refines_itself sims_all_intros)
  apply(tactic {* distinct_subgoals_tac *})
  apply(auto simp only: sim_def sim_ext_def simN_wpc_def simS_wpc_def)
  apply(clarsimp_all simp add: sim_def sim_ext_def simN_wpc_def simS_wpc_def abs2_abs1_strel_defs
    brute_force force_same_and_def combine_ec_states_rev_cases
  )
  by metis
  
lemma ll_read_ptr_ref[ref_thm]:
  "sim abs2_abs1_strel
    (Abs2_LLInterface.ll_read_ptr inst)
    (Abs1_LLInterface.ll_read_ptr inst)
  "
  apply(auto simp only: sim_def sim_ext_def
    Abs2_LLInterface.ll_read_ptr_def
    Abs1_LLInterface.ll_read_ptr_def
    first_stage restart_mangle_sv_empty
    intro!: Int_greatest simN_wpc_choice_lockstep simS_wpc_choice_lockstep
    del: subsetI)
  apply(clarsimp_all simp add: abs2_abs1_strel_defs simN_wpc_def simS_wpc_def
    Abs2_LLInterface.ll_read_ptr_defs hw_state_simps
    brute_force)
  apply(case_tac[!] inst, clarsimp_all)
  apply(case_tac[!] "hash1_state ba", simp_all)
  apply(case_tac[!] "hash2_state ba", simp_all)
  done

lemma write_hashes_ref_NN: " sim_normN_ext (abs2_abs1_strel \<inter> UNIV \<times> min_one_good_hash)
  (Abs2_CommonDefs.write_hashes ht)
  (Abs1_CommonDefs.write_hashes ht)
  (force_same_and abs2_abs1_strel)"
  apply(auto simp only: sim_normN_ext_def simN_wpc_def)
  apply(rename_tac sva spa svc spc svc' spc')
  apply(simp only: Abs1_CommonDefs.write_hashes_def)
  apply(simp only: first_stage)
  apply(simp only: write_hinst_def)
  apply(simp only: first_stage write_hinst_simps restart_mangle_sv_empty)
  apply(clarsimp simp add: brute_force split: split_if_asm)
  apply(clarsimp simp add: Abs2_CommonDefs.write_hashes_defs
    first_stage restart_mangle_sv_empty abs2_abs1_strel_defs brute_force
     ec_state_simps min_one_good_hash_def
  )
  by (metis combine_ec_states.simps(1) combine_ec_states.simps(2) combine_ec_states.simps(3))

lemma write_hashes_ref_NE: "sim_normE_ext (abs2_abs1_strel \<inter> UNIV \<times> min_one_good_hash)
  (Abs2_CommonDefs.write_hashes ht)
  (Abs1_CommonDefs.write_hashes ht)
  (force_same_and abs2_abs1_strel)"
  apply(auto simp only: sim_normE_ext_def simN_wpc_def)
  apply(rename_tac sva spa svc spc vc svc' spc')
  apply(simp only: Abs1_CommonDefs.write_hashes_def)
  apply(simp only: first_stage)
  apply(simp_all add: first_stage cong: if_cong exceptions.case_cong)
  apply(simp_all only: choice_def Un_iff, safe)
  apply(simp_all only: write_hinst_def get_hash_table_or_fail_def get_hash_table_def)
  apply(simp_all add: first_stage if_choice vol_ops_project_simps cong: if_cong exceptions.case_cong)
  apply(simp_all only: choice_def Un_iff, safe)
  apply(tactic {* distinct_subgoals_tac *})
  apply(clarsimp_all simp add: brute_force vol_ops_defs
    is_good_hash_def
    min_one_good_hash_def
    split: split_if_asm)
  apply(iterative_simp)+
  using [[simp_depth_limit=2]]
  apply(clarsimp_all simp add: Abs2_CommonDefs.write_hashes_defs 
    first_stage
    restart_mangle_sv_empty abs2_abs1_strel_defs brute_force ec_state_simps
     min_one_good_hash_def
    min_def
    HOL.conj_disj_distribR ex_disj_distrib conj_assoc
    split: split_if_asm
  )
  apply(case_tac[!] "hash1_state spc", simp_all)
  apply(case_tac[!] "hash2_state spc", simp_all)
  done
  
lemma write_hashes_ref_N[ref_thm]:
"sim_norm_ext (abs2_abs1_strel \<inter> UNIV \<times> min_one_good_hash)
  (Abs2_CommonDefs.write_hashes ht)
  (Abs1_CommonDefs.write_hashes ht)
  (force_same_and abs2_abs1_strel)
  (force_same_and abs2_abs1_strel)
  "
  by(auto simp only: sim_norm_ext_decompose intro: write_hashes_ref_NN write_hashes_ref_NE)

lemma get_hashes_ref_NN: "sim_normN_ext abs2_abs1_strel
  (Abs2_CommonDefs.get_hashes)
  (Abs1_CommonDefs.get_hashes)
  (force_same_and (abs2_abs1_strel \<inter> UNIV \<times> min_one_good_hash))"
  apply(auto simp only: sim_normN_ext_def simN_wpc_def force_same_and_def)
  apply(rename_tac sva spa svc spc vc svc' spc')
  apply(simp only: Abs1_CommonDefs.get_hashes_def)
  apply(simp_all add: first_stage if_choice vol_ops_project_simps cong: if_cong exceptions.case_cong)
  apply(simp_all only: choice_def Un_iff, safe)
  apply(simp_all only: get_hash_table_or_fail_def)
  apply(simp_all add: first_stage if_choice vol_ops_project_simps cong: if_cong exceptions.case_cong)
  apply(simp_all only: get_hash_table_raw)
  apply(simp_all only: write_hinst_def first_stage)
  apply(simp_all only: first_stage write_hinst_simps restart_mangle_sv_empty)
  apply(clarsimp_all simp add: brute_force get_hash_table_NN_def get_hash_table_NE_def
    min_one_good_hash_def
    split:  split_if_asm exceptions.split_asm)
  apply(clarsimp_all simp add: brute_force Abs2_CommonDefs.get_hashes_defs
    first_stage restart_mangle_sv_empty abs2_abs1_strel_defs
    ec_state_simps
  )
  apply(case_tac[!] "hash1_state spc", simp_all)
  apply(case_tac[!] "hash2_state spc", simp_all)
  done
  
lemma get_hashes_ref_NE: "sim_normE_ext abs2_abs1_strel
  (Abs2_CommonDefs.get_hashes)
  (Abs1_CommonDefs.get_hashes)
  (force_same_and abs2_abs1_strel)"
  apply(auto simp only: sim_normE_ext_def simN_wpc_def)
  apply(rename_tac sva spa svc spc e svc' spc')
  apply(simp only: Abs1_CommonDefs.get_hashes_def first_stage set_degraded_h_project_simps
    set_failed_project_simps)
  apply(simp_all add: first_stage if_choice vol_ops_project_simps cong: if_cong exceptions.case_cong)
  apply(simp_all only: choice_def Un_iff, safe)
  apply(simp_all only: get_hash_table_or_fail_def)
  apply(simp_all add: first_stage if_choice vol_ops_project_simps cong: if_cong exceptions.case_cong)
  apply(simp_all only: get_hash_table_raw)
  apply(simp_all only: write_hinst_def)
  apply(simp_all add: first_stage if_choice vol_ops_project_simps restart_mangle_sv_empty
    cong: if_cong exceptions.case_cong)
  apply(auto simp add: brute_force get_hash_table_NN_def get_hash_table_NE_def
    vol_ops_defs
    split:  split_if_asm exceptions.split_asm)
  apply(tactic {* distinct_subgoals_tac *})
  apply(simp_all add: ec_state_simps)
  apply(simp_all add: brute_force Abs2_CommonDefs.get_hashes_defs
    first_stage restart_mangle_sv_empty abs2_abs1_strel_defs force_same_and_def
    vol_ops_defs
    min_def
    conj_assoc
  )
  apply(case_tac[!] "hash1_state spc", simp_all)
  apply(case_tac[!] "hash2_state spc", simp_all)
  done

lemma get_hashes_ref_N[ref_thm]:
  "sim_norm_ext abs2_abs1_strel
    Abs2_CommonDefs.get_hashes Abs1_CommonDefs.get_hashes
    (force_same_and (abs2_abs1_strel \<inter> UNIV \<times> min_one_good_hash))
    (force_same_and abs2_abs1_strel)
  "
  by(auto simp only: sim_norm_ext_decompose sim_normN_def sim_normE_def
    intro!: get_hashes_ref_NN get_hashes_ref_NE)

lemma combine_ec_states_simps:
  "LDead \<noteq> combine_ec_states EcOK x"
  "LDead \<noteq> combine_ec_states x EcOK"
  "combine_ec_states EcOK x \<noteq> LDead"
  "combine_ec_states x EcOK \<noteq> LDead"
  by(case_tac[!] x, simp_all)

lemma conj_imp: "(P \<and> (P \<longrightarrow> Q)) = (P \<and> Q)"
  by(blast)

lemma get_hashes_DegradedH_ref_NN: "sim_normN_ext abs2_abs1_strel
  (Abs2_CommonDefs.get_hashes_DegradedH)
  (Abs1_CommonDefs.get_hashes_DegradedH)
  (force_same_and abs2_abs1_strel)
  "
  apply(auto simp only: sim_normN_ext_def simN_wpc_def)
  apply(rename_tac sva spa svc spc vc svc' spc')
  apply(simp only: Abs1_CommonDefs.get_hashes_DegradedH_def first_stage)
  apply(simp_all add: first_stage if_choice vol_ops_project_simps cong: if_cong exceptions.case_cong)
  apply(simp_all only: choice_def Un_iff, safe)
  apply(simp_all only: get_hash_table_or_fail_def)
  apply(simp_all add: first_stage if_choice vol_ops_project_simps cong: if_cong exceptions.case_cong)
  apply(simp_all only: get_hash_table_raw)
  apply(clarsimp_all simp add: brute_force get_hash_table_NN_def get_hash_table_NE_def
    min_one_good_hash_def
    split:  split_if_asm exceptions.split_asm)
  apply(iterative_simp)+
  apply(clarsimp_all simp add: brute_force Abs2_CommonDefs.get_hashes_DegradedH_defs
    min_def combine_ec_states_simps vol_ops_defs
    first_stage restart_mangle_sv_empty abs2_abs1_strel_defs
    ec_state_simps
  )
  apply(simp_all add: HOL.conj_disj_distribR HOL.conj_disj_distribL ex_disj_distrib conj_assoc)
  apply(case_tac[!] "hash1_state spc", simp_all)
  apply(case_tac[!] "hash2_state spc", simp_all)
  done

lemma get_hashes_DegradedH_ref_NE: "sim_normE_ext abs2_abs1_strel
  (Abs2_CommonDefs.get_hashes_DegradedH)
  (Abs1_CommonDefs.get_hashes_DegradedH)
  (force_same_and abs2_abs1_strel)
  "
  apply(auto simp only: sim_normE_ext_def simN_wpc_def)
  apply(rename_tac sva spa svc spc vc svc' spc')
  apply(simp only: Abs1_CommonDefs.get_hashes_DegradedH_def)
  apply(simp_all add: first_stage if_choice vol_ops_project_simps cong: if_cong exceptions.case_cong)
  apply(simp_all only: get_hash_table_or_fail_def)
  apply(simp_all add: first_stage if_choice vol_ops_project_simps cong: if_cong exceptions.case_cong)
  apply(simp_all only: get_hash_table_raw)
  apply(clarsimp_all simp add: brute_force get_hash_table_NN_def get_hash_table_NE_def
    min_one_good_hash_def vol_ops_defs
    split:  split_if_asm exceptions.split_asm)
  apply(clarsimp_all simp add: brute_force Abs2_CommonDefs.get_hashes_DegradedH_defs
    min_def
    first_stage restart_mangle_sv_empty abs2_abs1_strel_defs
    ec_state_simps vol_ops_defs
  )
  apply(iterative_simp simp add: combine_ec_states_simps)+
  apply(case_tac[!] "hash1_state spc", simp_all)
  apply(case_tac[!] "hash2_state spc", simp_all)
  done

lemma get_hashes_DegradedH_ref_N:
"sim_norm_ext abs2_abs1_strel
  (Abs2_CommonDefs.get_hashes_DegradedH)
  (Abs1_CommonDefs.get_hashes_DegradedH)
  (force_same_and abs2_abs1_strel)
  (force_same_and abs2_abs1_strel)
  "
  by(auto simp only: sim_norm_ext_decompose sim_normN_def sim_normE_def
    intro!: get_hashes_DegradedH_ref_NN get_hashes_DegradedH_ref_NE)

lemma LDegraded_le_comb:
  "(LDegraded \<le> combine_ec_states EcOK x) = True"
  "(LDegraded \<le> combine_ec_states x EcOK) = True"
  by(case_tac[!] x, simp_all add: min_def)

lemma comb_EcOK_is_LDegraded:
  "(LDegraded = combine_ec_states EcOK x) = (x \<le> EcUnwr)"
  "(combine_ec_states EcOK x = LDegraded) = (x \<le> EcUnwr)"
  by(case_tac[!] x, auto)

lemma comb_EcDead_or_EcUnwr_not_LOK:
  "LOK \<noteq> combine_ec_states EcDead x"
  "LOK \<noteq> combine_ec_states x EcDead"
  "combine_ec_states EcDead x \<noteq> LOK"
  "combine_ec_states x EcDead \<noteq> LOK"
  "LOK \<noteq> combine_ec_states EcUnwr x"
  "LOK \<noteq> combine_ec_states x EcUnwr"
  "combine_ec_states EcUnwr x \<noteq> LOK"
  "combine_ec_states x EcUnwr \<noteq> LOK"
  by(case_tac[!] x, simp_all)

lemma write_hashes_ref_R_NN:
  "sim_normN_ext (abs2_abs1_strel \<inter> UNIV \<times> min_one_good_hash)
  (\<lambda>s. ((Abs2_CommonDefs.write_hashes ht)\<Down>R) s \<guillemotright>=S (Abs2_StartupDefs.startup1))
  (\<lambda>s. ((Abs1_CommonDefs.write_hashes ht)\<Down>R) s \<guillemotright>=S (abs1_startup1'))
  (force_same_and abs2_abs1_strel)"
  apply(clarsimp simp add: sim_normN_ext_def simN_wpc_def force_same_and_def bindS_projectNN)
  apply(rename_tac sva spa svc spc svc' spc')
  apply(subst (asm) abs2_abs1_strel_def)
  apply(simp only:
    Abs1_CommonDefs.write_hashes_def abs1_startup1'_def abs1_check_hash_region'_def)
  apply(simp_all add: first_stage if_choice vol_ops_project_simps cong: if_cong exceptions.case_cong)
  apply(safe)
  apply(simp_all add: first_stage compose_project init_vars_NE)
  apply(simp_all only: get_hash_table_or_fail_def)
  apply(simp_all add: first_stage if_choice vol_ops_project_simps cong: if_cong exceptions.case_cong)
  apply(simp_all only: get_hash_table_def)
  apply(simp_all add: first_stage if_choice vol_ops_project_simps cong: if_cong exceptions.case_cong)
  apply(safe)
  apply(simp_all only: write_hinst_def)
  apply(simp_all add: first_stage if_choice vol_ops_project_simps cong: if_cong exceptions.case_cong)
  apply(safe)
  apply(tactic {* distinct_subgoals_tac *})
  using [[simp_depth_limit=3]]
  using [[simproc del: throw_simproc throw_simproc' throw_bind_simproc throw_bind_simproc']]
  using [[simproc del: Product_Type.split_beta]]
  (* TODO: simplifier bug here in the split_beta? *)
  apply(clarsimp_adj_all simp add: abs2_abs1_strel_core_def abs1_same_rest_def
    get_hash_table_def is_good_hash_def card_mode_full_upd
    brute_force vol_ops_defs
    ec_state_simps min_def min_one_good_hash_def
    split: split_if_asm
  )
  apply(tactic {* (REPEAT1 (CHANGED (TRYALL (etac @{thm disjE})))) *})
  apply(tactic {* distinct_subgoals_tac *})
  using [[simp_depth_limit=0]]
  apply(clarsimp_all simp add: check_hash_region_NN_def choice_def)
  apply(tactic {* distinct_subgoals_tac *})
  apply(clarsimp_all simp add:
    abs1_same_rest_def
    Abs2_StartupDefs.startup1_def Abs2_StartupDefs.check_hash_region_defs
    PmmDefs.init_vars_def Abs2_CommonDefs.write_hashes_defs card_mode_full_upd min_def
    first_stage restart_mangle_sv_empty abs2_abs1_strel_defs brute_force
    combine_ec_states_simps
    split: split_if_asm
  )
  apply(simp_all (no_asm) add: HOL.conj_disj_distribR HOL.conj_disj_distribL ex_disj_distrib conj_assoc)
  using [[simp_depth_limit=4]]
  apply(clarsimp_all simp add: card_mode_full_upd min_def combine_ec_states_simps LDegraded_le_comb
    comb_EcOK_is_LDegraded
    split: split_if_asm)
  apply(case_tac[!] "hash1_state spc")
  apply(clarsimp_all simp add: comb_EcDead_or_EcUnwr_not_LOK)
  apply(case_tac[!] "hash2_state spc")
  apply(clarsimp_all simp add: comb_EcDead_or_EcUnwr_not_LOK comb_EcOK_is_LDegraded)
  apply(tactic {* distinct_subgoals_tac *})
  apply(tactic {* (REPEAT1 (CHANGED (TRYALL (etac @{thm disjE})))) *})
  apply(simp_all add: comb_EcDead_or_EcUnwr_not_LOK comb_EcOK_is_LDegraded)
  apply(tactic {* distinct_subgoals_tac *})
  apply(clarsimp_all simp add: comb_EcDead_or_EcUnwr_not_LOK comb_EcOK_is_LDegraded)
  apply(iterative_simp simp add: comb_EcDead_or_EcUnwr_not_LOK comb_EcOK_is_LDegraded)+
  apply(iterative_simp simp add: less_eq_EcUnwr exhaust_EcOK)+
  done

lemma init_vars_NE:
  "(PmmDefs.init_vars\<Down>NE) = empty"
  by(auto simp add: PmmDefs.init_vars_def brute_force)

lemma write_hashes_ref_R_NE:
  "sim_normE_ext (abs2_abs1_strel \<inter> UNIV \<times> min_one_good_hash)
  (\<lambda>s. ((Abs2_CommonDefs.write_hashes ht)\<Down>R) s \<guillemotright>=S Abs2_StartupDefs.startup1)
  (\<lambda>s. ((Abs1_CommonDefs.write_hashes ht)\<Down>R) s \<guillemotright>=S abs1_startup1')
    (force_same_and abs2_abs1_strel)"
  apply(clarsimp simp add: sim_normE_ext_def simN_wpc_def force_same_and_def bindS_projectNE)
  apply(rename_tac sva spa svc spc e svc' spc')
  apply(subst (asm) abs2_abs1_strel_def)
  apply(simp only:
    Abs1_CommonDefs.write_hashes_def abs1_startup1'_def abs1_check_hash_region'_def)
  apply(simp_all add: first_stage if_choice vol_ops_project_simps cong: if_cong exceptions.case_cong)
  apply(simp_all only: compose_project)
  apply(safe)
  apply(simp_all only: get_hash_table_or_fail_def)
  apply(simp_all add: first_stage if_choice vol_ops_project_simps cong: if_cong exceptions.case_cong)
  apply(simp_all only: write_hinst_def)
  apply(simp_all add: first_stage if_choice vol_ops_project_simps cong: if_cong exceptions.case_cong)
  apply(safe)
  apply(tactic {* distinct_subgoals_tac *})
  using [[simp_depth_limit=3]]
  using [[simproc del: throw_simproc throw_simproc' throw_bind_simproc throw_bind_simproc']]
  using [[simproc del: Product_Type.split_beta]]
  apply(clarsimp_adj_all simp add: abs2_abs1_strel_core_def abs1_same_rest_def
    get_hash_table_def is_good_hash_def card_mode_full_upd
    brute_force vol_ops_defs
    ec_state_simps min_def min_one_good_hash_def
    split: split_if_asm
  )
  apply(tactic {* (REPEAT1 (CHANGED (TRYALL (etac @{thm disjE})))) *})
  apply(clarsimp_all)
  apply(tactic {* distinct_subgoals_tac *})
  apply(clarsimp_all simp add: check_hash_region_NE_def less_eq_EcBad choice_def)
  apply(tactic {* distinct_subgoals_tac *})
  apply(clarsimp_all simp add:
    abs1_same_rest_def
    Abs2_StartupDefs.startup1_def Abs2_StartupDefs.check_hash_region_defs
    PmmDefs.init_vars_def Abs2_CommonDefs.write_hashes_defs card_mode_full_upd
    first_stage restart_mangle_sv_empty abs2_abs1_strel_defs brute_force
  )
  apply(simp_all (no_asm) add: HOL.conj_disj_distribR HOL.conj_disj_distribL ex_disj_distrib conj_assoc)
  apply(tactic {* distinct_subgoals_tac *})
  apply(clarsimp_all)
  apply(iterative_simp simp add: less_eq_EcUnwr)+
  done

definition get_hashes_R where
  "get_hashes_R \<equiv>
    \<lambda>(sv, sp).
    {
        (sv', sp')|sv' sp'.
            (hash1_state sp' \<noteq> EcOK
                \<or> (hash1_state sp = EcOK \<and> hash1 sp' = hash1 sp)
                \<or> (hash2_state sp = EcOK \<and> hash1 sp' = hash2 sp)
            )
            \<and> (hash2_state sp' \<noteq> EcOK
                \<or> (hash1_state sp = EcOK \<and> hash2 sp' = hash1 sp)
                \<or> (hash2_state sp = EcOK \<and> hash2 sp' = hash2 sp)
            )
            \<and> (hash1_state sp = EcDead \<longrightarrow> hash1_state sp' = EcDead)
            \<and> (hash2_state sp = EcDead \<longrightarrow> hash2_state sp' = EcDead)
            \<and> (hash1_state sp = EcUnwr \<longrightarrow> hash1_state sp' \<le> EcUnwr)
            \<and> (hash2_state sp = EcUnwr \<longrightarrow> hash2_state sp' \<le> EcUnwr)
            \<and> abs1_same_rest sp sp'
    }
  "

lemma st_aux:
  "
        (sp\<lparr>hash2 := cnt, hash2_state := EcBad, hash1 := a,
             hash1_state := EcBad\<rparr> =
        sp\<lparr>hash2 := cnt, hash2_state := EcBad, hash1 := aa\<rparr>)
        = (a = aa \<and> hash1_state sp = EcBad)

  "
  "(sp\<lparr>hash2 := cnt, hash1 := a, hash1_state := EcBad\<rparr> = sp
        \<lparr>hash2 := cnt, hash1 := aa\<rparr>) = (a = aa \<and> hash1_state sp = EcBad)"
  "
    (sp\<lparr>hash2_state := EcBad, hash2 := ht'\<rparr> = sp\<lparr>hash2 := ht'a\<rparr>) =
        (ht' = ht'a \<and> hash2_state sp = EcBad)
  "
  apply (smt abs1_state.simps(1) abs1_state.simps(12) abs1_state.simps(13)
    abs1_state.simps(14) abs1_state.simps(15) abs1_state.simps(3) abs1_state.surjective)
  apply (smt abs1_state.iffs abs1_state.simps(12) abs1_state.simps(14)
    abs1_state.simps(15) abs1_state.surjective)
  apply (smt abs1_state.equality abs1_state.iffs abs1_state.simps(13)
    abs1_state.simps(15) abs1_state.surjective)
  done

lemma get_hashes_R:
  "(sv', sp') \<in> ((Abs1_CommonDefs.get_hashes)\<Down>R) (sv, sp) \<Longrightarrow>
        (sv', sp') \<in> get_hashes_R (sv, sp)
  "
  apply(simp_all only: Abs1_CommonDefs.get_hashes_def)
  apply(simp_all only: first_stage vol_ops_project_simps)
  apply(simp_all only: choice_def Un_iff, safe)
  apply(tactic {* distinct_subgoals_tac *})
  apply(simp_all only: get_hash_table_raw)
  apply(simp_all only: write_hinst_def)
  apply(simp_all add: first_stage vol_ops_project_simps)
  apply(simp_all only: choice_def Un_iff, safe)
  apply(tactic {* distinct_subgoals_tac *})
  apply(simp_all only: get_hash_table_or_fail_def)
  apply(simp_all only: first_stage write_hinst_simps restart_mangle_sv_empty)
  apply(simp_all only: choice_def Un_iff, safe)
  apply(tactic {* distinct_subgoals_tac *})
  apply(simp_all only: get_hash_table_def)
  apply(simp_all only: first_stage write_hinst_simps restart_mangle_sv_empty)
  apply(simp_all only: choice_def Un_iff, safe)
  apply(tactic {* distinct_subgoals_tac *})
  apply(simp_all only: ll_read_hinst_def)
  apply(simp_all add: first_stage Abs1_LLInterface_Lemmas.ll_read_simps
    is_good_hash_project_simp restart_mangle_sv_empty vol_ops_project_simps
    cong: if_cong exceptions.case_cong)
  apply(simp_all only: choice_def Un_iff, safe)
  apply(tactic {* distinct_subgoals_tac *})
  using [[simp_depth_limit=3]]
  using [[simproc del: Product_Type.split_beta]]
  apply(clarsimp_all simp add: brute_force PmmDefs.init_vars_def
    abs2_abs1_strel_core_def abs1_same_rest_def ec_state_simps min_def 
    is_good_hash_def vol_ops_defs
    get_hash_table_NN_def get_hash_table_NE_def split: split_if_asm)
  apply(tactic {* distinct_subgoals_tac *})
  apply(tactic {* (REPEAT1 (CHANGED (TRYALL (etac @{thm disjE})))) *})
  apply(tactic {* distinct_subgoals_tac *})
  using [[simp_depth_limit=1]]
  apply(simp_all add: log_state_upd_eq_iff)
  apply(tactic {* distinct_subgoals_tac *})
  using [[simp_depth_limit=0]]
  apply(clarsimp_all simp add: get_hashes_R_def abs1_same_rest_def st_aux)
  done

lemma get_hashes_ref_R_NN: "sim_normN_ext abs2_abs1_strel
  (\<lambda>s. ((Abs2_CommonDefs.get_hashes)\<Down>R) s \<guillemotright>=S Abs2_StartupDefs.startup1)
  (\<lambda>s. ((Abs1_CommonDefs.get_hashes)\<Down>R) s \<guillemotright>=S abs1_startup1')
  (force_same_and abs2_abs1_strel)"
  apply(auto simp only: sim_normN_ext_def simN_wpc_def force_same_and_def bindS_projectNN)
  apply(rename_tac sva spa svc spc svc' spc')
  apply(clarsimp_all simp add: unfold_monad)
  apply(drule get_hashes_R)
  apply(simp_all only:  abs1_startup1'_def compose_project abs1_check_hash_region'_def first_stage)
  apply(clarsimp_all simp add:
    abs1_same_rest_def
    get_hashes_R_def
    Abs2_StartupDefs.startup1_def Abs2_StartupDefs.check_hash_region_defs
    PmmDefs.init_vars_def Abs2_CommonDefs.get_hashes_defs aux1
    first_stage restart_mangle_sv_empty abs2_abs1_strel_defs brute_force
  )
  apply(simp_all (no_asm) add: HOL.conj_disj_distribR HOL.conj_disj_distribL ex_disj_distrib conj_assoc)
  apply(iterative_simp)+
  apply(simp_all add: check_hash_region_NN_def abs1_same_rest_def choice_def)
  apply(iterative_simp simp add: less_eq_EcBad EcBad_less_eq)+
  apply(case_tac[!] "hash2_state spc")
  apply(simp_all)
  apply(case_tac[!] "hash1_state spc")
  apply(simp_all)
  apply(iterative_simp simp add: less_eq_EcUnwr)+
  done

lemma get_hashes_ref_R_NE: "sim_normE_ext abs2_abs1_strel
  (\<lambda>s. ((Abs2_CommonDefs.get_hashes)\<Down>R) s \<guillemotright>=S Abs2_StartupDefs.startup1)
  (\<lambda>s. ((Abs1_CommonDefs.get_hashes)\<Down>R) s \<guillemotright>=S abs1_startup1')
  (force_same_and abs2_abs1_strel)"
  apply(auto simp only: sim_normE_ext_def simN_wpc_def force_same_and_def bindS_projectNE)
  apply(rename_tac sva spa svc spc e svc' spc')
  apply(clarsimp_all simp add: unfold_monad)
  apply(drule get_hashes_R)
  apply(simp_all only:  abs1_startup1'_def compose_project abs1_check_hash_region'_def first_stage)
  apply(clarsimp_all simp add:
    abs1_same_rest_def
    get_hashes_R_def
    Abs2_StartupDefs.startup1_def Abs2_StartupDefs.check_hash_region_defs
    PmmDefs.init_vars_def Abs2_CommonDefs.get_hashes_defs aux1
    first_stage restart_mangle_sv_empty abs2_abs1_strel_defs brute_force
  )
  apply(simp_all add: check_hash_region_NE_def abs1_same_rest_def choice_def)
  apply(iterative_simp simp add: less_eq_EcBad EcBad_less_eq)+
  done

lemma get_hashes_DegradedH_R:
  "(sv', sp') \<in> ((Abs1_CommonDefs.get_hashes_DegradedH)\<Down>R) (sv, sp) \<Longrightarrow>
        (sv', sp') \<in> get_hashes_R (sv, sp)
  "
  apply(simp_all only: Abs1_CommonDefs.get_hashes_DegradedH_def)
  apply(simp_all only: first_stage vol_ops_project_simps)
  apply(simp_all only: choice_def Un_iff, safe)
  apply(simp_all only: get_hash_table_or_fail_def)
  apply(simp_all add: first_stage vol_ops_project_simps)
  apply(tactic {* distinct_subgoals_tac *})
  apply(simp_all only: get_hash_table_raw)
  apply(simp_all only: get_hash_table_def)
  apply(simp_all only: first_stage write_hinst_simps restart_mangle_sv_empty)
  apply(simp_all only: choice_def Un_iff, safe)
  apply(tactic {* distinct_subgoals_tac *})
  apply(simp_all only: ll_read_hinst_def)
  apply(simp_all only: first_stage Abs1_LLInterface_Lemmas.ll_read_simps restart_mangle_sv_empty)
  apply(simp_all only: choice_def Un_iff, safe)
  apply(simp_all add: first_stage Abs1_LLInterface_Lemmas.ll_read_simps
    is_good_hash_project_simp restart_mangle_sv_empty vol_ops_project_simps
    cong: if_cong exceptions.case_cong)
  using [[simp_depth_limit=0]]
  apply(clarsimp_all simp add: brute_force PmmDefs.init_vars_def
    abs2_abs1_strel_core_def abs1_same_rest_def ec_state_simps min_def 
    is_good_hash_def
    get_hash_table_NN_def get_hash_table_NE_def split: split_if_asm)
  apply(tactic {* distinct_subgoals_tac *})
  apply(tactic {* (REPEAT1 (CHANGED (TRYALL (etac @{thm disjE})))) *})
  apply(tactic {* distinct_subgoals_tac *})
  using [[simp_depth_limit=0]]
  apply(clarsimp_all simp add: get_hashes_R_def abs1_same_rest_def st_aux)
  done
 
lemma get_hashes_DegradedH_ref_R_NN: "sim_normN_ext abs2_abs1_strel
  (\<lambda>s. ((Abs2_CommonDefs.get_hashes_DegradedH)\<Down>R) s \<guillemotright>=S Abs2_StartupDefs.startup1)
  (\<lambda>s. ((Abs1_CommonDefs.get_hashes_DegradedH)\<Down>R) s \<guillemotright>=S abs1_startup1')
  (force_same_and abs2_abs1_strel)"
  apply(auto simp only: sim_normN_ext_def simN_wpc_def force_same_and_def bindS_projectNN)
  apply(rename_tac sva spa svc spc svc' spc')
  apply(clarsimp_all simp add: unfold_monad)
  apply(drule get_hashes_DegradedH_R)
  apply(simp_all only:  abs1_startup1'_def compose_project abs1_check_hash_region'_def first_stage)
  apply(clarsimp_all simp add:
    abs1_same_rest_def
    get_hashes_R_def
    Abs2_StartupDefs.startup1_def Abs2_StartupDefs.check_hash_region_defs
    PmmDefs.init_vars_def Abs2_CommonDefs.get_hashes_all_defs aux1
    first_stage restart_mangle_sv_empty abs2_abs1_strel_defs brute_force
  )
  apply(simp_all (no_asm) add: HOL.conj_disj_distribR HOL.conj_disj_distribL ex_disj_distrib conj_assoc)
  apply(iterative_simp)+
  apply(simp_all add: check_hash_region_NN_def abs1_same_rest_def choice_def)
  apply(iterative_simp simp add: less_eq_EcBad EcBad_less_eq)+
  apply(case_tac[!] "hash2_state spc")
  apply(simp_all)
  apply(case_tac[!] "hash1_state spc")
  apply(simp_all)
  apply(iterative_simp simp add: less_eq_EcUnwr)+
  done


lemma get_hashes_DegradedH_ref_R_NE: "sim_normE_ext abs2_abs1_strel
  (\<lambda>s. ((Abs2_CommonDefs.get_hashes_DegradedH)\<Down>R) s \<guillemotright>=S Abs2_StartupDefs.startup1)
  (\<lambda>s. ((Abs1_CommonDefs.get_hashes_DegradedH)\<Down>R) s \<guillemotright>=S abs1_startup1')
  (force_same_and abs2_abs1_strel)"
  apply(auto simp only: sim_normE_ext_def simN_wpc_def force_same_and_def bindS_projectNE)
  apply(rename_tac sva spa svc spc e svc' spc')
  apply(clarsimp_all simp add: unfold_monad)
  apply(drule get_hashes_DegradedH_R)
  apply(simp_all only:  abs1_startup1'_def compose_project abs1_check_hash_region'_def first_stage)
  apply(clarsimp_all simp add:
    abs1_same_rest_def
    get_hashes_R_def
    Abs2_StartupDefs.startup1_def Abs2_StartupDefs.check_hash_region_defs
    PmmDefs.init_vars_def Abs2_CommonDefs.get_hashes_all_defs aux1
    first_stage restart_mangle_sv_empty abs2_abs1_strel_defs brute_force
  )
  apply(simp_all add: check_hash_region_NE_def abs1_same_rest_def choice_def)
  apply(iterative_simp simp add: less_eq_EcBad EcBad_less_eq)+
  done

lemma write_hashes_ref_R_N:
  "sim_norm_ext (abs2_abs1_strel \<inter> UNIV \<times> min_one_good_hash)
  (\<lambda>s. ((Abs2_CommonDefs.write_hashes ht)\<Down>R) s \<guillemotright>=S Abs2_StartupDefs.startup1)
  (\<lambda>s. ((Abs1_CommonDefs.write_hashes ht)\<Down>R) s \<guillemotright>=S abs1_startup1')
    (force_same_and abs2_abs1_strel)
    (force_same_and abs2_abs1_strel)"
  by(auto simp only: sim_norm_ext_decompose intro: write_hashes_ref_R_NN write_hashes_ref_R_NE)

lemma get_hashes_ref_R_N: "sim_norm_ext abs2_abs1_strel
  (\<lambda>s. ((Abs2_CommonDefs.get_hashes)\<Down>R) s \<guillemotright>=S Abs2_StartupDefs.startup1)
  (\<lambda>s. ((Abs1_CommonDefs.get_hashes)\<Down>R) s \<guillemotright>=S abs1_startup1')
  (force_same_and abs2_abs1_strel)
  (force_same_and abs2_abs1_strel)"
  by(auto simp only: sim_norm_ext_decompose intro: get_hashes_ref_R_NN get_hashes_ref_R_NE)

lemma get_hashes_DegradedH_ref_R_N:
  "sim_norm abs2_abs1_strel
  (\<lambda>s. ((Abs2_CommonDefs.get_hashes_DegradedH)\<Down>R) s \<guillemotright>=S Abs2_StartupDefs.startup1)
  (\<lambda>s. ((Abs1_CommonDefs.get_hashes_DegradedH)\<Down>R) s \<guillemotright>=S abs1_startup1')
  "
  by(auto simp only: sim_norm_def sim_norm_ext_decompose intro: get_hashes_DegradedH_ref_R_NN
    get_hashes_DegradedH_ref_R_NE)

lemma weaker_rel:
  "abs2_abs1_strel \<subseteq> abs2_abs1_strel_core"
  by(auto simp add: abs2_abs1_strel_defs)

lemma check_hash_region_ref_NN: "sim_normN_ext abs2_abs1_strel
  (Abs2_StartupDefs.check_hash_region)
  (abs1_check_hash_region')
  (force_same_and abs2_abs1_strel)"
  apply(auto simp only: sim_normN_ext_def simN_wpc_def)
  apply(rename_tac sva spa svc spc svc' spc')
  apply(simp only: abs1_check_hash_region'_def compose_project first_stage)
  apply(clarsimp_adj (no_asm) simp add: brute_force Abs2_StartupDefs.check_hash_region_defs
    first_stage restart_mangle_sv_empty abs2_abs1_strel_defs
  )
  apply(simp (no_asm) add: HOL.conj_disj_distribL HOL.conj_disj_distribR ex_disj_distrib conj_assoc)
  apply(clarsimp_adj (no_asm_use) simp add: check_hash_region_NN_def choice_def force_same_and_def)
  apply(elim disjE)
  using [[simp_depth_limit=0]]
  apply(simp_all add: brute_force get_hash_table_NN_def get_hash_table_NE_def
    abs2_abs1_strel_defs abs1_same_rest_def ec_state_simps
    split:  split_if_asm exceptions.split_asm)
  apply(iterative_simp simp add: ec_state_simps)+
  apply(case_tac[!] "hash1_state spc", simp_all)
  apply(case_tac[!] "hash2_state spc", simp_all)
  done

lemma check_hash_region_ref_NE: "sim_normE_ext abs2_abs1_strel
  (Abs2_StartupDefs.check_hash_region)
  (abs1_check_hash_region')
  (force_same_and abs2_abs1_strel)"
  apply(auto simp only: sim_normE_ext_def simN_wpc_def)
  apply(rename_tac sva spa svc spc vc svc' spc')
  apply(simp only: abs1_check_hash_region'_def compose_project first_stage)
  apply(clarsimp_adj (no_asm) simp add: brute_force Abs2_StartupDefs.check_hash_region_defs
    first_stage restart_mangle_sv_empty abs2_abs1_strel_defs
  )
  apply(clarsimp_adj (no_asm_use) simp add: check_hash_region_NE_def force_same_and_def)
  using [[simp_depth_limit=0]]
  apply(simp_all add: brute_force get_hash_table_NN_def get_hash_table_NE_def
    abs2_abs1_strel_defs abs1_same_rest_def ec_state_simps
    split:  split_if_asm exceptions.split_asm)
  apply(iterative_simp simp add: ec_state_simps)+
  done
  
lemma check_hash_region_ref_N: "sim_norm abs2_abs1_strel
  (Abs2_StartupDefs.check_hash_region)
  (abs1_check_hash_region')
  "
  by(auto simp only: sim_norm_decompose sim_normN_def sim_normE_def
    intro: check_hash_region_ref_NN check_hash_region_ref_NE)

lemma vol_ops_ref[ref_thm]:
  "sim abs2_abs1_strel (PmmDefs.init_vars) (PmmDefs.init_vars)"
  "sim abs2_abs1_strel (PmmDefs.get_mode) (PmmDefs.get_mode)"
  "sim abs2_abs1_strel (PmmDefs.set_degraded) (PmmDefs.set_degraded)"
  "sim abs2_abs1_strel (PmmDefs.set_degraded_p) (PmmDefs.set_degraded_p)"
  "sim abs2_abs1_strel (PmmDefs.set_degraded_h) (PmmDefs.set_degraded_h)"
  "sim abs2_abs1_strel (PmmDefs.set_failed) (PmmDefs.set_failed)"
  "sim abs2_abs1_strel (PmmDefs.get_updated) (PmmDefs.get_updated)"
  "sim abs2_abs1_strel (PmmDefs.add_to_updated pind) (PmmDefs.add_to_updated pind)"
  "sim abs2_abs1_strel (PmmDefs.set_updated upd) (PmmDefs.set_updated upd)"
  apply(auto simp only: sim_def sim_ext_def)
  apply(auto simp add: abs2_abs1_strel_defs brute_force force_same_and_def
    PmmDefs.vol_ops_defs
    PmmDefs.getters_setters 
    simN_wpc_def simS_wpc_def
        split: split_if_asm
        intro!: ext
  )
  done

lemma elem_if: "(x \<in> (if cond then UNIV else {})) = cond"
  by(simp)

lemma ex_elem_set: "(\<exists>x y. x \<in> set y) = True" "(\<exists>x y. y \<in> set x) = True"
  by (metis ListMem_iff elem)+

lemma subset_rewr: "(\<forall>x. x \<in> A \<longrightarrow> x \<in> B) = (A \<subseteq> B)"
  by auto

lemma force_same_and_subset:
  "(\<forall>x y. force_same_and R x y \<subseteq> force_same_and R' x y) = (R \<subseteq> R')"
  by(auto simp add: force_same_and_def)

lemmas abs2_ref_congs = imp_cong if_weak_cong

declare abs1_startup1'_def[monad_def]
declare Abs2_StartupDefs.startup1_def[monad_def] 

lemma force_same_and_mono:
  "R \<subseteq> R' \<Longrightarrow> force_same_and R x y \<subseteq> force_same_and R' x y"
  by(auto simp add: force_same_and_def)

lemmas abs2_ref_simp_thms = 
    (* Int_commute Int_left_commute *)
    UNIV_def[THEN sym] Set.empty_def[THEN sym]
    Int_UNIV_right Int_UNIV_left Int_empty_left Int_empty_right empty_subsetI
    Int_Collects Collect_subset Set.Int_Collect Pmm_Refinement.Int_Collect  mem_Collect_eq
    subset_Collect subset_bCollect empty_iff Int_iff imp_conj_same imp_conj_simps
    conj_commute conj_assoc conj_left_absorb iso_tuple_UNIV_I
    HOL.simp_thms HOL.ex_simps
    HOL.True_implies_equals
    Product_Type.split
    triv_precond bool_into_set_def
    admin_indx.simps indx.simps
    comm_same_alter
  (*
    abs1_abs1_strel_not_empty strel_and_make_hreg
    make_hreg_projs make_hreg_updates
  *)
    force_same_and_diff force_same_and_subset force_same_and_same force_same_and_subset
    if_True
    elem_if ex_elem_set subset_rewr
    subset_refl_eq
    imp_ex[THEN sym]
    set_equalityI_HOL
    Int_lower1_eq Int_lower2_eq

ML {*
  val abs2_ref_simpset = (HOL_basic_ss addsimps @{thms abs2_ref_simp_thms}
                                        addsimprocs [@{simproc HOL.defined_All}])
    |> fold Raw_Simplifier.add_cong @{thms abs2_ref_congs}

  fun abs2_simp _ = map (
    asm_full_simplify abs2_ref_simpset
    #> Ref_Tac.instantiate_redundant_subsets
    #> full_simplify abs2_ref_simpset
  )

*}

subsection {*
  Proofs of @{term "sim_norm"} type simulation
*}

lemma sim_norm_ext_mono_N:
  "\<lbrakk> sim_norm_ext R ma mc Sn Se; \<forall>va vc. Sn va vc \<subseteq> Sn' va vc \<rbrakk> \<Longrightarrow>
    sim_norm_ext R ma mc Sn' Se"
  by(auto simp add: sim_norm_ext_def intro: simN_wpc_mono_concl del: subsetI)

lemma sim_norm_ext_mono_E:
  "\<lbrakk> sim_norm_ext R ma mc Sn Se; \<forall>va vc. Se va vc \<subseteq> Se' va vc \<rbrakk> \<Longrightarrow>
    sim_norm_ext R ma mc Sn Se'"
  by(auto simp add: sim_norm_ext_def intro: simN_wpc_mono_concl del: subsetI)

lemma get_hashes_ref_N'[ref_thm]:
  "sim_norm abs2_abs1_strel
    (Abs2_CommonDefs.get_hashes)
    (Abs1_CommonDefs.get_hashes)
  "
  apply(simp add: sim_norm_def)
  apply(rule sim_norm_ext_mono_N)
  apply(rule get_hashes_ref_N)
  apply(auto simp add: force_same_and_subset intro!: get_hashes_ref_N del: subsetI)
  done

declare
  sim_norm_return[ref_thm]
  sims_throw(1)[ref_thm]
  sims_throw(2)[ref_thm]
  sim_norm_chooseN[ref_thm]

declare
  sim_norm_bind_rt[ref_bind]
  sim_norm_try_catch_rt[ref_try_catch]
  sim_norm_exc_case_rt[ref_exc_case]
  sim_norm_if_rt[ref_if]
  sim_norm_mapM_rt[ref_mapM]

declare sim_sim_norm_bindI[ref_bind]

lemma update_pub_instance_hash_ref_N[ref_thm]:
  "sim_norm abs2_abs1_strel
    (Abs2_CommonDefs.update_pub_instance_hash ind inst cnt)
    (Abs1_CommonDefs.update_pub_instance_hash ind inst cnt)
  "
  by(tactic {* (refinement_tac false abs2_simp @{context}) 1 *})

lemma update_ptr_instance_hash_ref_N[ref_thm]:
  "sim_norm abs2_abs1_strel
    (Abs2_CommonDefs.update_ptr_instance_hash inst cnt)
    (Abs1_CommonDefs.update_ptr_instance_hash inst cnt)
  "
  by(tactic {* (refinement_tac false abs2_simp @{context}) 1 *})

declare write_f_ref[ref_thm]

declare ll_read_ref[ref_thm]

lemma get_hashes_DegradedH_ref_N'[ref_thm]:
"sim_norm abs2_abs1_strel
  (Abs2_CommonDefs.get_hashes_DegradedH)
  (Abs1_CommonDefs.get_hashes_DegradedH)
  "
  by(auto simp only: sim_norm_def intro: get_hashes_DegradedH_ref_N)

declare write_f_ref[THEN sim_imp_sim_norm, ref_thm]

lemma write_instance_ref_N[ref_thm]:
  "sim_norm abs2_abs1_strel
    (Abs2_CommonDefs.write_instance regs ind cnt)
    (Abs1_CommonDefs.write_instance regs ind cnt)
  "
  apply(tactic {* (refinement_tac false abs2_simp @{context}) 1 *})
  done

lemma write_secondary_ref_N[ref_thm]:
  "sim_norm abs2_abs1_strel
    (Abs2_UpdateDefs.write_secondary regs ind)
    (Abs1_UpdateDefs.write_secondary regs ind)
  "
  apply(tactic {* (refinement_tac false abs2_simp @{context}) 1 *})
  done

declare check_hash_region_ref_N[ref_thm]
declare vol_ops_ref[THEN sim_imp_sim_norm, ref_thm]

declare write_ptr_ll_ref[ref_thm]

declare get_hashes_ref_N[ref_thm del]
declare get_hashes_ref_N'[ref_thm]

declare sim_return[ref_thm]
declare sim_norm_if_rt[ref_if]

declare write_ptr_ll_ref[THEN sim_imp_sim_norm, ref_thm]
thm get_hashes_ref_N'

lemma[ref_thm]:
  "sim R
    (PmmDefs.check_sizes upd_f)
    (PmmDefs.check_sizes upd_f)
  "
  apply(auto simp add: PmmDefs.check_sizes_def
    intro!: sims_all_intros)
  done

ML {*
  val thms = build_sim_thms false abs2_simp @{context}
    @{term "(Abs2_UpdateDefs.update regs)"}
    @{term "(Abs1_UpdateDefs.update regs)"}
    ||> (Context.>> o Ref_Thms.transfer)
    |> fst
*}

ML {*
  val thms = build_sim_thms false abs2_simp @{context}
    @{term "(Abs2_StartupDefs.startup2)"}
    @{term "(Abs1_StartupDefs.startup2)"}
    ||> (Context.>> o Ref_Thms.transfer)
    |> fst
*}

ML {*
  val thms = build_sim_thms false abs2_simp @{context}
    @{term "Abs2_FetchDefs.fetch pind"}
    @{term "Abs1_FetchDefs.fetch pind"}
    ||> (Context.>> o Ref_Thms.transfer)
    |> fst
  *}

lemma update_ref_N[ref_thm]:
  "sim_norm abs2_abs1_strel
    (Abs2_UpdateDefs.update regs)
    (Abs1_UpdateDefs.update regs)
  "
  by(tactic {* (refinement_tac true abs2_simp @{context}) 1 *})

lemma fetch_ref_N[ref_thm]:
  "sim_norm abs2_abs1_strel
    (Abs2_FetchDefs.fetch regs)
    (Abs1_FetchDefs.fetch regs)
  "
  by(tactic {* (refinement_tac false abs2_simp @{context}) 1 *})

lemma startup2_ref_N[ref_thm]:
  "sim_norm abs2_abs1_strel
    (Abs2_StartupDefs.startup2)
    (Abs1_StartupDefs.startup2)
  "
  by(tactic {* (refinement_tac false abs2_simp @{context}) 1 *})

subsubsection {*
  Proofs of @{term "sim_norm"} type simulation, over @{term "bindS"}
*}

lemma get_hashes_ref_R_N': "sim_norm abs2_abs1_strel
  (\<lambda>s. ((Abs2_CommonDefs.get_hashes)\<Down>R) s \<guillemotright>=S Abs2_StartupDefs.startup1)
  (\<lambda>s. ((Abs1_CommonDefs.get_hashes)\<Down>R) s \<guillemotright>=S abs1_startup1')
  "
  by(auto simp add: sim_norm_def intro: get_hashes_ref_R_N)

declare bind_bindS_rt[ref_bind_bindS]

declare sim_chooseN[ref_thm]
declare ll_read_ptr_ref[THEN sim_imp_sim_norm, ref_thm]
declare ll_read_ref[THEN sim_imp_sim_norm, ref_thm]
declare sim_return[ref_thm]
declare plain_bindS_rt[ref_bindS]
declare try_catch_bindS_rt[ref_try_catch_bindS]
declare mapM_bindS_rt[ref_mapM_bindS]
declare write_f_ref[THEN sim_imp_sim_norm, ref_thm]

lemma startup1_ref[ref_thm]:
  "sim_norm (abs2_abs1_strel)
    Abs2_StartupDefs.startup1
    abs1_startup1'
  "
  by(tactic {* (refinement_tac false abs2_simp @{context}) 1 *})

declare get_hashes_ref_N[ref_thm]
declare get_hashes_ref_R_N'[ref_thm]
declare get_hashes_DegradedH_ref_R_N[ref_thm]
declare write_hashes_ref_R_N[ref_thm]


ML {*
  Ref_Thms.get @{context}
*}


(* TODO: something funny going on; setting the ref_thm
  attribute directly on the theorem doesn't do jack,
  setting it afterwards with declare works fine,
  setting it twice (either directly on the theorem or
  with a declare first, and then again with declare)
  removes everything else from Ref_Thms.
  Also, adding any non-bindS theorem after a bindS
  theorem removes all the bindS theorems...
*)
lemma update_pub_instance_hash_ref_R_N[ref_thm]:
  "sim_norm abs2_abs1_strel
    (\<lambda>s. ((Abs2_CommonDefs.update_pub_instance_hash ind inst cnt)\<Down>R) s \<guillemotright>=S Abs2_StartupDefs.startup1)
    (\<lambda>s. ((Abs1_CommonDefs.update_pub_instance_hash ind inst cnt)\<Down>R) s \<guillemotright>=S abs1_startup1')
  "
  by(tactic {* (refinement_tac false abs2_simp @{context}) 1 *})

lemma update_ptr_instance_hash_ref_R_N[ref_thm]:
  "sim_norm abs2_abs1_strel
    (\<lambda>s. ((Abs2_CommonDefs.update_ptr_instance_hash inst cnt)\<Down>R) s \<guillemotright>=S Abs2_StartupDefs.startup1)
    (\<lambda>s. ((Abs1_CommonDefs.update_ptr_instance_hash inst cnt)\<Down>R) s \<guillemotright>=S abs1_startup1')
  "
  by(tactic {* (refinement_tac false abs2_simp @{context}) 1 *})

declare get_hashes_ref_N[ref_thm del]

lemma read_ref_R_N[ref_thm]:
  "sim_norm abs2_abs1_strel
    (\<lambda>s. ((Abs2_CommonDefs.read ind inst)\<Down>R) s \<guillemotright>=S Abs2_StartupDefs.startup1)
    (\<lambda>s. ((Abs1_CommonDefs.read ind inst)\<Down>R) s \<guillemotright>=S abs1_startup1')
  "
  by(tactic {* (refinement_tac false abs2_simp @{context}) 1 *})

lemma[ref_thm]:
  "sim abs2_abs1_strel (throw_mode_error e) (throw_mode_error e)"
  by(auto simp add: throw_mode_error_def intro!: sims_all_intros vol_ops_ref)

ML {*
  val thm = build_sim_thms false abs2_simp @{context}
  @{term "\<lambda>s. ((Abs2_StartupDefs.check_ptr)\<Down>R) s \<guillemotright>=S Abs2_StartupDefs.startup1"}
  @{term "\<lambda>s. ((Abs1_StartupDefs.check_ptr)\<Down>R) s \<guillemotright>=S abs1_startup1'"}
    ||> (Context.>> o Ref_Thms.transfer)
    |> fst
*}

ML {*
  val thms = build_sim_thms false abs2_simp @{context}
    @{term "
    (\<lambda>s. ((Abs2_UpdateDefs.update regs)\<Down>R) s \<guillemotright>=S Abs2_StartupDefs.startup1)
  "}
    @{term "
    (\<lambda>s. ((Abs1_UpdateDefs.update regs)\<Down>R) s \<guillemotright>=S abs1_startup1')
  "}
    ||> (Context.>> o Ref_Thms.transfer)
    |> fst
*}

lemma update_ref_R_N:
  "
  sim_norm abs2_abs1_strel
    (\<lambda>s. ((Abs2_UpdateDefs.update regs)\<Down>R) s \<guillemotright>=S Abs2_StartupDefs.startup1)
    (\<lambda>s. ((Abs1_UpdateDefs.update regs)\<Down>R) s \<guillemotright>=S abs1_startup1')
  "
  (* Seems that the polymorphism of throw_mode_error and check_sizes messes things up *)
  apply(auto simp add: Abs2_UpdateDefs.update_def Abs1_UpdateDefs.update_def)
  apply(rule sim_norm_bind_bindS)
  apply(rule sim_imp_sim_norm)
  apply(tactic {* (refinement_tac false abs2_simp @{context}) 1 *})
  apply(tactic {* (refinement_tac false abs2_simp @{context}) 1 *})
  apply(rule sim_norm_bind_bindS)
  apply(rule sim_imp_sim_norm)
  apply(tactic {* (refinement_tac false abs2_simp @{context}) 1 *})+
  done

ML {*
  val thms = build_sim_thms false abs2_simp @{context}
    @{term "
    (\<lambda>s. ((Abs2_FetchDefs.fetch regs)\<Down>R) s \<guillemotright>=S Abs2_StartupDefs.startup1)
  "}
    @{term "
    (\<lambda>s. ((Abs1_FetchDefs.fetch regs)\<Down>R) s \<guillemotright>=S abs1_startup1')
  "}
    ||> (Context.>> o Ref_Thms.transfer)
    |> fst
*}

lemma fetch_ref_R_N:
  "
  sim_norm abs2_abs1_strel
    (\<lambda>s. ((Abs2_FetchDefs.fetch regs)\<Down>R) s \<guillemotright>=S Abs2_StartupDefs.startup1)
    (\<lambda>s. ((Abs1_FetchDefs.fetch regs)\<Down>R) s \<guillemotright>=S abs1_startup1')
  "
  by(tactic {* (refinement_tac false abs2_simp @{context}) 1 *})

lemma startup2_ref_R_N:
  "
  sim_norm abs2_abs1_strel
    (\<lambda>s. ((Abs2_StartupDefs.startup2 :: ('a, pmm_vol_mem, 'c :: contents_cl)abs2_monad)\<Down>R) s
        \<guillemotright>=S Abs2_StartupDefs.startup1)
    (\<lambda>s. ((Abs1_StartupDefs.startup2 :: ('a, pmm_vol_mem, 'c :: contents_cl)abs1_monad)\<Down>R) s
        \<guillemotright>=S abs1_startup1')
  "
  by(tactic {* (refinement_tac false abs2_simp @{context}) 1 *})

declare startup2_ref_R_N[ref_thm]

lemma update_full_ref:
  "sim_norm abs2_abs1_strel
    (<tryR>
        Abs2_UpdateDefs.update regs   
    <catchR>
        rec_tryR (Abs2_StartupDefs.startup)
    )
    (<tryR>
        Abs1_UpdateDefs.update regs   
    <catchR>
        rec_tryR (Abs1_StartupDefs.startup)
    )
  "
  by(auto simp add: Abs2_StartupDefs.startup_def Abs1_StartupDefs.startup_def
    intro!: trans_ref_fin update_ref_N startup2_ref_N update_ref_R_N startup2_ref_R_N
    abs1_startup1_fin)

lemma fetch_full_ref:
  "sim_norm abs2_abs1_strel
    (<tryR>
        Abs2_FetchDefs.fetch ind
    <catchR>
        rec_tryR (Abs2_StartupDefs.startup)
    )
    (<tryR>
        Abs1_FetchDefs.fetch ind
    <catchR>
        rec_tryR (Abs1_StartupDefs.startup)
    )
  "
  by(auto simp add: Abs2_StartupDefs.startup_def Abs1_StartupDefs.startup_def
    intro!: trans_ref_fin fetch_ref_N startup2_ref_N fetch_ref_R_N startup2_ref_R_N
    abs1_startup1_fin)

lemma abs2_startup_full_ref_N:
  "sim_norm abs2_abs1_strel
    (<tryR>
        Abs2_StartupDefs.startup
    <catchR>
        rec_tryR (Abs2_StartupDefs.startup)
    )
    (<tryR>
        Abs1_StartupDefs.startup
    <catchR>
        rec_tryR (Abs1_StartupDefs.startup)
    )
  "
  apply(auto simp add: Abs2_StartupDefs.startup_def Abs1_StartupDefs.startup_def)
  apply(auto intro!: trans_ref_fin_same Abs2_Ref.startup1_ref Abs2_Ref.startup2_ref_N 
    Abs2_Ref.startup2_ref_R_N Abs1_Startup_Lemmas.abs1_startup1_fin)
  done

end
