theory Abs2_Specification
  imports Abs2_UpdateDefs Abs2_StartupDefs Abs2_FetchDefs "../Pmm_Specification"
begin

definition abs2_trans 
  :: "((pmm_vol_mem \<times> ('c :: contents_cl) abs2_state) \<times> (pmm_vol_mem \<times> 'c abs2_state))set" where
  "abs2_trans \<equiv> \<Union>upd_f ind. set_fun_into_rel (
    ((try_rec_tryR (Abs2_UpdateDefs.update upd_f) Abs2_StartupDefs.startup)\<Down>SN)
    [+] ((try_rec_tryR (Abs2_FetchDefs.fetch ind) Abs2_StartupDefs.startup)\<Down>SN)
    [+] ((try_rec_tryR 
        (restart_mangle_sv :: (unit, pmm_vol_mem, 'c)abs2_monad)
        Abs2_StartupDefs.startup)\<Down>SN)
  )"

definition abs2_init where
  "abs2_init \<equiv> {(sv, sp). 
    (hstate sp \<noteq> LDead \<and> ptr1_state sp = IUnwr \<longrightarrow> ptr_hashes2 (hash sp) Primary \<noteq> ptr1 sp)
    \<and> (hstate sp \<noteq> LDead \<and> ptr2_state sp = IUnwr \<longrightarrow> ptr_hashes2 (hash sp) Secondary \<noteq> ptr2 sp)
    \<and> (\<forall>ind inst. size (memory sp ind inst) \<le> capacity (Public ind))
  }"
 
definition abs2_ts 
  :: "(pmm_vol_mem \<times> 'c :: contents_cl abs2_state)TS" where
  "abs2_ts \<equiv> \<lparr> 
    init = abs2_init, 
    init_trans = set_fun_into_rel 
        ((Abs2_StartupDefs.startup :: (unit, pmm_vol_mem, 'c)abs2_monad)\<Down>SN), 
    trans = abs2_trans 
  \<rparr>"

record 'c abs2_obs_state =
  hstate :: log_state
  hash :: "('c htable2)option"

  ptr1 :: "pub_indx set"
  ptr1_state :: hw_state
  ptr2 :: "pub_indx set"
  ptr2_state :: hw_state

  memory :: "pub_indx \<Rightarrow> INST \<Rightarrow> 'c"
  hw_state :: "pub_indx \<Rightarrow> INST \<Rightarrow> hw_state"

fun abs2_obs where
  "abs2_obs (sv, sp) = (sv,
    \<lparr>
        abs2_obs_state.hstate = abs2_state.hstate sp
        , abs2_obs_state.hash = (if abs2_state.hstate sp = LDead then None else Some (abs2_state.hash sp))
        , abs2_obs_state.ptr1 = abs2_state.ptr1 sp
        , abs2_obs_state.ptr1_state = abs2_state.ptr1_state sp
        , abs2_obs_state.ptr2 = abs2_state.ptr2 sp
        , abs2_obs_state.ptr2_state = abs2_state.ptr2_state sp
        , abs2_obs_state.memory = abs2_state.memory sp
        , abs2_obs_state.hw_state = abs2_state.hw_state sp
    \<rparr>
  )"

definition abs2_spec where
  "abs2_spec \<equiv> TS.extend abs2_ts (spec.fields abs2_obs)"

end