signature TRANS_SIMPROC = sig
    val trans_simproc': simpset -> term -> thm option
    val trans_simproc: simpset -> cterm -> thm option
end

structure Trans_Simproc : TRANS_SIMPROC =
struct

fun trans_simproc' ss (t as (less as Const _) $ _ $ _) = let
    val ctxt = Simplifier.the_context ss

    val goal = HOLogic.mk_Trueprop t

    fun is_le_prem thm = (
        prop_of thm
                |> HOLogic.dest_Trueprop 
                |> head_of
                |> equal less
    ) handle TERM _ => false

    val le_prems = Simplifier.prems_of ss |> filter is_le_prem
    
in
    Goal.prove ctxt [] [] goal
               ((fn {context = ctxt', ...} => Orders.order_tac ctxt' le_prems 1))
               |> (fn thm => thm RS @{thm Eq_TrueI})
               |> SOME
    handle ERROR _ => NONE
end

fun trans_simproc ss ct = trans_simproc' ss (term_of ct)

end
