theory Abs3_Lemmas
imports Abs3_CommonDefs "../Projections" "../Pmm_Tacs" "../Pmm_Lemmas"
begin

lemmas brute_force =
  unfold_monad
  project_defs
  restart_mangle_sv_raw
  getters_setters
  modify_def
  choose_def
  put_def
  vol_ops_defs
  Abs3_LLInterface.write_f_defs
  Abs3_LLInterface.ll_read_defs

lemma write_f_proj_simps:
  "(write_f ind inst cnt)\<Down>NN = (write_success ind inst cnt)\<Down>NN"
  "(write_f ind inst cnt)\<Down>NE =
    (write_fail_instance ind inst cnt)\<Down>NE
    [+] (write_fail_readonly ind inst cnt)\<Down>NE
    [+] (write_too_large ind inst cnt)\<Down>NE
  "
  "(write_success ind inst cnt)\<Down>NE = empty"
  "(write_success ind inst cnt)\<Down>R = empty"
  "(write_fail_instance ind inst cnt)\<Down>NN = empty"
  "(write_fail_instance ind inst cnt)\<Down>R = empty"
  "(write_corrupt_restart ind inst cnt)\<Down>NN = empty"
  "(write_corrupt_restart ind inst cnt)\<Down>NE = empty"
  "(write_fail_readonly ind inst cnt)\<Down>NN = empty"
  "(write_fail_readonly ind inst cnt)\<Down>R = empty"
  apply(auto simp add: brute_force intro!: ext)
  done

lemma get_hashes_proj_simps:
  "(get_hashes_success)\<Down>NE = empty"
  "(get_hashes_success)\<Down>R = empty"
  "(get_hashes_degrade')\<Down>NE = empty"
  "(get_hashes_degrade')\<Down>R = empty"
  "(get_hashes_fail)\<Down>NN = empty"
  "(get_hashes_fail)\<Down>R = empty"
  "(get_hashes_degrade)\<Down>NN = empty"
  "(get_hashes_degrade)\<Down>R = empty"
  by(auto simp add: get_hashes_all_defs project_defs intro!: ext)

lemma write_hashes_proj_simps:
  "(write_hashes_success ht)\<Down>NE = empty"
  "(write_hashes_success ht)\<Down>R = empty"
  "(write_hashes_degrade_write ht)\<Down>NN = empty"
  "(write_hashes_degrade_write ht)\<Down>R = empty"
  "(write_hashes_partial_restart ht)\<Down>NN = empty"
  "(write_hashes_partial_restart ht)\<Down>NE = empty"
  "(write_hashes_fail ht)\<Down>NN = empty"
  "(write_hashes_fail ht)\<Down>R = empty"
  "(write_hashes_degrade ht)\<Down>NN = empty"
  "(write_hashes_degrade ht)\<Down>R = empty"
  by(auto simp add: write_hashes_defs project_defs intro!: ext)

lemma [no_throw]:
  "doesnt_throw_raw (get_hashes\<Down>NE) FailWrite"
  "doesnt_throw_raw (get_hashes\<Down>NE) FailRead"
  "doesnt_throw_raw (get_hashes\<Down>NE) FailLLRead"
  "doesnt_throw_raw (get_hashes\<Down>NE) StartedExc"
  "doesnt_throw_raw (get_hashes\<Down>NE) InvalidInput"
  "doesnt_throw_raw (get_hashes_DegradedH\<Down>NE) FailWrite"
  "doesnt_throw_raw (get_hashes_DegradedH\<Down>NE) FailRead"
  "doesnt_throw_raw (get_hashes_DegradedH\<Down>NE) FailLLRead"
  "doesnt_throw_raw (get_hashes_DegradedH\<Down>NE) StartedExc"
  "doesnt_throw_raw (get_hashes_DegradedH\<Down>NE) InvalidInput"
  "\<forall>v. doesnt_throw_raw (get_hashes_DegradedH\<Down>NE) (Degraded v)"
  by(auto simp add: doesnt_throw_raw_def get_hashes_all_defs brute_force)

lemma [no_throw]:
  "doesnt_throw_raw ((write_hashes ht)\<Down>NE) FailWrite"
  "doesnt_throw_raw ((write_hashes ht)\<Down>NE) FailRead"
  "doesnt_throw_raw ((write_hashes ht)\<Down>NE) FailLLRead"
  "doesnt_throw_raw ((write_hashes ht)\<Down>NE) StartedExc"
  "doesnt_throw_raw ((write_hashes ht)\<Down>NE) InvalidInput"
  by(auto simp add: doesnt_throw_raw_def write_hashes_defs brute_force)

lemma get_ptr_proj_simps:
  "(get_ptr_success)\<Down>NE = empty"
  "(get_ptr_success)\<Down>R = empty"
  "(get_ptr_deg)\<Down>NN = empty"
  "(get_ptr_deg)\<Down>R = empty"
  "(get_ptr_deg_h)\<Down>NN = empty"
  "(get_ptr_deg_h)\<Down>R = empty"
  "(get_ptr_fail)\<Down>NN = empty"
  "(get_ptr_fail)\<Down>R = empty"
  by(auto simp add: get_ptr_defs project_defs intro!: ext)

lemma[no_throw]:
  "doesnt_throw_raw (get_hashes_degrade\<Down>NE) FailLLRead"
  "doesnt_throw_raw (get_hashes_degrade\<Down>NE) FailRead"
  "doesnt_throw_raw (get_hashes_degrade\<Down>NE) FailMode"
  "doesnt_throw_raw (get_hashes_degrade\<Down>NE) FailWrite"
  "doesnt_throw_raw (get_hashes_degrade\<Down>NE) StartedExc"
  "doesnt_throw_raw (get_hashes_degrade\<Down>NE) InvalidInput"
  "doesnt_throw_raw (get_hashes_fail\<Down>NE) FailLLRead"
  "doesnt_throw_raw (get_hashes_fail\<Down>NE) FailRead"
  "doesnt_throw_raw (get_hashes_fail\<Down>NE) InvalidInput"
  "\<forall>v. doesnt_throw_raw (get_hashes_fail\<Down>NE) (Degraded v)"
  "doesnt_throw_raw (get_hashes_fail\<Down>NE) FailWrite"
  "doesnt_throw_raw (get_hashes_fail\<Down>NE) StartedExc"
  by(auto simp add: doesnt_throw_raw_def project_defs get_hashes_defs)

lemma[no_throw]:
  "doesnt_throw_raw ((Abs3_CommonDefs.read ind inst)\<Down>NE) FailWrite"
  "doesnt_throw_raw ((Abs3_CommonDefs.read ind inst)\<Down>NE) FailLLRead"
  "doesnt_throw_raw ((Abs3_CommonDefs.read ind inst)\<Down>NE) StartedExc"
  "doesnt_throw_raw ((Abs3_CommonDefs.read ind inst)\<Down>NE) InvalidInput"
  apply(clarsimp_all simp add: doesnt_throw_raw_def)
  apply(simp_all only: read_def)
  apply(simp_all only: first_stage vol_ops_project_simps)
  apply(simp_all only: choice_def Un_iff, safe)
  apply(iterative_simp simp add: brute_force get_hashes_all_defs
    split: split_if_asm exceptions.split_asm)
  apply(case_tac[!] ac)
  apply(simp_all)
  done

lemma doesnt_throw_just_sync[no_throw]:
  "doesnt_throw (Abs3_CommonDefs.just_sync pind to from) FailWrite"
  "doesnt_throw (Abs3_CommonDefs.just_sync pind to from) FailRead"
  "doesnt_throw (Abs3_CommonDefs.just_sync pind to from) FailLLRead"
  "doesnt_throw (Abs3_CommonDefs.just_sync pind to from) StartedExc"
  apply(simp_all add: doesnt_throw_def Abs3_CommonDefs.just_sync_def)
  apply(simp_all add: first_stage vol_ops_project_simps)
  apply(simp_all add: Abs3_CommonDefs.sync_def)
  apply(simp_all add: first_stage vol_ops_project_simps if_choice cong: exceptions.case_cong if_cong)
  apply(simp_all only: first_stage vol_ops_project_simps doesnt_throw_raw_choice)
  apply(safe)
  apply(simp_all only: Abs3_CommonDefs.read_or_fail_def)
  apply(simp_all add: first_stage vol_ops_project_simps if_choice cong: exceptions.case_cong if_cong)
  apply(simp_all only: Abs3_CommonDefs.read_def)
  apply(simp_all add: first_stage vol_ops_project_simps if_choice cong: exceptions.case_cong if_cong)
  apply(simp_all only: first_stage vol_ops_project_simps doesnt_throw_raw_choice)
  apply(safe)
  apply(simp_all only: Abs3_CommonDefs.write_instance_def)
  apply(simp_all add: first_stage vol_ops_project_simps if_choice cong: exceptions.case_cong if_cong)
  apply(simp_all only: first_stage vol_ops_project_simps doesnt_throw_raw_choice)
  apply(safe)
  apply(simp_all only: Abs3_CommonDefs.read_DegradedH_def
    Abs3_CommonDefs.update_instance_hash_def)
  apply(simp_all only: first_stage vol_ops_project_simps doesnt_throw_raw_choice)
  apply(safe)
  using [[simp_depth_limit=0]]
  using [[simproc del: Product_Type.split_beta]]
  apply(clarsimp_all simp add: doesnt_throw_raw_def brute_force
    get_hashes_all_defs write_hashes_defs
    split: exceptions.split_asm split_if_asm)
  done

lemma doesnt_throw_read_or_fail_silence_deg:
  "\<forall>v. doesnt_throw (Abs3_CommonDefs.read_or_fail_silence_deg ind inst)
    (Degraded v)"
  "\<forall>v. doesnt_throw (Abs3_CommonDefs.read_or_fail_silence_deg ind inst)
    (InvalidInput)"
  apply(simp_all add: Abs3_CommonDefs.read_or_fail_silence_deg_def)
  apply(simp_all add: first_stage vol_ops_project_simps if_choice cong: exceptions.case_cong if_cong)
  apply(simp_all add: Abs3_CommonDefs.read_or_fail_def)
  apply(simp_all only: first_stage vol_ops_project_simps doesnt_throw_raw_choice)
  apply(safe)
  apply(simp_all only: Abs3_CommonDefs.read_def)
  apply(simp_all only: first_stage vol_ops_project_simps doesnt_throw_raw_choice)
  apply(safe)
  apply(clarsimp_all simp add: doesnt_throw_raw_def brute_force
    get_hashes_all_defs write_hashes_defs
    split: exceptions.split_asm split_if_asm)
  done

lemma doesnt_throw_raw_post:
  "\<lbrakk>doesnt_throw_raw m e; \<lbrace>P\<rbrace> m \<lbrace>> Q\<rbrace>\<rbrakk>
    \<Longrightarrow> \<lbrace>P\<rbrace> m \<lbrace>> \<lambda>e'. if e' = e then {} else Q e'\<rbrace>"
  apply(auto simp add: doesnt_throw_raw_def Hoare_def Box_def)
  by (metis fst_conv imageI)

lemma doesnt_throw_raw_val_post:
  "\<lbrakk>\<forall>v. doesnt_throw_raw m (e v); \<lbrace>P\<rbrace> m \<lbrace>> Q\<rbrace>\<rbrakk>
    \<Longrightarrow> \<lbrace>P\<rbrace> m \<lbrace>> \<lambda>e'. if (\<exists>v. e' = e v) then {} else Q e'\<rbrace>"
  apply(auto simp add: doesnt_throw_raw_def Hoare_def Box_def)
  by (metis (hide_lams, no_types) fst_eqD image_iff)

lemma doesnt_throw_post_NE:
  "\<lbrakk> doesnt_throw m e; \<lbrace>P\<rbrace> m \<lbrace>@N Q\<rbrace> \<rbrakk> \<Longrightarrow>
  \<lbrace>P\<rbrace> m \<lbrace>@N \<lambda>e'. (if e' = e then {} else Q e')\<rbrace>"
  by(auto simp add: HoareNE_alt doesnt_throw_def intro!: doesnt_throw_raw_post)

lemma doesnt_throw_val_post_NE:
  "\<lbrakk> \<forall>v. doesnt_throw m (e v); \<lbrace>P\<rbrace> m \<lbrace>@N Q\<rbrace> \<rbrakk> \<Longrightarrow>
  \<lbrace>P\<rbrace> m \<lbrace>@N \<lambda>e'. (if (\<exists>v. e' = e v) then {} else Q e')\<rbrace>"
  by(auto simp add: HoareNE_alt doesnt_throw_def intro!: doesnt_throw_raw_val_post)

lemma just_sync_post_NE':
  "\<lbrace>P\<rbrace> Abs3_CommonDefs.just_sync pind to from \<lbrace>@N \<lambda>e.
    if e = FailWrite
    then {}
    else 
        if e = FailRead
        then {}
        else if e = FailLLRead
            then {}
            else if e = StartedExc
                then {}
                else UNIV
  \<rbrace>" 
  by(auto intro!: doesnt_throw_post_NE doesnt_throw_just_sync true_postNE[simplified K_def])

lemma just_sync_post_NE:
  "\<lbrace>P\<rbrace> Abs3_CommonDefs.just_sync pind to from \<lbrace>@N \<lambda>e.
    if e \<in> {FailWrite, FailRead, FailLLRead, StartedExc}
    then {}
    else UNIV
  \<rbrace>" 
  by(auto intro!: conseqNE_rule[OF _ just_sync_post_NE'])

lemma just_sync_silence_deg_post_NE:
  "\<lbrace>P\<rbrace> Abs3_CommonDefs.just_sync_silence_deg pind to from \<lbrace>@N \<lambda>e.
    if e = FailMode \<or> e = InvalidInput then UNIV else {}
  \<rbrace>" 
  apply(simp add: Abs3_CommonDefs.just_sync_silence_deg_def)
  apply(rule try_catch_ruleNE[OF just_sync_post_NE])
  (*
  apply(rule bind_ruleNE[OF just_sync_post_NE])
    *)
  apply(auto intro!: HoareNE_return ex_falsumNE)
  apply(case_tac x)
  apply(auto simp add: HoareNE_alt Hoare_def Box_def brute_force split: exceptions.split_asm)
  done

end
