theory Abs3_Specification
  imports Abs3_UpdateDefs Abs3_StartupDefs Abs3_FetchDefs "../Pmm_Specification"
begin

definition abs3_trans 
  :: "((pmm_vol_mem \<times> 'c abs3_state) \<times> (pmm_vol_mem \<times> 'c :: size abs3_state))set" where
  "abs3_trans \<equiv> \<Union>upd_f ind. set_fun_into_rel (
    ((try_rec_tryR (Abs3_UpdateDefs.update upd_f) Abs3_StartupDefs.startup)\<Down>SN)
    [+] ((try_rec_tryR (Abs3_FetchDefs.fetch ind) Abs3_StartupDefs.startup)\<Down>SN)
    [+] ((try_rec_tryR 
        (restart_mangle_sv :: (unit, 'c)abs3_monad)
        Abs3_StartupDefs.startup)\<Down>SN)
  )"

definition abs3_init where
  "abs3_init \<equiv> {(sv, sp). \<forall>ind inst. size (memory sp ind inst) \<le> capacity (Public ind)}"

definition abs3_ts 
  :: "(pmm_vol_mem \<times> 'c :: size abs3_state)TS" where
  "abs3_ts \<equiv> \<lparr> 
    init = abs3_init, 
    init_trans = set_fun_into_rel 
        ((Abs3_StartupDefs.startup :: (unit, 'c)abs3_monad)\<Down>SN), 
    trans = abs3_trans 
  \<rparr>"

record 'c abs3_obs_state =
  hstate :: log_state

  ptr :: "(pub_indx set)option"
  ptr_state :: log_state

  memory :: "pub_indx \<Rightarrow> INST \<Rightarrow> 'c"
  hw_state :: "pub_indx \<Rightarrow> INST \<Rightarrow> hw_state"
  pub_hashes :: "('c pub_hashes) option"

fun abs3_obs :: "('sv \<times> 'c abs3_state) \<Rightarrow> ('sv \<times> 'c :: contents_cl abs3_obs_state)" 
  where
  "abs3_obs (svc, spc) = (svc, 
        \<lparr> 
            abs3_obs_state.hstate = abs3_state.hstate spc
            , abs3_obs_state.ptr = (
                if abs3_state.ptr_state spc = LDead \<or> abs3_state.hstate spc = LDead
                then None
                else Some (abs3_state.ptr spc)                
            )
            , abs3_obs_state.ptr_state = (if abs3_state.hstate spc = LDead 
                then LDead 
                else abs3_state.ptr_state spc)
            , abs3_obs_state.memory = abs3_state.memory spc
            , abs3_obs_state.hw_state = abs3_state.hw_state spc
            , abs3_obs_state.pub_hashes = (
                if abs3_state.hstate spc = LDead 
                then None
                else Some (abs3_state.pub_hashes spc)
            )
        \<rparr>
  )"

definition abs3_spec where
  "abs3_spec \<equiv> TS.extend abs3_ts (spec.fields abs3_obs)"

end
