theory Abs3_StartupDefs
imports Abs3_CommonDefs "../Composition"
begin

definition startup1_NN
  :: "(unit, pmm_vol_mem \<times> 'c abs3_state)nds_monad"
  where
  "startup1_NN \<equiv>
  (\<lambda>(sv, sp). {((), sv', sp)|sv'.
    hstate sp = LOK
    \<and> ptr_state sp = LOK
    \<and> sv' = \<lparr> card_mode = CNormal, updated = {} \<rparr>
  })
  [+]
  (\<lambda>(sv, sp). {((), sv', sp')|sv' sp'.
    hstate sp = LOK
    \<and> ptr_state sp \<noteq> LDead
    \<and> sp' = sp\<lparr> ptr_state := LDegraded \<rparr>
    \<and> sv' = \<lparr> card_mode = CDegradedP, updated = {} \<rparr>
  })
  [+]
  (\<lambda>(sv, sp). {((), sv', sp')|sv' sp' pst.
    hstate sp \<ge> LDegraded
    \<and> (pst = LDegraded \<or> pst = LOK)
    \<and> pst \<le> ptr_state sp
    \<and> sp' = sp \<lparr> hstate := LDegraded, ptr_state := pst \<rparr>
    \<and> sv' = \<lparr> card_mode = CDegradedH, updated = {} \<rparr>
  })
  "

definition startup1_NE
  :: "('c exceptions, pmm_vol_mem \<times> 'c abs3_state)nds_monad"
  where
  "startup1_NE \<equiv>
  (\<lambda>(sv, sp). {(FailMode, sv', sp')|sv' sp' hst pst.
    sv' = \<lparr> card_mode = CFail, updated = {} \<rparr>
    \<and> (hst = LDead \<or> pst = LDead) 
    \<and> hst \<le> hstate sp
    \<and> pst \<le> ptr_state sp
    \<and> sp' = sp\<lparr> hstate := hst, ptr_state := pst \<rparr>
  })
  "

definition startup1 where
  "startup1 \<equiv> compose startup1_NN startup1_NE empty"

definition check_pub_same
    :: "pub_indx  \<Rightarrow> (unit, 'c :: size)abs3_monad" where
  check_pub_same_def[monad_def]:
  "check_pub_same pind \<equiv>
    <try> do {
        read pind Primary;
        (<try> do {
            read pind Secondary;
            return ()
        } <catch>
            (\<lambda>e. case e of
                FailRead \<Rightarrow> just_sync_silence_deg Secondary Primary pind
                | Degraded _ \<Rightarrow> return ()
                | _ \<Rightarrow> throw e
            )
        )
   } <catch> (\<lambda>e. case e of
        FailRead \<Rightarrow> just_sync_silence_deg Primary Secondary pind 
        | Degraded v \<Rightarrow>
            if v = EU
            then read_or_fail_silence_deg pind Secondary \<guillemotright> return ()
            else return ()
        | _ \<Rightarrow> throw e
    )
  "

definition check_pub_region :: "pub_indx \<Rightarrow> (unit, 'c :: size)abs3_monad" where
  check_pub_region_def[monad_def]:
  "check_pub_region pind \<equiv> do {
    dir \<leftarrow> get_sync_direction pind;
    if dir = SEq
    then do { check_pub_same pind; remove_from_ptr_silence_deg pind }
    else
        if dir = SR
        then sync_and_remove_from_ptr_silence_deg Secondary Primary pind 
        else sync_and_remove_from_ptr_silence_deg Primary Secondary pind 
  }"

definition check_all_public :: "
  (unit, 'c :: size) abs3_monad" where
  check_all_public_def[monad_def]:
  "check_all_public \<equiv> do {
    l \<leftarrow> chooseN (order_set UNIV);
    mapM' check_pub_region l
  }"

definition startup2 where
  startup2_def[monad_def]:
  "startup2 \<equiv> do {
    check_all_public;
    throw_mode_error EU;
    throw StartedExc
  }"
  
definition startup :: "('a, 'c :: size)abs3_monad" where
  startup_def[monad_def]:
  "startup \<equiv> do {
    startup1;
    startup2
  }"

end
            

