theory Abs4Defs
imports "../RMonad" "../PmmDefs" "../Inst_State"
begin

record 'c abs4_state =
  arrow :: "pub_indx \<Rightarrow> sync_direction"
  reliable :: "(pub_indx \<times> INST)set"
  writable :: "(pub_indx \<times> INST)set"
  memory :: "pub_indx \<Rightarrow> INST \<Rightarrow> 'c"
  admin_state :: log_state

type_synonym ('a, 'c)abs4_monad = "('a, 'c exceptions, abs_vol_mem, 'c abs4_state)pre_monad"

fun arrow_srcs :: "sync_direction \<Rightarrow> INST set" where
  "arrow_srcs SL = {Secondary}"
  | "arrow_srcs SR = {Primary}"
  | "arrow_srcs SEq = {Primary, Secondary}"
  | "arrow_srcs SBot = {}"

definition in_view :: "'c abs4_state \<Rightarrow> (pub_indx \<times> INST)set" where
  "in_view sp \<equiv> {(ind, inst). (ind, inst) \<in> reliable sp \<and> inst \<in> arrow_srcs (arrow sp ind)}"

end
