theory Abs4_FetchDefs
  imports Abs4_CommonDefs
begin

definition fetch_same 
  :: "pub_indx \<Rightarrow> ('c, 'c :: size)abs4_monad" where
  fetch_same_def[monad_def]:
  "fetch_same pind = 
       <try>
           read pind Primary
       <catch> (\<lambda>e. case e of
            FailRead \<Rightarrow> sync pind Primary Secondary
            | Degraded v \<Rightarrow> 
                if v = EU
                then do {
                    cnt \<leftarrow> read_or_fail pind Secondary;
                    throw (Degraded (EC cnt))
                }
                else throw e
            | _ \<Rightarrow> throw e
        )
  "

definition fetch :: "pub_indx \<Rightarrow> ('c, 'c :: size)abs4_monad" where
  fetch_def[monad_def]:
  "fetch pind \<equiv> do {
    mode \<leftarrow> get_abs_mode;
    (if mode = ACFail
    then throw FailMode
    else return ()
    );
    dir \<leftarrow> get_arrow pind;
    cnt \<leftarrow> (if dir = SEq
    then fetch_same pind
    else read_or_fail pind (if dir = SR then Primary else Secondary));
    throw_abs_mode_error (EC cnt);
    return cnt
  }"

end
