theory Abs4_Invariant_Lemmas
imports Abs4_CommonDefs Abs4_StartupDefs "../Pmm_Lemmas" Abs4_UpdateDefs Abs4_FetchDefs
begin

lemmas brute_force =
  unfold_monad
  project_defs
  restart_mangle_sv_raw
  getters_setters
  modify_def
  choose_def
  put_def
  vol_ops_defs

lemma[no_throw]:
  "doesnt_throw_raw ((read_degrade_reliable pind inst)\<Down>NE) FailRead"
  "doesnt_throw_raw ((read_degrade_reliable pind inst)\<Down>NE) FailLLRead"
  "doesnt_throw_raw ((read_degrade_reliable pind inst)\<Down>NE) FailWrite"
  "doesnt_throw_raw ((read_degrade_reliable pind inst)\<Down>NE) FailMode"
  "doesnt_throw_raw ((read_degrade_reliable pind inst)\<Down>NE) StartedExc"
  "doesnt_throw_raw ((read_degrade_reliable pind inst)\<Down>NE) InvalidInput"
  "doesnt_throw_raw ((read_degrade pind inst)\<Down>NE) FailRead"
  "doesnt_throw_raw ((read_degrade pind inst)\<Down>NE) FailLLRead"
  "doesnt_throw_raw ((read_degrade pind inst)\<Down>NE) FailWrite"
  "doesnt_throw_raw ((read_degrade pind inst)\<Down>NE) FailMode"
  "doesnt_throw_raw ((read_degrade pind inst)\<Down>NE) StartedExc"
  "doesnt_throw_raw ((read_degrade pind inst)\<Down>NE) InvalidInput"
  "doesnt_throw_raw ((sync_success pind to from)\<Down>NE) FailRead"
  "doesnt_throw_raw ((sync_success pind to from)\<Down>NE) FailLLRead"
  "doesnt_throw_raw ((sync_success pind to from)\<Down>NE) FailWrite"
  "doesnt_throw_raw ((sync_success pind to from)\<Down>NE) FailMode"
  "\<forall>v. doesnt_throw_raw ((sync_success pind to from)\<Down>NE) (Degraded v)"
  "doesnt_throw_raw ((sync_success pind to from)\<Down>NE) StartedExc"
  "doesnt_throw_raw ((sync_success pind to from)\<Down>NE) InvalidInput"
  "doesnt_throw_raw ((sync_degrade pind to from)\<Down>NE) FailRead"
  "doesnt_throw_raw ((sync_degrade pind to from)\<Down>NE) FailLLRead"
  "doesnt_throw_raw ((sync_degrade pind to from)\<Down>NE) FailWrite"
  "doesnt_throw_raw ((sync_degrade pind to from)\<Down>NE) FailMode"
  "doesnt_throw_raw ((sync_degrade pind to from)\<Down>NE) StartedExc"
  "doesnt_throw_raw ((sync_degrade pind to from)\<Down>NE) InvalidInput"
  "doesnt_throw_raw ((sync_degrade_write pind to from)\<Down>NE) FailRead"
  "doesnt_throw_raw ((sync_degrade_write pind to from)\<Down>NE) FailLLRead"
  "doesnt_throw_raw ((sync_degrade_write pind to from)\<Down>NE) FailWrite"
  "doesnt_throw_raw ((sync_degrade_write pind to from)\<Down>NE) FailMode"
  "doesnt_throw_raw ((sync_degrade_write pind to from)\<Down>NE) StartedExc"
  "doesnt_throw_raw ((sync_degrade_write pind to from)\<Down>NE) InvalidInput"
  "doesnt_throw_raw ((sync_fail pind to from)\<Down>NE) FailRead"
  "doesnt_throw_raw ((sync_fail pind to from)\<Down>NE) FailLLRead"
  "doesnt_throw_raw ((sync_fail pind to from)\<Down>NE) FailWrite"
  "\<forall>v. doesnt_throw_raw ((sync_fail pind to from)\<Down>NE) (Degraded v)"
  "doesnt_throw_raw ((sync_fail pind to from)\<Down>NE) StartedExc"
  "doesnt_throw_raw ((sync_fail pind to from)\<Down>NE) InvalidInput"
  "doesnt_throw_raw ((sync_restart pind to from)\<Down>NE) FailRead"
  "doesnt_throw_raw ((sync_restart pind to from)\<Down>NE) FailLLRead"
  "doesnt_throw_raw ((sync_restart pind to from)\<Down>NE) FailWrite"
  "doesnt_throw_raw ((sync_restart pind to from)\<Down>NE) FailMode"
  "\<forall>v. doesnt_throw_raw ((sync_restart pind to from)\<Down>NE) (Degraded v)"
  "doesnt_throw_raw ((sync_restart pind to from)\<Down>NE) StartedExc"
  "doesnt_throw_raw ((sync_restart pind to from)\<Down>NE) InvalidInput"
  "doesnt_throw_raw ((sync_restart_write pind to from)\<Down>NE) FailRead"
  "doesnt_throw_raw ((sync_restart_write pind to from)\<Down>NE) FailLLRead"
  "doesnt_throw_raw ((sync_restart_write pind to from)\<Down>NE) FailWrite"
  "doesnt_throw_raw ((sync_restart_write pind to from)\<Down>NE) FailMode"
  "\<forall>v. doesnt_throw_raw ((sync_restart_write pind to from)\<Down>NE) (Degraded v)"
  "doesnt_throw_raw ((sync_restart_write pind to from)\<Down>NE) StartedExc"
  "doesnt_throw_raw ((sync_restart_write pind to from)\<Down>NE) InvalidInput"
  by(auto simp add: read_defs sync_defs doesnt_throw_raw_def project_defs)

definition arrow_is
  :: "sync_direction \<Rightarrow> pub_indx \<Rightarrow> ('sv \<times> 'c abs4_state) set" where
  "arrow_is dir pind  \<equiv> {(sva, spa). arrow spa pind = dir }"

lemma sync_post_NN:
  "\<lbrace>P\<rbrace>
    Abs4_CommonDefs.sync pind to from
  \<lbrace>>N K (arrow_is SEq pind) \<rbrace>
  "
  apply(clarsimp simp add: HoareNN_alt Hoare_def Box_def)
  apply(clarsimp_all simp add: first_stage Abs4_CommonDefs.sync_def choice_inv)
  apply(simp_all only: choice_def Un_iff, safe)
  apply(clarsimp_all simp add: brute_force Abs4_CommonDefs.sync_defs
    arrow_is_def
    split: split_if_asm exceptions.split_asm)
  done

lemma just_sync_post_NN:
  "\<lbrace>P\<rbrace>
    Abs4_CommonDefs.just_sync pind to from
  \<lbrace>>N K (arrow_is SEq pind) \<rbrace>
  "
  by(auto simp add: Abs4_CommonDefs.just_sync_def HoareNN_return' K_beta
    intro!: bind_ruleNN sync_post_NN)

lemma check_pub_same_arrow_inv_NN:
  "\<lbrace>arrow_is SEq pind'\<rbrace> Abs4_StartupDefs.check_pub_same pind \<lbrace>>N K (arrow_is SEq pind')\<rbrace>"
  apply(auto simp add: HoareNN_alt Hoare_def Box_def)
  apply(simp_all only: Abs4_StartupDefs.check_pub_same_def)
  apply(simp_all add: first_stage cong: exceptions.case_cong if_cong)
  apply(simp_all only: choice_def Un_iff, safe)
  apply(simp_all only: Abs4_CommonDefs.just_sync_silence_deg_def)
  apply(simp_all add: first_stage cong: exceptions.case_cong if_cong)
  apply(simp_all only: choice_def Un_iff, safe)
  apply(simp_all only: Abs4_StartupDefs.read_or_fail_silence_deg_def)
  apply(simp_all add: first_stage if_choice cong: exceptions.case_cong if_cong)
  apply(simp_all only: choice_def Un_iff, safe)
  apply(simp_all only: Abs4_CommonDefs.just_sync_def)
  apply(simp_all add: first_stage if_choice cong: exceptions.case_cong if_cong)
  using [[simp_depth_limit=0]]
  apply(clarsimp_all simp add: Abs4_CommonDefs.read_defs Abs4_CommonDefs.read_or_fail_defs
    Abs4_CommonDefs.sync_defs brute_force arrow_is_def
    split: exceptions.split_asm split_if_asm
  )
  apply(simp_all add:
    HOL.conj_disj_distribR HOL.conj_disj_distribL ex_disj_distrib conj_assoc
    ex_conj_distribs
  )
  apply(iterative_simp)+
  apply(case_tac[!] ab, simp_all add: all_conj)
  apply(iterative_simp)+
  apply(tactic {* Pmm_Tacs.full_dest_tac @{context} @{thms exc_exhaust} *}, simp_all)
  done

lemma read_proj_simps:
  "(read_success ind inst)\<Down>NE = empty"
  "(read_success ind inst)\<Down>R = empty"
  "(read_corrupt ind inst)\<Down>NN = empty"
  "(read_corrupt ind inst)\<Down>R = empty"
  "(read_degrade ind inst)\<Down>NN = empty"
  "(read_degrade ind inst)\<Down>R = empty"
  "(read_degrade_reliable ind inst)\<Down>NN = empty"
  "(read_degrade_reliable ind inst)\<Down>R = empty"
  "(focused_adm_fail ind inst)\<Down>NN = empty"
  "(focused_adm_fail ind inst)\<Down>R = empty"
  by(auto simp add: read_defs project_defs)

lemma sync_proj_simps:
  "(sync_success ind to from)\<Down>NE = empty"
  "(sync_success ind to from)\<Down>R = empty"
  "(sync_degrade ind to from)\<Down>NN = empty"
  "(sync_degrade ind to from)\<Down>R = empty"
  "(sync_degrade_write ind to from)\<Down>NN = empty"
  "(sync_degrade_write ind to from)\<Down>R = empty"
  "(sync_fail ind to from)\<Down>NN = empty"
  "(sync_fail ind to from)\<Down>R = empty"
  "(sync_restart ind to from)\<Down>NN = empty"
  "(sync_restart ind to from)\<Down>NE = empty"
  "(sync_restart_write ind to from)\<Down>NN = empty"
  "(sync_restart_write ind to from)\<Down>NE = empty"
  by(auto simp add: sync_defs brute_force)

definition both_insts_reliable where
  "both_insts_reliable ind \<equiv> {(sva, spa). abs_card_mode sva = ACNormal \<longrightarrow>
    (ind, Primary) \<in> reliable spa \<and> (ind, Secondary) \<in> reliable spa }"

lemma check_pub_same_reliable_post_NN:
  "\<lbrace>P\<rbrace> Abs4_StartupDefs.check_pub_same pind \<lbrace>>N K (both_insts_reliable pind)\<rbrace>"
  apply(auto simp add: HoareNN_alt Hoare_def Box_def)
  apply(rename_tac sva spa sva' spa')
  apply(simp_all only: Abs4_StartupDefs.check_pub_same_def)
  apply(simp_all add: first_stage cong: exceptions.case_cong if_cong)
  apply(simp_all only: choice_def Un_iff, safe)
  apply(simp_all only: Abs4_CommonDefs.just_sync_silence_deg_def)
  apply(simp_all add: first_stage cong: exceptions.case_cong if_cong)
  apply(simp_all only: choice_def Un_iff, safe)
  apply(simp_all only: Abs4_StartupDefs.read_or_fail_silence_deg_def)
  apply(simp_all add: first_stage if_choice cong: exceptions.case_cong if_cong)
  apply(simp_all only: choice_def Un_iff, safe)
  apply(simp_all only: Abs4_CommonDefs.just_sync_def)
  apply(simp_all add: first_stage if_choice cong: exceptions.case_cong if_cong)
  apply(simp_all only: Abs4_CommonDefs.read_def)
  apply(simp_all add: first_stage if_choice read_proj_simps restart_mangle_sv_proj_simps
    cong: exceptions.case_cong if_cong)
  apply(simp_all only: choice_def Un_iff, safe)
  apply(simp_all only: Abs4_CommonDefs.sync_def)
  apply(simp_all add: first_stage if_choice sync_proj_simps restart_mangle_sv_proj_simps
    cong: exceptions.case_cong if_cong)
  apply(simp_all only: choice_def Un_iff, safe)
  using [[simp_depth_limit=0]]
  apply(clarsimp_all simp add: Abs4_CommonDefs.read_defs Abs4_CommonDefs.read_or_fail_defs
    Abs4_CommonDefs.sync_defs brute_force both_insts_reliable_def
    split: exceptions.split_asm split_if_asm
  )
  apply(simp_all add: min_def split: split_if_asm)
  apply(iterative_simp)+
  apply(tactic {* Pmm_Tacs.full_dest_tac @{context} @{thms exc_exhaust} *}, simp_all)
  done

definition all_reliable_inv where
  "all_reliable_inv \<equiv> {(sva, spa). abs_card_mode sva = ACNormal \<longrightarrow> reliable spa = UNIV }"

lemma just_sync_reliable_post_NN:
  "to \<noteq> from \<Longrightarrow> \<lbrace>P\<rbrace> just_sync_silence_deg' to from pind \<lbrace>>N K (both_insts_reliable pind)\<rbrace>"
  apply(auto simp add: HoareNN_alt Hoare_def Box_def)
  apply(simp_all only: just_sync_silence_deg_def')
  apply(simp_all add: first_stage cong: exceptions.case_cong if_cong)
  apply(simp_all only: choice_def Un_iff, safe)
  apply(simp_all only: sync_def)
  apply(simp_all add: first_stage cong: exceptions.case_cong if_cong)
  apply(simp_all only: choice_def Un_iff, safe)
  apply(simp_all only: maybe_mess_up_admin_def)
  apply(simp_all add: first_stage cong: exceptions.case_cong if_cong)
  apply(simp_all only: choice_def Un_iff, safe)
  using [[simp_depth_limit=0]]
  using [[simproc del: Product_Type.split_beta]]
  apply(clarsimp_all simp add: brute_force sync_defs get_arrow_defs
    both_insts_reliable_def min_def
    split: exceptions.split_asm split_if_asm)
  apply(case_tac[!] to, clarsimp_all)
  done

lemma check_pub_region_reliable_post_NN:
  "\<lbrace>P\<rbrace> check_pub_region pind \<lbrace>>N K (both_insts_reliable pind)\<rbrace>"
  apply(auto simp add: Abs4_StartupDefs.check_pub_region_def intro!: bind_ruleNN)
  apply(auto intro!: check_pub_same_reliable_post_NN just_sync_reliable_post_NN
    intro: true_postNN simp add: K_beta)
  apply(auto simp add: HoareNN_alt Hoare_def Box_def
    maybe_mess_up_admin_def brute_force get_arrow_defs both_insts_reliable_def min_def 
    split: split_if_asm)
  done

lemma just_sync_preserves_reliable_post_NN:
  "to \<noteq> from \<Longrightarrow>
  \<lbrace>(both_insts_reliable pind')\<rbrace>
    just_sync_silence_deg' to from pind
  \<lbrace>>N K (both_insts_reliable pind')\<rbrace>"
  apply(auto simp add: HoareNN_alt Hoare_def Box_def)
  apply(simp_all only: just_sync_silence_deg_def')
  apply(simp_all add: first_stage cong: exceptions.case_cong if_cong)
  apply(simp_all only: choice_def Un_iff, safe)
  apply(simp_all only: sync_def)
  apply(simp_all add: first_stage cong: exceptions.case_cong if_cong)
  apply(simp_all only: choice_def Un_iff, safe)
  apply(simp_all only: maybe_mess_up_admin_def)
  apply(simp_all add: first_stage cong: exceptions.case_cong if_cong)
  apply(simp_all only: choice_def Un_iff, safe)
  using [[simp_depth_limit=0]]
  using [[simproc del: Product_Type.split_beta]]
  apply(clarsimp_all simp add: brute_force sync_defs get_arrow_defs
    both_insts_reliable_def min_def
    split: exceptions.split_asm split_if_asm)
  done

lemma check_pub_same_preserves_reliable_post_NN:
  "\<lbrace>(both_insts_reliable pind')\<rbrace>
    check_pub_same pind
  \<lbrace>>N K (both_insts_reliable pind')\<rbrace>"
  apply(auto simp add: HoareNN_alt Hoare_def Box_def)
  apply(rename_tac sva spa sva' spa')
  apply(simp_all only: Abs4_StartupDefs.check_pub_same_def)
  apply(simp_all add: first_stage cong: exceptions.case_cong if_cong)
  apply(simp_all only: choice_def Un_iff, safe)
  apply(simp_all only: Abs4_CommonDefs.just_sync_silence_deg_def)
  apply(simp_all add: first_stage cong: exceptions.case_cong if_cong)
  apply(simp_all only: choice_def Un_iff, safe)
  apply(simp_all only: Abs4_StartupDefs.read_or_fail_silence_deg_def)
  apply(simp_all add: first_stage if_choice cong: exceptions.case_cong if_cong)
  apply(simp_all only: choice_def Un_iff, safe)
  apply(simp_all only: Abs4_CommonDefs.just_sync_def)
  apply(simp_all add: first_stage if_choice cong: exceptions.case_cong if_cong)
  apply(simp_all only: Abs4_CommonDefs.read_def)
  apply(simp_all add: first_stage if_choice read_proj_simps restart_mangle_sv_proj_simps
    cong: exceptions.case_cong if_cong)
  apply(simp_all only: choice_def Un_iff, safe)
  apply(simp_all only: Abs4_CommonDefs.sync_def)
  apply(simp_all add: first_stage if_choice sync_proj_simps restart_mangle_sv_proj_simps
    cong: exceptions.case_cong if_cong)
  apply(simp_all only: choice_def Un_iff, safe)
  using [[simp_depth_limit=0]]
  apply(clarsimp_all simp add: Abs4_CommonDefs.read_defs Abs4_CommonDefs.read_or_fail_defs
    Abs4_CommonDefs.sync_defs brute_force both_insts_reliable_def
    split: exceptions.split_asm split_if_asm
  )
  apply(simp_all add: min_def split: split_if_asm)
  apply(iterative_simp)+
  apply(tactic {* Pmm_Tacs.full_dest_tac @{context} @{thms exc_exhaust} *}, simp_all)
  done

lemma check_pub_region_preserves_reliable_post_NN:
  "\<lbrace>both_insts_reliable pind'\<rbrace> check_pub_region pind \<lbrace>>N K (both_insts_reliable pind')\<rbrace>"
  apply(auto simp add: Abs4_StartupDefs.check_pub_region_def intro!: bind_ruleNN)
  apply(auto intro!: check_pub_same_preserves_reliable_post_NN just_sync_preserves_reliable_post_NN
    simp add: K_beta)
  apply(auto simp add: HoareNN_alt Hoare_def Box_def
    maybe_mess_up_admin_def brute_force get_arrow_defs both_insts_reliable_def min_def 
    split: split_if_asm)
  done

lemma check_all_public_post_NN:
  "\<lbrace>UNIV\<rbrace> check_all_public \<lbrace>>N K all_reliable_inv\<rbrace>"
proof(subst check_all_public_def, rule bind_ruleNN[OF chooseN_ruleNN], intro allI)
  fix l
  show "\<lbrace>if l \<in> order_set UNIV then UNIV else {}\<rbrace> mapM' check_pub_region l \<lbrace>>N K all_reliable_inv\<rbrace>"
  proof(cases "l \<in> order_set UNIV")
    case True
    thus ?thesis
    proof(simp)
      have characterization: "all_reliable_inv = (\<Inter>x' \<in> set l. both_insts_reliable x')"
        using order_set_set[OF True]
        apply(auto simp add: all_reliable_inv_def both_insts_reliable_def)
        apply (metis (full_types) INST.exhaust)
        done
      show "\<lbrace>UNIV\<rbrace> mapM' check_pub_region l \<lbrace>>N K all_reliable_inv\<rbrace>"
        by(auto simp add: characterization
          intro!: mapM'_ruleNN check_pub_region_reliable_post_NN true_postNN
          check_pub_region_preserves_reliable_post_NN)
    qed
  qed(auto simp add: ex_falsumNN)
qed

lemma startup_UNIV_post_NN:
  "\<lbrace>UNIV\<rbrace> startup \<lbrace>>N Q\<rbrace>"
  by(auto simp only: startup_def startup2_def
    intro!: bind_ruleNN HoareNN_throw intro: true_postNN)

lemma startup_post_NN:
  "\<lbrace>P\<rbrace> startup \<lbrace>>N Q\<rbrace>"
  by(blast intro: conseqNN_rule startup_UNIV_post_NN)

lemma check_pub_same_post_NE:
  "\<lbrace>UNIV\<rbrace>
    check_pub_same ind
  \<lbrace>@N (\<lambda>e. if e = FailMode then sv_abs_mode_equals ACFail else {})\<rbrace>"
  apply(auto simp add: HoareNE_alt Hoare_def Box_def split del: split_if)
  apply(rename_tac sva spa e sva' spa')
  apply(auto)
  apply(simp_all only: Abs4_StartupDefs.check_pub_same_def)
  apply(simp_all add: first_stage cong: exceptions.case_cong if_cong)
  apply(simp_all only: choice_def Un_iff, safe)
  apply(simp_all only: Abs4_CommonDefs.just_sync_silence_deg_def)
  apply(simp_all add: first_stage cong: exceptions.case_cong if_cong)
  apply(simp_all only: Abs4_StartupDefs.read_or_fail_silence_deg_def)
  apply(simp_all add: first_stage if_choice cong: exceptions.case_cong if_cong)
  apply(simp_all only: Abs4_CommonDefs.just_sync_def)
  apply(simp_all add: first_stage if_choice cong: exceptions.case_cong if_cong)
  apply(simp_all only: Abs4_CommonDefs.read_def)
  apply(simp_all add: first_stage if_choice read_proj_simps restart_mangle_sv_proj_simps
    cong: exceptions.case_cong if_cong)
  apply(simp_all only: choice_def Un_iff, safe)
  apply(simp_all only: Abs4_CommonDefs.sync_def)
  apply(simp_all add: first_stage if_choice sync_proj_simps restart_mangle_sv_proj_simps
    cong: exceptions.case_cong if_cong)
  apply(simp_all only: choice_def Un_iff, safe)
  using [[simp_depth_limit=0]]
  apply(clarsimp_all simp add: Abs4_CommonDefs.read_defs Abs4_CommonDefs.read_or_fail_defs
    Abs4_CommonDefs.sync_defs brute_force sv_abs_mode_equals_def
    split: exceptions.split_asm split_if_asm
  )
  using [[simp_depth_limit=5]]
  apply(clarsimp_all simp add: FailMode_exhaust)
  done

lemma just_sync_silence_deg'_post_NE:
  "\<lbrace>UNIV\<rbrace>
    just_sync_silence_deg' to from ind
  \<lbrace>@N (\<lambda>e. if e = FailMode then sv_abs_mode_equals ACFail else {})\<rbrace>"
  apply(auto simp add: HoareNE_alt Hoare_def Box_def split del: split_if)
  apply(rename_tac[!] sv sp e sv' sp')
  apply(auto)
  apply(simp_all only: just_sync_silence_deg_def')
  apply(simp_all add: first_stage cong: exceptions.case_cong if_cong)
  apply(simp_all only: choice_def Un_iff, safe)
  apply(simp_all only: sync_def)
  apply(simp_all add: first_stage cong: exceptions.case_cong if_cong)
  apply(simp_all only: choice_def Un_iff, safe)
  apply(simp_all only: maybe_mess_up_admin_def)
  apply(simp_all add: first_stage cong: exceptions.case_cong if_cong)
  apply(simp_all only: choice_def Un_iff, safe)
  using [[simp_depth_limit=0]]
  using [[simproc del: Product_Type.split_beta]]
  apply(clarsimp_all simp add: brute_force sync_defs get_arrow_defs
    sv_abs_mode_equals_def min_def
    split: exceptions.split_asm split_if_asm)
  done

lemma check_pub_region_post_NE:
  "\<lbrace>UNIV\<rbrace>
    check_pub_region ind
  \<lbrace>@N (\<lambda>e. if e = FailMode then sv_abs_mode_equals ACFail else {})\<rbrace>"
  apply(auto simp add: Abs4_StartupDefs.check_pub_region_def intro!: bind_ruleNE)
  apply(auto intro!: check_pub_same_post_NE just_sync_silence_deg'_post_NE
    intro: true_postNN
    simp add: K_beta)
  apply(auto simp add: HoareNE_alt Hoare_def Box_def
    maybe_mess_up_admin_def brute_force get_arrow_defs sv_abs_mode_equals_def min_def 
    split: split_if_asm)
  done

lemma check_all_public_post_NE:
  "\<lbrace>UNIV\<rbrace>
    check_all_public
  \<lbrace>@N (\<lambda>e. if e = FailMode then sv_abs_mode_equals ACFail else {})\<rbrace>"
  by(auto simp add: check_all_public_def K_beta
    intro!: bind_ruleNE mapM'_ruleNE check_pub_region_post_NE chooseN_ruleNE
    intro: true_postNN)

lemma startup1_post_NE:
  "\<lbrace>UNIV\<rbrace>
    startup1
  \<lbrace>@N (\<lambda>e. if e = FailMode then sv_abs_mode_equals ACFail else {})\<rbrace>"
  apply(auto simp add: HoareNE_alt Hoare_def Box_def startup1_def compose_project)
  apply(auto simp add: sv_abs_mode_equals_def startup1_NE_def)
  done

lemma startup1_all_reliable_NE:
  "\<lbrace>UNIV\<rbrace>
    startup1
  \<lbrace>@N K (all_reliable_inv)\<rbrace>"
  apply(rule conseqNE_rule[OF order_refl startup1_post_NE])
  apply(auto simp add: sv_abs_mode_equals_def all_reliable_inv_def K_def)
  done

lemma check_all_public_all_reliable_post_NE:
  "\<lbrace>UNIV\<rbrace>
    check_all_public
  \<lbrace>@N K (all_reliable_inv)\<rbrace>"
  apply(rule conseqNE_rule[OF order_refl check_all_public_post_NE])
  apply(auto simp add: sv_abs_mode_equals_def all_reliable_inv_def K_def)
  done

lemma HoareNE_vol_ops:
  "\<lbrace>P\<rbrace> set_abs_failed \<lbrace>@N Q\<rbrace>"
  "\<lbrace>P\<rbrace> set_abs_degraded \<lbrace>@N Q\<rbrace>"
  "\<lbrace>P\<rbrace> set_abs_updated pinds \<lbrace>@N Q\<rbrace>"
  "\<lbrace>P\<rbrace> get_abs_mode \<lbrace>@N Q\<rbrace>"
  "\<lbrace>P\<rbrace> add_to_abs_updated pind \<lbrace>@N Q\<rbrace>"
  "\<lbrace>P\<rbrace> get_abs_updated \<lbrace>@N Q\<rbrace>"
  by(auto simp add: HoareNE_alt Hoare_def Box_def vol_ops_defs project_defs getters_setters unfold_monad)

lemma HoareNN_get_abs_mode:
  "\<lbrace>P\<rbrace> get_abs_mode \<lbrace>>N K P\<rbrace>"
  by(auto simp add: HoareNN_alt Hoare_def Box_def vol_ops_defs project_defs getters_setters unfold_monad)

lemma startup_post_NE:
  "\<lbrace>UNIV\<rbrace> startup \<lbrace>@N K all_reliable_inv\<rbrace>"
  apply(auto simp add: startup_def startup2_def throw_abs_mode_error_def
    K_beta HoareNE_throw' HoareNN_return'
    intro!:
    bind_ruleNE
    bind_ruleNN
    startup1_all_reliable_NE
    check_all_public_post_NN
    check_all_public_all_reliable_post_NE
    HoareNE_return
    HoareNN_throw
    HoareNE_vol_ops
    HoareNN_get_abs_mode 
  )
  apply(auto intro: true_postNN[simplified K_def])
  done

lemma write_new_Secondary_arrow_post_NN:
  "\<lbrace>P\<rbrace> Abs4_CommonDefs.write_new ind Secondary cnt \<lbrace>>N K (arrow_is SR ind \<union> arrow_is SEq ind)\<rbrace>"
  apply(auto simp add: HoareNN_alt Hoare_def Box_def K_beta)
  apply(auto simp add: write_new_defs brute_force arrow_is_def)
  done

lemma write_new_Secondary_all_reliable_post_NN:
  "\<lbrace>all_reliable_inv\<rbrace> Abs4_CommonDefs.write_new ind inst cnt \<lbrace>>N K all_reliable_inv\<rbrace>"
  apply(auto simp add: HoareNN_alt Hoare_def Box_def K_beta)
  apply(auto simp add: write_new_defs brute_force all_reliable_inv_def)
  done

definition abs_updated_not_SL where
  "abs_updated_not_SL \<equiv> {(sv, sp). 
    \<forall>ind. ind \<in> abs_updated sv \<longrightarrow> arrow sp ind \<in> {SR, SEq}}"

lemma sync_rollback_arrows_inv_NN:
  "\<lbrace>\<Inter>ind\<in>upd. arrow_is SEq ind \<union> arrow_is SR ind\<rbrace>
    sync ind to from
  \<lbrace>>N K (\<Inter>ind\<in>upd. arrow_is SEq ind \<union> arrow_is SR ind)\<rbrace>"
  apply(auto simp add: HoareNN_alt Hoare_def Box_def K_beta)
  apply(simp only: sync_def)
  apply(simp_all add: first_stage vol_ops_project_simps if_choice cong: exceptions.case_cong if_cong)
  apply(simp_all only: choice_def Un_iff, safe)
  apply(auto simp add: sync_defs arrow_is_def brute_force)
  done

lemma sync_rollback_arrows_inv_NE:
  "\<lbrace>\<Inter>ind\<in>upd. arrow_is SEq ind \<union> arrow_is SR ind\<rbrace>
    sync ind to from
  \<lbrace>@N \<lambda>e. if e = FailMode then UNIV else (\<Inter>ind\<in>upd. arrow_is SEq ind \<union> arrow_is SR ind)\<rbrace>"
  apply(auto simp add: HoareNE_alt Hoare_def Box_def K_beta)
  apply(simp only: sync_def)
  apply(simp_all add: first_stage vol_ops_project_simps if_choice cong: exceptions.case_cong if_cong)
  apply(simp_all only: choice_def Un_iff, safe)
  apply(auto simp add: sync_defs arrow_is_def brute_force)
  apply(metis)+
  done

lemma get_arrow_rollback_inv_NN:
  "\<lbrace>\<Inter>ind\<in>upd. arrow_is SEq ind \<union> arrow_is SR ind\<rbrace> get_arrow ind
  \<lbrace>>N K (\<Inter>ind\<in>upd. arrow_is SEq ind \<union> arrow_is SR ind)\<rbrace>"
  apply(auto simp add: HoareNN_alt Hoare_def Box_def)
  apply(rename_tac sv sp v sv' sp')
  apply(auto simp only: get_arrow_defs brute_force arrow_is_def)
  apply(case_tac sp, auto)
  done

lemma get_arrow_rollback_inv_NE:
  "\<lbrace>\<Inter>ind\<in>upd. arrow_is SEq ind \<union> arrow_is SR ind\<rbrace> get_arrow ind
  \<lbrace>@N \<lambda>e. if e = FailMode then UNIV else (\<Inter>ind\<in>upd. arrow_is SEq ind \<union> arrow_is SR ind)\<rbrace>"
  apply(auto simp add: HoareNE_alt Hoare_def Box_def)
  apply(rename_tac sv sp e sv' sp' ind')
  apply(auto simp only: get_arrow_defs brute_force arrow_is_def)
  done

lemma maybe_mess_up_admin_rollback_inv_NN:
  "\<lbrace>\<Inter>ind\<in>upd. arrow_is SEq ind \<union> arrow_is SR ind\<rbrace>
  maybe_mess_up_admin ind
  \<lbrace>>N K (\<Inter>ind\<in>upd. arrow_is SEq ind \<union> arrow_is SR ind)\<rbrace>"
  apply(auto simp add: HoareNN_alt Hoare_def Box_def)
  apply(rename_tac sv sp sv' sp')
  apply(auto simp add: maybe_mess_up_admin_def get_arrow_defs brute_force arrow_is_def)
  done

lemma maybe_mess_up_admin_rollback_inv_NE:
  "\<lbrace>\<Inter>ind\<in>upd. arrow_is SEq ind \<union> arrow_is SR ind\<rbrace>
  maybe_mess_up_admin ind
  \<lbrace>@N \<lambda>e. if e = FailMode then UNIV else (\<Inter>ind\<in>upd. arrow_is SEq ind \<union> arrow_is SR ind)\<rbrace>"
  apply(auto simp add: HoareNE_alt Hoare_def Box_def)
  apply(rename_tac sv sp e sv' sp' ind')
  apply(auto simp add: maybe_mess_up_admin_def get_arrow_defs brute_force arrow_is_def)
  done

lemma sync_by_arrow_silence_deg_arrow_inv_NN:
  "\<lbrace>\<Inter>ind\<in>upd. arrow_is SEq ind \<union> arrow_is SR ind\<rbrace>
    sync_by_arrow_silence_deg ind
  \<lbrace>>N K (\<Inter>ind\<in>upd. arrow_is SEq ind \<union> arrow_is SR ind)\<rbrace>"
  by(auto simp add: HoareNN_return' HoareNE_throw' K_beta HoareNN_choice HoareNE_choice
    sync_by_arrow_silence_deg_def
    just_sync_silence_deg_def'
    intro!: HoareNN_throw HoareNE_return
    bind_ruleNN
    bind_ruleNE
    try_catch_ruleNN
    get_arrow_rollback_inv_NN
    get_arrow_rollback_inv_NE
    maybe_mess_up_admin_rollback_inv_NN
    maybe_mess_up_admin_rollback_inv_NE
    sync_rollback_arrows_inv_NN sync_rollback_arrows_inv_NE 
  )

lemma write_new_Secondary_abs_updated_post_NE:
  "\<lbrace>abs_updated_not_SL\<rbrace>
    (Abs4_CommonDefs.write_new ind Secondary cnt) 
  \<lbrace>@N \<lambda>e. if \<exists>v. e = Degraded v then abs_updated_not_SL else UNIV\<rbrace>
  "
  apply(auto simp add: HoareNE_alt Hoare_def Box_def K_beta)
  apply(rename_tac sv sp v sv' sp')
  apply(simp_all only: write_new_def)
  apply(simp_all add: first_stage vol_ops_project_simps if_choice cong: exceptions.case_cong if_cong)
  apply(simp_all only: choice_def Un_iff, safe)
  apply(tactic {* distinct_subgoals_tac *})
  apply(clarsimp_all simp add: write_new_defs brute_force abs_updated_not_SL_def
    split: split_if_asm)
  apply(case_tac[!] sp)
  apply(iterative_simp simp add: fun_upd_eq_iff split: split_if_asm)+
  apply(auto)
  done
 
lemma write_new_Secondary_abs_updated_post_NN:
  "\<lbrace>abs_updated_not_SL\<rbrace>
    (Abs4_CommonDefs.write_new ind Secondary cnt) 
  \<lbrace>>N K abs_updated_not_SL\<rbrace>
  "
  apply(auto simp add: HoareNN_alt Hoare_def Box_def K_beta)
  apply(rename_tac sv sp sv' sp')
  apply(simp_all only: write_new_def)
  apply(simp_all add: first_stage vol_ops_project_simps if_choice cong: exceptions.case_cong if_cong)
  apply(simp_all only: choice_def Un_iff, safe)
  apply(tactic {* distinct_subgoals_tac *})
  apply(clarsimp_all simp add: write_new_defs brute_force abs_updated_not_SL_def
    split: split_if_asm)
  done

lemma write_new_Secondary_post_NN:
  "\<lbrace>all_reliable_inv \<inter> abs_updated_not_SL\<rbrace>
  write_new ind Secondary (the (upd_f ind))
  \<lbrace>>N K (all_reliable_inv \<inter> abs_updated_not_SL)\<rbrace>"
  by(intro HoareNN_Int write_new_Secondary_all_reliable_post_NN
        write_new_Secondary_abs_updated_post_NN)


definition abs_updated_not_SR where
  "abs_updated_not_SR \<equiv> {(sv, sp). 
    \<forall>ind. ind \<in> abs_updated sv \<longrightarrow> arrow sp ind \<in> {SL, SEq}}"

lemma switch_arrows_post_NN:
  "\<lbrace>all_reliable_inv \<inter> abs_updated_not_SL \<inter> abs_updated_equals pinds\<rbrace>
    switch_arrows pinds \<lbrace>>N K (all_reliable_inv \<inter> abs_updated_not_SR)\<rbrace>"
  apply(auto simp add: HoareNN_alt Hoare_def Box_def)
  apply(simp only: switch_arrows_def)
  apply(simp_all add: first_stage vol_ops_project_simps if_choice cong: exceptions.case_cong if_cong)
  apply(simp_all only: choice_def Un_iff, safe)
  apply(auto simp add: abs_updated_not_SL_def abs_updated_equals_def abs_updated_not_SR_def all_reliable_inv_def
    switch_arrows_defs brute_force)
  done

lemma switch_arrows_post_NE:
  "\<lbrace>all_reliable_inv \<inter> abs_updated_not_SL \<inter> abs_updated_equals pinds\<rbrace> switch_arrows pinds \<lbrace>@N
    \<lambda>e. if e = Degraded (EB True)
        then all_reliable_inv \<inter> abs_updated_not_SR
        else if \<exists>v. e = Degraded v
            then all_reliable_inv \<inter> abs_updated_not_SL
            else UNIV \<rbrace>"
  apply(auto simp add: HoareNE_alt Hoare_def Box_def)
  apply(simp only: switch_arrows_def)
  apply(simp_all add: first_stage vol_ops_project_simps if_choice cong: exceptions.case_cong if_cong)
  apply(simp_all only: choice_def Un_iff, safe)
  apply(auto simp add: abs_updated_not_SL_def abs_updated_equals_def abs_updated_not_SR_def
    switch_arrows_defs brute_force all_reliable_inv_def min_def split: split_if_asm)
  done

lemma just_sync_silence_deg'_rollforward_post_NN:
  "\<lbrace>(all_reliable_inv \<inter> (abs_updated_not_SR \<inter> abs_updated_equals pinds))\<rbrace>
    Abs4_CommonDefs.just_sync_silence_deg' to from pind
  \<lbrace>>N K (all_reliable_inv \<inter> (abs_updated_not_SR \<inter> abs_updated_equals pinds))\<rbrace>"
  apply(auto simp add: HoareNN_alt Hoare_def Box_def)
  apply(simp_all only: just_sync_silence_deg_def')
  apply(simp_all add: first_stage vol_ops_project_simps if_choice cong: exceptions.case_cong if_cong)
  apply(simp_all only: choice_def Un_iff, safe)
  apply(simp_all only: sync_def)
  apply(simp_all add: first_stage vol_ops_project_simps if_choice cong: exceptions.case_cong if_cong)
  apply(simp_all only: choice_def Un_iff, safe)
  apply(simp_all only: maybe_mess_up_admin_def)
  apply(simp_all add: first_stage vol_ops_project_simps if_choice cong: exceptions.case_cong if_cong)
  apply(simp_all only: choice_def Un_iff, safe)
  apply(clarsimp_all simp add: sync_defs brute_force all_reliable_inv_def abs_updated_not_SR_def
    get_arrow_defs min_def
    abs_updated_equals_def insert_UNIV split: split_if_asm)
  apply(auto)
  done

lemma get_arrow_proj_simps:
  "(get_arrow_success ind)\<Down>NE = empty"
  "(get_arrow_success ind)\<Down>R = empty"
  "(get_arrow_degrade ind)\<Down>NE = empty"
  "(get_arrow_degrade ind)\<Down>R = empty"
  "(get_arrow_fail ind)\<Down>NN = empty"
  "(get_arrow_fail ind)\<Down>R = empty"
  "(get_arrow_restart ind)\<Down>NN = empty"
  "(get_arrow_restart ind)\<Down>NE = empty"
  by(auto simp add: get_arrow_defs brute_force)

lemma get_arrow_all_reliable_inv_NN:
  "\<lbrace>all_reliable_inv\<rbrace> get_arrow ind \<lbrace>>N K all_reliable_inv\<rbrace>"
  apply(auto simp add: HoareNN_alt Hoare_def Box_def K_beta)
  apply(auto simp add: get_arrow_defs brute_force all_reliable_inv_def min_def
    split: split_if_asm)
  done
  
lemma get_arrow_all_reliable_inv_NE:
  "\<lbrace>all_reliable_inv\<rbrace> get_arrow ind \<lbrace>@N K all_reliable_inv\<rbrace>"
  apply(auto simp add: HoareNE_alt Hoare_def Box_def K_beta)
  apply(auto simp add: get_arrow_defs brute_force all_reliable_inv_def min_def
    split: split_if_asm)
  done
 
lemma sync_all_reliable_inv_NN:
  "\<lbrace>all_reliable_inv\<rbrace> sync ind to from \<lbrace>>N K all_reliable_inv\<rbrace> "
  apply(auto simp add: HoareNN_alt Hoare_def Box_def K_beta)
  apply(auto simp add: sync_defs brute_force all_reliable_inv_def min_def
    split: split_if_asm)
  done

lemma sync_mode_post_NE:
  "\<lbrace>P\<rbrace> sync ind to from \<lbrace>@N K (sv_abs_mode_neq ACNormal)\<rbrace>"
  apply(auto simp add: HoareNE_alt Hoare_def Box_def K_beta)
  apply(auto simp add: sync_defs brute_force sv_abs_mode_neq_def min_def
    split: split_if_asm)
  done

lemma sync_all_reliable_inv_NE:
  "\<lbrace>all_reliable_inv\<rbrace> sync ind to from \<lbrace>@N K all_reliable_inv\<rbrace> "
  apply(rule conseqNE_rule[OF order_refl sync_mode_post_NE])
  apply(clarsimp_all simp add: K_beta all_reliable_inv_def sv_abs_mode_neq_def)
  done
 
lemma maybe_mess_up_admin_all_reliable_inv_NN:
  "\<lbrace>all_reliable_inv\<rbrace> maybe_mess_up_admin ind \<lbrace>>N K all_reliable_inv\<rbrace>"
  apply(auto simp add: HoareNN_alt Hoare_def Box_def K_beta)
  apply(auto simp add: maybe_mess_up_admin_def get_arrow_defs brute_force all_reliable_inv_def min_def
    split: split_if_asm)
  done
  
lemma maybe_mess_up_admin_all_reliable_inv_NE:
  "\<lbrace>all_reliable_inv\<rbrace> maybe_mess_up_admin ind \<lbrace>@N K all_reliable_inv\<rbrace>"
  apply(auto simp add: HoareNE_alt Hoare_def Box_def K_beta)
  apply(auto simp add: maybe_mess_up_admin_def get_arrow_defs brute_force all_reliable_inv_def min_def
    split: split_if_asm)
  done
 
lemma sync_by_arrow_silence_deg_all_reliable_inv_NN:
  "\<lbrace>all_reliable_inv\<rbrace> sync_by_arrow_silence_deg ind \<lbrace>>N K all_reliable_inv\<rbrace>"
  apply(auto simp add: HoareNN_return' K_beta
    sync_by_arrow_silence_deg_def
    just_sync_silence_deg_def'
    intro!:
    HoareNN_throw
    get_arrow_all_reliable_inv_NN
    sync_all_reliable_inv_NN
    sync_all_reliable_inv_NE
    maybe_mess_up_admin_all_reliable_inv_NN
    maybe_mess_up_admin_all_reliable_inv_NE
    bind_ruleNN_same
    bind_ruleNE_same
    try_catch_ruleNN_same
  )
  done

lemma sync_by_arrow_silence_deg_all_reliable_inv_NE:
  "\<lbrace>all_reliable_inv\<rbrace> sync_by_arrow_silence_deg ind \<lbrace>@N K all_reliable_inv\<rbrace>"
  apply(auto simp add: HoareNN_return' HoareNE_throw' K_beta
    sync_by_arrow_silence_deg_def
    just_sync_silence_deg_def'
    intro!:
    HoareNN_throw
    HoareNE_return
    get_arrow_all_reliable_inv_NN
    get_arrow_all_reliable_inv_NE
    sync_all_reliable_inv_NN
    sync_all_reliable_inv_NE
    maybe_mess_up_admin_all_reliable_inv_NN
    maybe_mess_up_admin_all_reliable_inv_NE
    bind_ruleNN_same
    bind_ruleNE_same
    try_catch_ruleNN_same
    try_catch_ruleNE
  )
  done

lemma get_abs_updated_post_NN:
  "\<lbrace>P\<rbrace> get_abs_updated \<lbrace>>N K P\<rbrace>"
  by(auto simp add: HoareNN_alt Hoare_def Box_def brute_force)

lemma get_abs_updated_post_NN':
  "\<lbrace>P\<rbrace> get_abs_updated \<lbrace>>N abs_updated_equals \<rbrace>"
  by(auto simp add: HoareNN_alt Hoare_def Box_def vol_ops_defs getters_setters unfold_monad
    project_defs abs_updated_equals_def)

lemma set_abs_updated_all_reliable_inv_NN:
  "\<lbrace>all_reliable_inv\<rbrace> set_abs_updated pinds \<lbrace>>N K all_reliable_inv\<rbrace>"
  by(auto simp add: HoareNN_alt Hoare_def Box_def brute_force all_reliable_inv_def)

lemma rollback_post_NN:
  "\<lbrace>P\<rbrace> rollback \<lbrace>>N Q\<rbrace>"
  apply(auto simp add: HoareNN_return' K_beta
    rollback_def
    intro!:
    HoareNN_throw
    bind_ruleNN
    true_postNN
  )
  done

lemma rollback_all_reliable_inv_NE:
  "\<lbrace>all_reliable_inv\<rbrace> rollback \<lbrace>@N K all_reliable_inv\<rbrace>"
  apply(auto simp add: HoareNN_return' HoareNE_throw' K_beta 
    rollback_def
    sync_updated_def
    intro!:
    HoareNN_throw
    chooseN_inv_NN
    chooseN_ruleNE
    HoareNE_vol_ops
    get_abs_updated_post_NN
    set_abs_updated_all_reliable_inv_NN
    get_arrow_all_reliable_inv_NN
    sync_by_arrow_silence_deg_all_reliable_inv_NN
    sync_by_arrow_silence_deg_all_reliable_inv_NE
    bind_ruleNN_same
    bind_ruleNE_same
    mapM'_invNN
    mapM'_ruleNE
    try_catch_ruleNN_same
  )
  done

lemma set_abs_updated_no_mode_upgrade_NN:
  "\<lbrace>sv_abs_mode_neq ACNormal\<rbrace> set_abs_updated {} \<lbrace>>N K (sv_abs_mode_neq ACNormal)\<rbrace>"
  by(auto simp add: HoareNN_alt Hoare_def Box_def sv_abs_mode_neq_def brute_force)

lemma get_arrow_no_mode_upgrade_NN:
  "\<lbrace>sv_abs_mode_neq ACNormal\<rbrace> get_arrow ind \<lbrace>>N K (sv_abs_mode_neq ACNormal)\<rbrace>"
  apply(auto simp add: HoareNN_alt Hoare_def Box_def sv_abs_mode_neq_def brute_force)
  apply(auto simp add: get_arrow_defs brute_force min_def split: split_if_asm)
  done

lemma get_arrow_mode_post_NE:
  "\<lbrace>P\<rbrace> get_arrow ind \<lbrace>@N K (sv_abs_mode_neq ACNormal)\<rbrace>"
  apply(auto simp add: HoareNE_alt Hoare_def Box_def sv_abs_mode_neq_def brute_force)
  apply(auto simp add: get_arrow_defs brute_force min_def split: split_if_asm)
  done

lemma sync_no_mode_upgrade_NN:
  "\<lbrace>sv_abs_mode_neq ACNormal\<rbrace> sync ind to from \<lbrace>>N K (sv_abs_mode_neq ACNormal)\<rbrace> "
  apply(auto simp add: HoareNN_alt Hoare_def Box_def sv_abs_mode_neq_def brute_force)
  apply(auto simp add: sync_defs brute_force min_def split: split_if_asm)
  done

lemma maybe_mess_up_admin_no_mode_upgrade_NN:
  "\<lbrace>sv_abs_mode_neq ACNormal\<rbrace> maybe_mess_up_admin ind \<lbrace>>N K (sv_abs_mode_neq ACNormal)\<rbrace>"
  apply(auto simp add: HoareNN_alt Hoare_def Box_def sv_abs_mode_neq_def brute_force)
  apply(auto simp add: maybe_mess_up_admin_def get_arrow_defs brute_force min_def
    split: split_if_asm)
  done

lemma maybe_mess_up_admin_mode_post_NE:
  "\<lbrace>P\<rbrace> maybe_mess_up_admin ind \<lbrace>@N K (sv_abs_mode_neq ACNormal)\<rbrace>"
  apply(auto simp add: HoareNE_alt Hoare_def Box_def sv_abs_mode_neq_def brute_force)
  apply(auto simp add: maybe_mess_up_admin_def get_arrow_defs brute_force min_def
    split: split_if_asm)
  done

lemma sync_by_arrow_no_mode_upgrade_NN:
  "\<lbrace>sv_abs_mode_neq ACNormal\<rbrace> sync_by_arrow_silence_deg ind \<lbrace>>N K (sv_abs_mode_neq ACNormal)\<rbrace>"
  apply(auto simp add: HoareNN_return' K_beta
    sync_by_arrow_silence_deg_def
    just_sync_silence_deg_def'
    intro!:
    HoareNN_throw
    get_arrow_no_mode_upgrade_NN
    get_arrow_mode_post_NE
    sync_no_mode_upgrade_NN
    sync_mode_post_NE
    maybe_mess_up_admin_no_mode_upgrade_NN
    maybe_mess_up_admin_mode_post_NE
    bind_ruleNN_same
    bind_ruleNE_same
    try_catch_ruleNN_same
  )
  apply(tactic {* distinct_subgoals_tac *})
  done

lemma sync_by_arrow_mode_post_NE:
  "\<lbrace>P\<rbrace> sync_by_arrow_silence_deg ind \<lbrace>@N K (sv_abs_mode_neq ACNormal)\<rbrace>"
  apply(auto simp add: HoareNN_return' HoareNE_throw' K_beta
    sync_by_arrow_silence_deg_def
    just_sync_silence_deg_def'
    intro!:
    bind_ruleNN
    bind_ruleNE
    HoareNN_throw
    HoareNE_return
    try_catch_ruleNN
    try_catch_ruleNE
    get_arrow_mode_post_NE
    sync_mode_post_NE
    maybe_mess_up_admin_mode_post_NE
    del: subsetI
  )
  apply(auto simp add: K_beta
    intro!: maybe_mess_up_admin_mode_post_NE sync_mode_post_NE del: subsetI
    intro: true_postNN
  )
  done

lemma rollback_no_mode_upgrade_NE:
  "\<lbrace> sv_abs_mode_neq ACNormal \<rbrace> rollback \<lbrace>@N K (sv_abs_mode_neq ACNormal)\<rbrace>"
  apply(auto simp add: HoareNN_return' HoareNE_throw' K_beta 
    rollback_def
    sync_updated_def
    intro!:
    HoareNN_throw
    chooseN_inv_NN
    chooseN_ruleNE
    HoareNE_vol_ops
    get_abs_updated_post_NN
    sync_by_arrow_no_mode_upgrade_NN
    sync_by_arrow_mode_post_NE
    set_abs_updated_no_mode_upgrade_NN
    bind_ruleNN_same
    bind_ruleNE_same
    mapM'_invNN
    mapM'_ruleNE
    try_catch_ruleNN_same
  )
  done

lemma rollforward_all_reliable_inv_NN:
  "\<lbrace>all_reliable_inv\<rbrace> rollforward \<lbrace>>N K all_reliable_inv \<rbrace>"
  by(auto simp add:
    rollforward_def
    sync_updated_def
    intro!:
    bind_ruleNN_same
    mapM'_invNN
    set_abs_updated_all_reliable_inv_NN
    get_abs_updated_post_NN
    chooseN_inv_NN
    sync_by_arrow_silence_deg_all_reliable_inv_NN
  )

lemma rollforward_mode_post_NE':
  "\<lbrace>UNIV\<rbrace> rollforward \<lbrace>@N K (sv_abs_mode_neq ACNormal) \<rbrace>"
  by(auto simp add: K_beta
    rollforward_def
    sync_updated_def
    intro!:
    bind_ruleNE
    mapM'_invNN
    mapM'_ruleNE
    HoareNE_vol_ops
    get_abs_updated_post_NN
    chooseN_ruleNE
    chooseN_inv_NN
    sync_by_arrow_silence_deg_all_reliable_inv_NN
    sync_by_arrow_mode_post_NE
    intro: true_postNN
  )

lemma rollforward_mode_post_NE:
  "\<lbrace>P\<rbrace> rollforward \<lbrace>@N K (sv_abs_mode_neq ACNormal) \<rbrace>"
  by(auto intro: conseqNE_rule intro!: rollforward_mode_post_NE')

definition not_abs_updated_are_SEq where
  "not_abs_updated_are_SEq \<equiv> {(svc, spc). abs_card_mode svc = ACNormal \<longrightarrow>
    (\<forall>ind. ind \<notin> abs_updated svc \<longrightarrow> arrow spc ind = SEq)}"

lemma switch_arrows_preserves_SEq_NN:
  "\<lbrace>not_abs_updated_are_SEq\<rbrace> switch_arrows inds \<lbrace>>N K not_abs_updated_are_SEq\<rbrace>"
  apply(auto simp add: HoareNN_alt Hoare_def Box_def K_beta)
  apply(auto simp add: not_abs_updated_are_SEq_def switch_arrows_defs brute_force override_on_def)
  done

lemma switch_arrows_preserves_SEq_NE:
  "\<lbrace>not_abs_updated_are_SEq\<rbrace> switch_arrows inds \<lbrace>@N K not_abs_updated_are_SEq\<rbrace>"
  apply(auto simp add: HoareNE_alt Hoare_def Box_def K_beta)
  apply(auto simp add: not_abs_updated_are_SEq_def switch_arrows_defs brute_force override_on_def
    min_def split: split_if_asm)
  done

lemma do_commit_preserves_SEq_NN:
  "\<lbrace>not_abs_updated_are_SEq\<rbrace> do_commit \<lbrace>>N K not_abs_updated_are_SEq \<rbrace>"
  by(auto simp add: K_beta HoareNN_return'
    do_commit_def
    intro!:
    bind_ruleNN
    try_catch_ruleNN
    rollback_post_NN
    HoareNN_throw 
    get_abs_updated_post_NN
    switch_arrows_preserves_SEq_NN
    switch_arrows_preserves_SEq_NE
    split: exceptions.split
  )

definition all_SEq where
  "all_SEq \<equiv> {(svc, spc). abs_card_mode svc = ACNormal \<longrightarrow> (\<forall>ind. arrow spc ind = SEq)}"

lemma get_arrow_intact_SEq_NN:
  "\<lbrace>not_abs_updated_are_SEq\<rbrace> get_arrow x \<lbrace>>N K not_abs_updated_are_SEq\<rbrace>"
  apply(auto simp add: HoareNN_alt Hoare_def Box_def K_beta)
  apply(auto simp add: not_abs_updated_are_SEq_def get_arrow_defs brute_force min_def
    split: split_if_asm)
  done

lemma sync_intact_SEq_NN:
  "\<lbrace>not_abs_updated_are_SEq\<rbrace> sync ind to from \<lbrace>>N K not_abs_updated_are_SEq\<rbrace>"
  apply(auto simp add: HoareNN_alt Hoare_def Box_def K_beta)
  apply(auto simp add: not_abs_updated_are_SEq_def sync_defs brute_force min_def
    split: split_if_asm)
  done

lemma maybe_mess_up_admin_intact_SEq_NN:
  "\<lbrace>not_abs_updated_are_SEq\<rbrace> maybe_mess_up_admin x \<lbrace>>N K not_abs_updated_are_SEq\<rbrace> "
  apply(auto simp add: HoareNN_alt Hoare_def Box_def K_beta)
  apply(auto simp add: not_abs_updated_are_SEq_def get_arrow_defs brute_force min_def
    maybe_mess_up_admin_def split: split_if_asm)
  done

lemma sync_by_arrow_silence_deg_intact_SEq_NN:
  "\<lbrace>not_abs_updated_are_SEq\<rbrace> mapM' sync_by_arrow_silence_deg xa \<lbrace>>N K not_abs_updated_are_SEq \<rbrace>"
  apply(rule mapM'_invNN)
  apply(auto simp add: HoareNN_return' K_beta
    sync_by_arrow_silence_deg_def
    just_sync_silence_deg_def'
    intro!:
    bind_ruleNN_same
    try_catch_ruleNN
    try_catch_ruleNE
    bind_ruleNE
    HoareNN_throw
    get_arrow_intact_SEq_NN
    conseqNE_rule[OF subset_UNIV sync_mode_post_NE _]
    conseqNE_rule[OF subset_UNIV maybe_mess_up_admin_mode_post_NE _]
  )
  apply(auto simp add: K_beta
    intro!: sync_intact_SEq_NN maybe_mess_up_admin_intact_SEq_NN
  )
  apply(auto simp add: sv_abs_mode_neq_def not_abs_updated_are_SEq_def)
  done

definition abs_updated_are_SEq where
  "abs_updated_are_SEq \<equiv> {(sv, sp). abs_card_mode sv = ACNormal \<longrightarrow> (\<forall>ind \<in> abs_updated sv. arrow sp ind = SEq) }"

lemma get_arrow_intact_abs_updated_NN:
  "\<lbrace>abs_updated_equals A\<rbrace> get_arrow ind \<lbrace>>N K (abs_updated_equals A)\<rbrace>"
  apply(auto simp add: HoareNN_alt Hoare_def Box_def K_beta)
  apply(auto simp add: abs_updated_equals_def get_arrow_defs brute_force min_def
    split: split_if_asm)
  done

lemma sync_intact_abs_updated_NN:
  "\<lbrace>abs_updated_equals A\<rbrace> sync ind to frm \<lbrace>>N K (abs_updated_equals A)\<rbrace>"
  apply(auto simp add: HoareNN_alt Hoare_def Box_def K_beta)
  apply(auto simp add: abs_updated_equals_def sync_defs brute_force min_def
    split: split_if_asm)
  done

lemma sync_intact_abs_updated_NE:
  "\<lbrace>abs_updated_equals A\<rbrace> sync ind to frm \<lbrace>@N K (abs_updated_equals A)\<rbrace>"
  apply(auto simp add: HoareNE_alt Hoare_def Box_def K_beta)
  apply(auto simp add: abs_updated_equals_def sync_defs brute_force min_def
    split: split_if_asm)
  done

lemma maybe_mess_up_admin_intact_abs_updated_NN:
  "\<lbrace>abs_updated_equals A\<rbrace> maybe_mess_up_admin ind \<lbrace>>N K (abs_updated_equals A)\<rbrace>"
  apply(auto simp add: HoareNN_alt Hoare_def Box_def K_beta)
  apply(auto simp add: abs_updated_equals_def get_arrow_defs brute_force min_def
    maybe_mess_up_admin_def split: split_if_asm)
  done

lemma maybe_mess_up_admin_intact_abs_updated_NE:
  "\<lbrace>abs_updated_equals A\<rbrace> maybe_mess_up_admin ind \<lbrace>@N K (abs_updated_equals A)\<rbrace>"
  apply(auto simp add: HoareNE_alt Hoare_def Box_def K_beta)
  apply(auto simp add: abs_updated_equals_def get_arrow_defs brute_force min_def
    maybe_mess_up_admin_def split: split_if_asm)
  done

lemma sync_by_arrow_silence_deg_intact_abs_updated_NN:
  "\<lbrace>abs_updated_equals A\<rbrace> sync_by_arrow_silence_deg ind \<lbrace>>N K (abs_updated_equals A)\<rbrace>"
  apply(auto simp add: HoareNN_return' K_beta
    sync_by_arrow_silence_deg_def
    just_sync_silence_deg_def'
    intro!:
    HoareNN_throw
    bind_ruleNN
    bind_ruleNE
    try_catch_ruleNN
    get_arrow_intact_abs_updated_NN
    sync_intact_abs_updated_NN
    maybe_mess_up_admin_intact_abs_updated_NN
    maybe_mess_up_admin_intact_abs_updated_NE
  )
   apply(auto  simp add: K_beta
     intro!:
     sync_intact_abs_updated_NN
     sync_intact_abs_updated_NE
     maybe_mess_up_admin_intact_abs_updated_NN
     maybe_mess_up_admin_intact_abs_updated_NE
     sync_intact_abs_updated_NE[simplified K_def]
     maybe_mess_up_admin_intact_abs_updated_NE[simplified K_def]
   )
   done

definition if_CNormal_arrow_is
  :: "sync_direction \<Rightarrow> pub_indx \<Rightarrow> (abs_vol_mem \<times> 'c abs4_state) set" where
  "if_CNormal_arrow_is dir pind  \<equiv> {(sv, sp). abs_card_mode sv = ACNormal \<longrightarrow> arrow sp pind = dir }"

lemma get_arrow_arrow_post_NN:
  "\<lbrace>P\<rbrace> get_arrow ind \<lbrace>>N \<lambda>arr. if arr \<noteq> SBot then arrow_is arr ind else {}\<rbrace>"
  apply(auto simp add: HoareNN_alt Hoare_def Box_def K_beta)
  apply(auto simp add: get_arrow_defs arrow_is_def brute_force min_def split: split_if_asm)
  done

lemma maybe_mess_up_admin_arrow_intact_NN:
  "\<lbrace>arrow_is arr ind'\<rbrace> maybe_mess_up_admin ind \<lbrace>>N K (arrow_is arr ind')\<rbrace>"
  apply(auto simp add: HoareNN_alt Hoare_def Box_def K_beta)
  apply(auto simp add: arrow_is_def get_arrow_defs brute_force min_def
    maybe_mess_up_admin_def split: split_if_asm)
  done

lemma arrow_is_imp_if_CNormal:
  "arrow_is arr ind \<subseteq> if_CNormal_arrow_is arr ind"
  by(auto simp add: arrow_is_def if_CNormal_arrow_is_def)

lemma not_CNormal_imp_if_CNormal:
  "sv_abs_mode_neq ACNormal \<subseteq> if_CNormal_arrow_is arr ind"
  by(auto simp add: sv_abs_mode_neq_def if_CNormal_arrow_is_def)

lemma just_sync_silence_deg'_tgt_SEq_post_NN:
  "\<lbrace>P\<rbrace> just_sync_silence_deg' to from ind \<lbrace>>N K (if_CNormal_arrow_is SEq ind)\<rbrace>"
  apply(auto simp add: K_beta HoareNN_return'
    just_sync_silence_deg_def'
    intro!:
    bind_ruleNN
    bind_ruleNE
    HoareNN_throw
    try_catch_ruleNN
    sync_post_NN
    conseqNN_rule[OF _ maybe_mess_up_admin_arrow_intact_NN _]
    maybe_mess_up_admin_mode_post_NE

  )
  apply(auto intro:
    arrow_is_imp_if_CNormal[THEN subsetD]
    not_CNormal_imp_if_CNormal[THEN subsetD]
    sync_mode_post_NE
  )
  done

lemma sync_preserves_other_arr_NN:
  "ind' \<noteq> ind \<Longrightarrow>
  \<lbrace>if_CNormal_arrow_is arr ind'\<rbrace> sync ind to from \<lbrace>>N K (if_CNormal_arrow_is arr ind')\<rbrace>"
  apply(clarsimp simp add: HoareNN_alt Hoare_def Box_def)
  apply(clarsimp_all simp add: first_stage Abs4_CommonDefs.sync_def choice_inv)
  apply(simp_all only: choice_def Un_iff, safe)
  apply(clarsimp_all simp add: brute_force Abs4_CommonDefs.sync_defs
    if_CNormal_arrow_is_def
    split: split_if_asm exceptions.split_asm)
  done

lemma maybe_mess_up_admin_if_CNormal_arrow_intact_NN:
  "\<lbrace>if_CNormal_arrow_is arr ind'\<rbrace> maybe_mess_up_admin ind \<lbrace>>N K (if_CNormal_arrow_is arr ind')\<rbrace>"
  apply(auto simp add: HoareNN_alt Hoare_def Box_def K_beta)
  apply(auto simp add: if_CNormal_arrow_is_def get_arrow_defs brute_force min_def
    maybe_mess_up_admin_def split: split_if_asm)
  done

lemma just_sync_silence_deg'_other_SEq_post_NN:
  "ind' \<noteq> ind \<Longrightarrow>
    \<lbrace>if_CNormal_arrow_is arr ind'\<rbrace>
    just_sync_silence_deg' to from  ind
    \<lbrace>>N K (if_CNormal_arrow_is arr ind')\<rbrace>"
  by(auto simp add: K_beta HoareNN_return'
    just_sync_silence_deg_def'
    intro!:
    bind_ruleNN
    bind_ruleNE
    HoareNN_throw
    try_catch_ruleNN
    sync_preserves_other_arr_NN
    sync_mode_post_NE
    maybe_mess_up_admin_if_CNormal_arrow_intact_NN
    maybe_mess_up_admin_mode_post_NE
    not_CNormal_imp_if_CNormal[THEN subsetD]
  )
 
lemma sync_by_arrow_tgt_SEq_NN:
  "\<lbrace>P\<rbrace> sync_by_arrow_silence_deg ind \<lbrace>>N K (if_CNormal_arrow_is SEq ind)\<rbrace>"
  apply(auto simp add: K_beta HoareNN_return'
    sync_by_arrow_silence_deg_def
    intro!:
    bind_ruleNN
    bind_ruleNE
    HoareNN_throw
    try_catch_ruleNN
    get_arrow_arrow_post_NN
    just_sync_silence_deg'_tgt_SEq_post_NN
    conseqNN_rule[OF _ maybe_mess_up_admin_arrow_intact_NN _]
    arrow_is_imp_if_CNormal[THEN subsetD]
  )
  apply(auto)
  apply(case_tac x, simp_all)
  done

lemma get_arrow_preserves_other_arr_NN:
  "\<lbrace>if_CNormal_arrow_is arr ind'\<rbrace> get_arrow ind \<lbrace>>N K (if_CNormal_arrow_is arr ind')\<rbrace>"
  apply(auto simp add: HoareNN_alt Hoare_def Box_def K_beta)
  apply(auto simp add: get_arrow_defs if_CNormal_arrow_is_def brute_force min_def split: split_if_asm)
  done

lemma sync_by_arrow_other_SEq_NN:
  "ind \<noteq> ind' \<Longrightarrow>
  \<lbrace>if_CNormal_arrow_is arr ind'\<rbrace>
    sync_by_arrow_silence_deg ind
  \<lbrace>>N K (if_CNormal_arrow_is arr ind')\<rbrace>"
  by(auto simp add: K_beta HoareNN_return'
    sync_by_arrow_silence_deg_def
    intro!:
    bind_ruleNN
    bind_ruleNE
    HoareNN_throw
    try_catch_ruleNN
    get_arrow_preserves_other_arr_NN
    maybe_mess_up_admin_if_CNormal_arrow_intact_NN
    just_sync_silence_deg'_other_SEq_post_NN
    conseqNN_rule[OF _ maybe_mess_up_admin_arrow_intact_NN _]
    arrow_is_imp_if_CNormal[THEN subsetD]
  )

lemma sync_by_arrow_post_abs_updated_are_SEq_NN:
  assumes l_set: " l \<in> order_set A"
  shows "\<lbrace>abs_updated_equals A\<rbrace> mapM' sync_by_arrow_silence_deg l \<lbrace>>N K abs_updated_are_SEq\<rbrace>"
proof(cases l)
  case Nil
  hence "set l = {}" by simp
  hence "A = {}" using l_set
    by(simp add: order_set_set)
  thus ?thesis using Nil
    by(auto simp add: HoareNN_return' K_beta abs_updated_equals_def abs_updated_are_SEq_def)
next
  case (Cons x xs)
  have P:
    "\<lbrace>\<Inter>ind \<in> set l. abs_updated_equals A\<rbrace>
        mapM' sync_by_arrow_silence_deg l
    \<lbrace>>N K (\<Inter>ind \<in> set l. if_CNormal_arrow_is SEq ind)\<rbrace>"
    apply(rule mapM'_distinct_ruleNN)
    apply(simp add: order_set_distinct[OF l_set])
    apply(auto intro: sync_by_arrow_silence_deg_intact_abs_updated_NN sync_by_arrow_tgt_SEq_NN
      sync_by_arrow_other_SEq_NN)
    done
  have P':
    "\<lbrace>\<Inter>ind \<in> set l. abs_updated_equals A\<rbrace>
        mapM' sync_by_arrow_silence_deg l
    \<lbrace>>N K (\<Inter>ind \<in> set l. abs_updated_equals A)\<rbrace>"
    by(auto intro!: mapM'_invNN sync_by_arrow_silence_deg_intact_abs_updated_NN intro: true_postNN)

  have "l \<noteq> []" using Cons by simp
    
  thus ?thesis using l_set 
    apply -
    apply(rule conseqNN_rule[OF _ HoareNN_join_post[OF P P'] _])
    apply(clarsimp_all simp add: K_beta del: subsetI)
    apply(auto simp add: K_beta if_CNormal_arrow_is_def abs_updated_are_SEq_def abs_updated_equals_def
      order_set_set)
    done
qed
 
lemma sync_updated_makes_all_SEq_NN:
  "\<lbrace>not_abs_updated_are_SEq\<rbrace> sync_updated \<lbrace>>N K all_SEq\<rbrace>"
  apply(unfold sync_updated_def)
  apply(rule bind_ruleNN)
  apply(rule HoareNN_join_post[OF get_abs_updated_post_NN get_abs_updated_post_NN'])
  apply(clarsimp simp add: K_beta)
  apply(rule bind_ruleNN[OF chooseN_ruleNN])
  apply(auto intro: ex_falsumNN)
  apply(rule bind_ruleNN[where Q="K all_SEq"])
  apply(rule conseqNN_rule[OF _
    HoareNN_join[OF sync_by_arrow_silence_deg_intact_SEq_NN sync_by_arrow_post_abs_updated_are_SEq_NN]])
  apply(rule order_refl)
  apply(assumption)
  apply(auto simp add: K_def not_abs_updated_are_SEq_def abs_updated_are_SEq_def all_SEq_def
    HoareNN_alt Hoare_def Box_def brute_force)
  done

lemma rollforward_makes_all_SEq_NN:
  "\<lbrace>not_abs_updated_are_SEq\<rbrace> rollforward \<lbrace>>N K all_SEq\<rbrace>"
  by(unfold rollforward_def, rule sync_updated_makes_all_SEq_NN)

lemma startup_all_SEq_post_NN:
  "\<lbrace>UNIV\<rbrace> startup \<lbrace>>N K all_SEq\<rbrace>"
  by (rule startup_UNIV_post_NN)

lemma check_public_region_SEq_tgt_post_NN:
  "\<lbrace>UNIV\<rbrace> check_pub_region ind \<lbrace>>N K (if_CNormal_arrow_is SEq ind)\<rbrace>"
  apply(auto simp add: check_pub_region_def
    intro!:
    bind_ruleNN
    get_arrow_arrow_post_NN
    just_sync_silence_deg'_tgt_SEq_post_NN
  )
  apply(rule check_pub_same_arrow_inv_NN)
  apply(simp add: K_beta)
  apply(rule conseqNN_rule[OF arrow_is_imp_if_CNormal maybe_mess_up_admin_if_CNormal_arrow_intact_NN])
  apply(simp)
  done

lemma if_CNormal_char:
  "if_CNormal_arrow_is arr ind = sv_abs_mode_neq ACNormal \<union> arrow_is arr ind"
  by(auto simp add: if_CNormal_arrow_is_def sv_abs_mode_neq_def arrow_is_def)

lemma HoareNN_pre_Un:
  "\<lbrace>P \<union> P'\<rbrace> m \<lbrace>>N Q\<rbrace> = (\<lbrace>P\<rbrace> m \<lbrace>>N Q\<rbrace> \<and> \<lbrace>P'\<rbrace> m \<lbrace>>N Q\<rbrace>)"
  by(auto simp add: HoareNN_alt Hoare_def Box_def)

lemma read_no_mode_upgrade_NN:
  "\<lbrace>sv_abs_mode_neq ACNormal\<rbrace> read ind inst \<lbrace>>N K (sv_abs_mode_neq ACNormal)\<rbrace>"
  apply(auto simp add: HoareNN_alt Hoare_def Box_def K_def)
  apply(auto simp add: sv_abs_mode_neq_def read_defs brute_force)
  done

lemma read_or_fail_no_mode_upgrade_NN:
  "\<lbrace>sv_abs_mode_neq ACNormal\<rbrace> read_or_fail ind inst \<lbrace>>N K (sv_abs_mode_neq ACNormal)\<rbrace>"
  apply(auto simp add: HoareNN_alt Hoare_def Box_def K_def)
  apply(auto simp add: sv_abs_mode_neq_def read_or_fail_defs brute_force)
  done

lemma read_no_mode_upgrade_NE:
  "\<lbrace>sv_abs_mode_neq ACNormal\<rbrace> read ind inst \<lbrace>@N K (sv_abs_mode_neq ACNormal)\<rbrace>"
  apply(auto simp add: HoareNE_alt Hoare_def Box_def K_def)
  apply(auto simp add: sv_abs_mode_neq_def read_defs brute_force min_def split: split_if_asm)
  done

lemma read_or_fail_no_mode_upgrade_NE:
  "\<lbrace>sv_abs_mode_neq ACNormal\<rbrace> read_or_fail ind inst \<lbrace>@N K (sv_abs_mode_neq ACNormal)\<rbrace>"
  apply(auto simp add: HoareNE_alt Hoare_def Box_def K_def)
  apply(auto simp add: sv_abs_mode_neq_def read_or_fail_defs brute_force min_def split: split_if_asm)
  done

lemma check_pub_same_no_mode_upgrade_NN:
  "\<lbrace>sv_abs_mode_neq ACNormal\<rbrace> check_pub_same ind \<lbrace>>N K (sv_abs_mode_neq ACNormal)\<rbrace>"
  by(auto simp add: HoareNN_return' HoareNE_throw' K_beta
    check_pub_same_def
    just_sync_silence_deg_def
    just_sync_def
    read_or_fail_silence_deg_def
    intro!:
    bind_ruleNN_same
    bind_ruleNE_same
    HoareNE_return
    HoareNN_throw
    try_catch_ruleNN_same
    try_catch_ruleNE_same
    read_no_mode_upgrade_NN
    read_no_mode_upgrade_NE
    read_or_fail_no_mode_upgrade_NN
    read_or_fail_no_mode_upgrade_NE
    sync_no_mode_upgrade_NN
    sync_mode_post_NE
    split: exceptions.split
  )
  
lemma check_pub_same_preserves_if_CNormal_NN:
  "\<lbrace>if_CNormal_arrow_is SEq ind'\<rbrace>
  check_pub_same ind
  \<lbrace>>N K (if_CNormal_arrow_is SEq ind')\<rbrace>"
  by(auto simp add: if_CNormal_char HoareNN_pre_Un K_beta
    intro!:
    conseqNN_rule[OF order_refl check_pub_same_no_mode_upgrade_NN]
    conseqNN_rule[OF order_refl check_pub_same_arrow_inv_NN])

lemma check_public_region_SEq_other_post_NN:
  "ind' \<noteq> ind \<Longrightarrow>
  \<lbrace>if_CNormal_arrow_is SEq ind'\<rbrace> check_pub_region ind \<lbrace>>N K (if_CNormal_arrow_is SEq ind')\<rbrace>"
  by(auto simp add: K_beta
    check_pub_region_def 
    intro!:
    bind_ruleNN
    HoareNN_join_post[OF get_arrow_arrow_post_NN get_arrow_preserves_other_arr_NN]
    conseqNN_rule[OF Int_lower2 just_sync_silence_deg'_other_SEq_post_NN[where ind'=ind']]
    conseqNN_rule[OF Int_lower2 check_pub_same_preserves_if_CNormal_NN]
    maybe_mess_up_admin_if_CNormal_arrow_intact_NN
    intro: ex_falsumNN
    del: subsetI
  )

lemma mapM'_check_pub_region_all_SEq_post_NN:
  assumes l_set: "l \<in> order_set UNIV"
  shows "\<lbrace>UNIV\<rbrace> mapM' check_pub_region l \<lbrace>>N K all_SEq\<rbrace>"
proof-
  have all_Seq':
    "all_SEq = (\<Inter>ind \<in> set l. if_CNormal_arrow_is SEq ind)" using l_set
    by(auto simp add: all_SEq_def if_CNormal_arrow_is_def order_set_set)
  have UNIV': "UNIV = (\<Inter>ind \<in> set l. UNIV)" by auto
  show ?thesis
    apply(subst all_Seq', subst UNIV')
    apply(rule mapM'_distinct_ruleNN)
    apply(auto intro: order_set_distinct[OF l_set]
      check_public_region_SEq_tgt_post_NN true_postNN check_public_region_SEq_other_post_NN)
    done
qed

lemma check_all_public_all_SEq_post_NN:
  "\<lbrace>UNIV\<rbrace> check_all_public \<lbrace>>N K all_SEq\<rbrace>"
  by(auto simp add: check_all_public_def
    intro!:
    bind_ruleNN
    chooseN_ruleNN
    mapM'_check_pub_region_all_SEq_post_NN
    intro: ex_falsumNN)

lemma startup_all_SEq_post_NE:
  "\<lbrace>UNIV\<rbrace> startup \<lbrace>@N K all_SEq\<rbrace>"
  apply(auto simp add:
    startup_def
    startup2_def
    intro!:
    bind_ruleNE
  )
  apply(rule conseqNE_rule[OF order_refl startup1_post_NE])
  apply(clarsimp simp add: sv_abs_mode_equals_def all_SEq_def)
  apply(simp_all add: K_beta)
  apply(rule true_postNN)
  apply(simp_all add: K_beta)
  apply(rule conseqNE_rule[OF order_refl check_all_public_post_NE])
  apply(clarsimp simp add: K_beta sv_abs_mode_equals_def all_SEq_def)
  apply(rule check_all_public_all_SEq_post_NN)
  apply(simp_all add: K_beta)
  apply(auto simp add: K_beta HoareNN_return' HoareNE_throw'
    throw_abs_mode_error_def
    intro!:
    HoareNE_return
    HoareNN_throw
    HoareNE_vol_ops
    HoareNN_get_abs_mode
    bind_ruleNE
    bind_ruleNN
  )
  done

lemma get_arrow_preserves_all_SEq_NN:
  "\<lbrace>all_SEq\<rbrace> get_arrow ind \<lbrace>>N K all_SEq\<rbrace>"
  apply(auto simp add: HoareNN_alt Hoare_def Box_def K_beta)
  apply(auto simp add: all_SEq_def get_arrow_defs brute_force min_def
    split: split_if_asm)
  done

lemma read_preserves_all_SEq_NN:
  "\<lbrace>all_SEq\<rbrace> read ind inst \<lbrace>>N K all_SEq \<rbrace>"
  apply(auto simp add: HoareNN_alt Hoare_def Box_def K_def)
  apply(auto simp add: all_SEq_def read_defs brute_force)
  done

lemma read_or_fail_preserves_all_SEq_NN:
  "\<lbrace>all_SEq\<rbrace> read_or_fail ind inst \<lbrace>>N K all_SEq \<rbrace>"
  apply(auto simp add: HoareNN_alt Hoare_def Box_def K_def)
  apply(auto simp add: all_SEq_def read_or_fail_defs brute_force)
  done

lemma read_preserves_all_SEq_NE:
  "\<lbrace>all_SEq\<rbrace> read ind inst \<lbrace>@N K all_SEq \<rbrace>"
  apply(auto simp add: HoareNE_alt Hoare_def Box_def K_def)
  apply(auto simp add: all_SEq_def read_defs brute_force min_def split: split_if_asm)
  done

lemma read_or_fail_preserves_all_SEq_NE:
  "\<lbrace>all_SEq\<rbrace> read_or_fail ind inst \<lbrace>@N K all_SEq \<rbrace>"
  apply(auto simp add: HoareNE_alt Hoare_def Box_def K_def)
  apply(auto simp add: all_SEq_def read_or_fail_defs brute_force min_def split: split_if_asm)
  done

lemma sync_preserves_all_SEq_NN:
  "\<lbrace>all_SEq\<rbrace> sync ind Primary Secondary \<lbrace>>N K all_SEq\<rbrace>"
  apply(auto simp add: HoareNN_alt Hoare_def Box_def K_def)
  apply(auto simp add: all_SEq_def sync_defs brute_force min_def split: split_if_asm)
  done

lemma sync_preserves_all_SEq_NE:
  "\<lbrace>all_SEq\<rbrace> sync ind Primary Secondary \<lbrace>@N K all_SEq\<rbrace>"
  apply(auto simp add: HoareNE_alt Hoare_def Box_def K_def)
  apply(auto simp add: all_SEq_def sync_defs brute_force min_def split: split_if_asm)
  done

lemma fetch_same_preserves_all_SEq_NN:
  "\<lbrace>all_SEq\<rbrace> fetch_same ind \<lbrace>>N K all_SEq\<rbrace>"
  by(auto simp add:
    fetch_same_def
    intro!:
    try_catch_ruleNN_same
    bind_ruleNN_same
    HoareNN_throw
    read_preserves_all_SEq_NN
    read_preserves_all_SEq_NE
    read_or_fail_preserves_all_SEq_NN
    sync_preserves_all_SEq_NN
    split: exceptions.split
  )

lemma fetch_same_preserves_all_SEq_NE:
  "\<lbrace>all_SEq\<rbrace> fetch_same ind \<lbrace>@N K all_SEq\<rbrace>"
  by(auto simp add: K_beta HoareNE_throw'
    fetch_same_def
    intro!:
    try_catch_ruleNE_same
    bind_ruleNE_same
    HoareNE_return
    read_preserves_all_SEq_NE
    read_or_fail_preserves_all_SEq_NN
    read_or_fail_preserves_all_SEq_NE
    sync_preserves_all_SEq_NE
    split: exceptions.split
  )

lemma fetch_preserves_all_SEq_NN:
  "\<lbrace>all_SEq\<rbrace> fetch ind \<lbrace>>N K all_SEq\<rbrace>"
  by(auto simp add: K_beta first_stage HoareNN_return'
    fetch_def
    throw_abs_mode_error_def
    intro!: bind_ruleNN
    fetch_same_preserves_all_SEq_NN
    HoareNN_get_abs_mode
    HoareNN_throw
    get_arrow_preserves_all_SEq_NN
    read_or_fail_preserves_all_SEq_NN)

lemma fetch_preserves_all_SEq_NE:
  "\<lbrace>all_SEq\<rbrace> fetch ind \<lbrace>@N K all_SEq\<rbrace>"
  apply(auto simp add: K_beta HoareNN_return' HoareNE_throw'
    fetch_def
    throw_abs_mode_error_def
    intro!:
    bind_ruleNN
    bind_ruleNE
    HoareNE_return
    HoareNN_get_abs_mode
    HoareNE_vol_ops
    HoareNN_throw
    fetch_same_preserves_all_SEq_NN
    fetch_same_preserves_all_SEq_NE
    get_arrow_preserves_all_SEq_NN
    read_or_fail_preserves_all_SEq_NN
    read_or_fail_preserves_all_SEq_NE
    conseqNE_rule[OF order_refl get_arrow_mode_post_NE]
  )
  apply(simp add: sv_abs_mode_neq_def all_SEq_def)
  done

definition all_reliable_but where
  "all_reliable_but ind inst \<equiv> {(sv, sp). abs_card_mode sv = ACNormal \<longrightarrow>
    (\<forall>ind' inst'. ind' \<noteq> ind \<or> inst' \<noteq> inst \<longrightarrow> (ind', inst') \<in> reliable sp)}"

lemma read_reliable_post_NE:
  "\<lbrace>all_reliable_inv\<rbrace>
  read pind inst
  \<lbrace>@N \<lambda>e. if e = FailRead then all_reliable_but pind inst else all_reliable_inv\<rbrace>"
  apply(auto simp add: HoareNE_alt Hoare_def Box_def K_def)
  apply(simp_all only: read_def)
  apply(simp_all add: first_stage vol_ops_project_simps cong: exceptions.case_cong if_cong)
  apply(simp_all only: choice_def Un_iff, safe)
  apply(clarsimp_all simp add: read_defs all_reliable_inv_def all_reliable_but_def
    brute_force min_def split: split_if_asm)
  done

lemma get_arrow_reliable_inv_NN:
  "\<lbrace>all_reliable_inv\<rbrace> get_arrow pind \<lbrace>>N K all_reliable_inv\<rbrace>"
  apply(auto simp add: HoareNN_alt Hoare_def Box_def K_def)
  apply(simp_all only: get_arrow_def)
  apply(simp_all add: first_stage vol_ops_project_simps cong: exceptions.case_cong if_cong)
  apply(simp_all only: choice_def Un_iff, safe)
  apply(clarsimp_all simp add: get_arrow_defs all_reliable_inv_def brute_force min_def)
  done

lemma read_or_fail_reliable_inv_NN:
  "\<lbrace>all_reliable_inv\<rbrace> Abs4_CommonDefs.read_or_fail pind inst \<lbrace>>N K all_reliable_inv\<rbrace>"
  apply(auto simp add: HoareNN_alt Hoare_def Box_def K_def)
  apply(simp_all only: read_or_fail_def)
  apply(simp_all add: first_stage vol_ops_project_simps cong: exceptions.case_cong if_cong)
  apply(simp_all only: choice_def Un_iff, safe)
  apply(clarsimp_all simp add:
    read_or_fail_defs all_reliable_inv_def brute_force min_def)
  done

lemma read_reliable_inv_NN:
  "\<lbrace>all_reliable_inv\<rbrace> read pind inst \<lbrace>>N K all_reliable_inv\<rbrace>"
  apply(auto simp add: HoareNN_alt Hoare_def Box_def K_def)
  apply(simp_all only: read_def)
  apply(simp_all add: first_stage vol_ops_project_simps cong: exceptions.case_cong if_cong)
  apply(simp_all only: choice_def Un_iff, safe)
  apply(clarsimp_all simp add: read_defs all_reliable_inv_def brute_force min_def)
  done

lemma fetch_reliable_inv:
  "\<lbrace>all_reliable_inv\<rbrace> fetch pind \<lbrace>>N K all_reliable_inv\<rbrace>"
  apply(auto simp add: fetch_def HoareNN_return' K_beta
    throw_abs_mode_error_def
    fetch_same_def
    intro!:
    bind_ruleNN_same
    try_catch_ruleNN
    HoareNN_throw
    HoareNN_get_abs_mode
    get_arrow_reliable_inv_NN
    read_or_fail_reliable_inv_NN
    read_reliable_inv_NN
    read_reliable_post_NE
    split: exceptions.split
  )
  apply(auto intro!: read_or_fail_reliable_inv_NN read_reliable_post_NE)
  apply(auto simp add: HoareNN_alt Hoare_def Box_def K_def)
  apply(simp_all only: sync_def)
  apply(simp_all add: first_stage vol_ops_project_simps cong: exceptions.case_cong if_cong)
  apply(simp_all only: choice_def Un_iff, safe)
  apply(auto simp add: sync_defs all_reliable_inv_def all_reliable_but_def
    brute_force min_def split: split_if_asm)
  done

lemma read_mode_post_NE':
  "\<lbrace>P\<rbrace>
  read pind inst
  \<lbrace>@N \<lambda>e.
  if e = FailMode then sv_abs_mode_equals ACFail
  else if \<exists>v. e = Degraded v then sv_abs_mode_neq ACNormal
  else if e \<in> {FailWrite, FailLLRead, StartedExc, InvalidInput} then {}
  else UNIV \<rbrace>"
  apply(auto simp add: HoareNE_alt Hoare_def Box_def)
  apply(auto simp add: sv_abs_mode_equals_def sv_abs_mode_neq_def read_defs brute_force
    min_def split: split_if_asm)
  done

lemma read_or_fail_mode_post_NE:
  "\<lbrace>P\<rbrace> read_or_fail pind inst \<lbrace>@N K (sv_abs_mode_neq ACNormal)\<rbrace>"
  apply(auto simp add: HoareNE_alt Hoare_def Box_def)
  apply(auto simp add: sv_abs_mode_neq_def read_or_fail_defs brute_force
    min_def split: split_if_asm)
  done

lemma set_abs_failed_post_NN:
  "\<lbrace>P\<rbrace> set_abs_failed \<lbrace>>N K (sv_abs_mode_neq ACNormal)\<rbrace>"
  by(auto simp add: HoareNN_alt Hoare_def Box_def brute_force sv_abs_mode_neq_def)

lemma sv_abs_mode_eq_neq_subset: "m \<noteq> m' \<Longrightarrow> sv_abs_mode_equals m \<subseteq> sv_abs_mode_neq m'"
  by(auto simp add: sv_abs_mode_equals_def sv_abs_mode_neq_def)

lemma fetch_same_mode_post_NE:
  "\<lbrace>P\<rbrace> fetch_same pind \<lbrace>@N K (sv_abs_mode_neq ACNormal)\<rbrace>"
  apply(auto simp add: HoareNE_throw' K_beta
    fetch_same_def
    intro!:
    try_catch_ruleNE
    try_catch_ruleNN
    bind_ruleNE
    bind_ruleNN
    HoareNN_throw
    HoareNE_vol_ops
    read_mode_post_NE'
    read_or_fail_mode_post_NE
    read_no_mode_upgrade_NN
    read_or_fail_no_mode_upgrade_NN
    set_abs_failed_post_NN
    conseqNE_rule[OF _ sync_mode_post_NE]
    sv_abs_mode_eq_neq_subset
    split: exceptions.split
    del: subsetI
  )
  done

lemma get_abs_mode_ruleNN:
  "\<lbrace>P\<rbrace> get_abs_mode \<lbrace>>N \<lambda>v. sv_abs_mode_equals v \<inter> P\<rbrace>"
  by(auto simp add: HoareNN_alt Hoare_def Box_def brute_force sv_abs_mode_equals_def)

lemma fetch_mode_post_NE:
  "\<lbrace>P\<rbrace> fetch pind \<lbrace>@N K (sv_abs_mode_neq ACNormal)\<rbrace>"
  apply(auto simp add: HoareNE_throw' HoareNN_return' K_beta
    fetch_def
  )
  apply(rule bind_ruleNE)
  apply(rule HoareNE_vol_ops)
  apply(rule get_abs_mode_ruleNN)
  apply(auto)
  apply(force simp add: first_stage HoareNE_throw' intro!: sv_abs_mode_eq_neq_subset[THEN subsetD])
  apply(rule bind_ruleNE)
  apply(rule HoareNE_return)
  apply(rule true_postNN)
  apply(auto simp add: K_beta HoareNE_throw'
    throw_abs_mode_error_def
    intro!:
    HoareNE_vol_ops
    bind_ruleNE read_or_fail_mode_post_NE fetch_same_mode_post_NE true_postNN
    get_abs_mode_ruleNN
    HoareNE_return
    get_arrow_mode_post_NE
    sv_abs_mode_eq_neq_subset[THEN subsetD]
    intro: true_postNN
  )
  done

end