theory Abs4_Lemmas
imports Abs4_UpdateDefs "../HoareLogic" "../Pmm_Tacs"
begin

lemmas brute_force =
  unfold_monad
  project_defs
  restart_mangle_sv_raw
  getters_setters
  modify_def
  choose_def
  put_def
  vol_ops_defs

definition arrow_source_at :: "pub_indx \<Rightarrow> INST \<Rightarrow> ('sv \<times> 'c abs4_state)set" where
  "arrow_source_at pind inst \<equiv> {(sva, spa).
    arrow spa pind = SEq
    \<or> (arrow spa pind = SR \<and> inst = Primary)
    \<or> (arrow spa pind = SL \<and> inst = Secondary)
  }"

definition updated_arrows_src_at_Primary :: "(abs_vol_mem \<times> 'c abs4_state)set" where
  "updated_arrows_src_at_Primary \<equiv> {(sva, spa).
    \<forall>pind. pind \<in> abs_updated sva \<longrightarrow> arrow spa pind \<in> {SEq, SR}}"

(*
lemma write_new_arrow_post_NN:
  "\<lbrace>P\<rbrace> write_new ind Secondary cnt \<lbrace>>N K (arrow_source_at ind Primary)\<rbrace>"
  by(clarsimp simp add: HoareNN_alt Hoare_def Box_def brute_force write_new_defs arrow_source_at_def
    split: split_if_asm)
  *)

lemma write_new_arrow_post_NN:
  "\<lbrace>updated_arrows_src_at_Primary\<rbrace> write_new ind Secondary cnt \<lbrace>>N K updated_arrows_src_at_Primary\<rbrace>"
  by(auto simp add: HoareNN_alt Hoare_def Box_def brute_force write_new_defs
    updated_arrows_src_at_Primary_def
    split: split_if_asm)

lemma write_new_arrow_post_NE:
  "\<lbrace>updated_arrows_src_at_Primary\<rbrace>
    write_new ind Secondary cnt
  \<lbrace>@N \<lambda>e. if e \<noteq> FailMode then updated_arrows_src_at_Primary else UNIV\<rbrace>"
  apply(auto simp add: HoareNE_alt Hoare_def Box_def)
  apply(rename_tac sv sp e sv' sp')
  apply(clarsimp simp add: brute_force write_new_defs
    updated_arrows_src_at_Primary_def
    split: split_if_asm
    del: disjCI)
  apply(iterative_simp del: disjCI)+
  done

end