theory Abs4_Redundancy
  imports Abs4_Invariant_Lemmas Abs4_Specification
begin

definition writable_in_view where
  "writable_in_view \<equiv> {(sv, sp). abs_card_mode sv \<noteq> ACFail \<longrightarrow> writable sp \<subseteq> in_view sp}"

definition ind_writable_in_view where
  "ind_writable_in_view ind \<equiv> {(sv, sp). abs_card_mode sv \<noteq> ACFail \<longrightarrow> 
    (
        ((ind, Primary) \<in> writable sp \<longrightarrow> (ind, Primary) \<in> in_view sp)
        \<and> ((ind, Secondary) \<in> writable sp \<longrightarrow> (ind, Secondary) \<in> in_view sp)
    )
  }"

lemma check_pub_same_redundancy_inv_NN:
  "\<lbrace>ind_writable_in_view pind'\<rbrace> Abs4_StartupDefs.check_pub_same pind 
  \<lbrace>>N K (ind_writable_in_view pind')\<rbrace>"
  apply(auto simp add: HoareNN_alt Hoare_def Box_def)
  apply(rename_tac sva spa sva' spa')
  apply(simp_all only: Abs4_StartupDefs.check_pub_same_def)
  apply(simp_all add: first_stage cong: exceptions.case_cong if_cong)
  apply(simp_all only: choice_def Un_iff, safe)
  apply(simp_all only: Abs4_CommonDefs.just_sync_silence_deg_def)
  apply(simp_all add: first_stage cong: exceptions.case_cong if_cong)
  apply(simp_all only: choice_def Un_iff, safe)
  apply(simp_all only: Abs4_StartupDefs.read_or_fail_silence_deg_def)
  apply(simp_all add: first_stage if_choice cong: exceptions.case_cong if_cong)
  apply(simp_all only: choice_def Un_iff, safe)
  apply(simp_all only: Abs4_CommonDefs.just_sync_def)
  apply(simp_all add: first_stage if_choice cong: exceptions.case_cong if_cong)
  apply(simp_all only: Abs4_CommonDefs.read_def)
  apply(simp_all add: first_stage if_choice read_proj_simps restart_mangle_sv_proj_simps
    cong: exceptions.case_cong if_cong)
  apply(simp_all only: choice_def Un_iff, safe)
  apply(simp_all only: Abs4_CommonDefs.sync_def)
  apply(simp_all add: first_stage if_choice sync_proj_simps restart_mangle_sv_proj_simps
    cong: exceptions.case_cong if_cong)
  apply(simp_all only: choice_def Un_iff, safe)
  using [[simp_depth_limit=0]]
  apply(tactic {* distinct_subgoals_tac *})
  apply(clarsimp_all simp add: Abs4_CommonDefs.read_defs Abs4_CommonDefs.read_or_fail_defs
    Abs4_CommonDefs.sync_defs brute_force
    split: exceptions.split_asm split_if_asm
  )
  apply(tactic {* distinct_subgoals_tac *})
  apply(clarsimp_all simp add: ind_writable_in_view_def in_view_def)
  apply(simp_all add: min_def split: split_if_asm)
  apply(iterative_simp)+
  apply(tactic {* Pmm_Tacs.full_dest_tac @{context} @{thms exc_exhaust} *}, simp_all)
  apply (metis (full_types) less_eq_abs_card_mode.simps(1))+
  done

lemma check_pub_same_redundancy_inv_NE:
  "\<lbrace>ind_writable_in_view pind'\<rbrace> Abs4_StartupDefs.check_pub_same pind 
  \<lbrace>@N K (ind_writable_in_view pind')\<rbrace>"
  apply(rule conseqNE_rule[OF _ check_pub_same_post_NE])
  apply(auto simp add: ind_writable_in_view_def K_def sv_abs_mode_equals_def)
  done

lemma check_pub_same_establishes_redundancy_NN:
  "\<lbrace>arrow_is SEq pind\<rbrace> Abs4_StartupDefs.check_pub_same pind 
  \<lbrace>>N K (ind_writable_in_view pind)\<rbrace>"
  apply(auto simp add: Hoare_alt Hoare_def Box_def)
  apply(rename_tac sva spa sva' spa')
  apply(simp_all only: Abs4_StartupDefs.check_pub_same_def)
  apply(simp_all add: first_stage cong: exceptions.case_cong if_cong)
  apply(simp_all only: choice_def Un_iff, safe)
  apply(simp_all only: Abs4_CommonDefs.just_sync_silence_deg_def)
  apply(simp_all add: first_stage cong: exceptions.case_cong if_cong)
  apply(simp_all only: choice_def Un_iff, safe)
  apply(simp_all only: Abs4_StartupDefs.read_or_fail_silence_deg_def)
  apply(simp_all add: first_stage if_choice cong: exceptions.case_cong if_cong)
  apply(simp_all only: choice_def Un_iff, safe)
  apply(simp_all only: Abs4_CommonDefs.just_sync_def)
  apply(simp_all add: first_stage if_choice cong: exceptions.case_cong if_cong)
  apply(simp_all only: Abs4_CommonDefs.read_def)
  apply(simp_all add: first_stage if_choice read_proj_simps restart_mangle_sv_proj_simps
    cong: exceptions.case_cong if_cong)
  apply(simp_all only: choice_def Un_iff, safe)
  apply(simp_all only: Abs4_CommonDefs.sync_def)
  apply(simp_all add: first_stage if_choice sync_proj_simps restart_mangle_sv_proj_simps
    cong: exceptions.case_cong if_cong)
  apply(simp_all only: choice_def Un_iff, safe)
  using [[simp_depth_limit=0]]
  apply(clarsimp_all simp add: Abs4_CommonDefs.read_defs Abs4_CommonDefs.read_or_fail_defs
    Abs4_CommonDefs.sync_defs brute_force
    split: exceptions.split_asm split_if_asm
  )
  apply(tactic {* distinct_subgoals_tac *})
  apply(clarsimp_all simp add: ind_writable_in_view_def in_view_def arrow_is_def)
  apply(simp_all add: min_def split: split_if_asm)
  apply(iterative_simp)+
  apply(tactic {* Pmm_Tacs.full_dest_tac @{context} @{thms exc_exhaust} *}, simp_all)
  done

lemma get_arrow_proj_simps:
  "(get_arrow_fail pind)\<Down>NN = empty"
  "(get_arrow_success pind)\<Down>NE = empty"
  "(get_arrow_degrade pind)\<Down>NE = empty"
  "(get_arrow_restart pind)\<Down>NN = empty"
  "(get_arrow_restart pind)\<Down>NE = empty"
  by(auto simp add: project_defs get_arrow_defs)

lemma just_sync_silence_deg'_establishes_redundancy_NN:
  "\<lbrakk> dir = SR \<or> dir = SL; (dir = SR) = (to = Secondary); to \<noteq> from \<rbrakk> \<Longrightarrow>
  \<lbrace>arrow_is dir pind\<rbrace> 
    just_sync_silence_deg' to from pind 
  \<lbrace>>N K (ind_writable_in_view pind)\<rbrace>"
  apply(auto simp add: HoareNN_alt Hoare_def Box_def)
  apply(simp_all only: just_sync_silence_deg_def')
  apply(simp_all add: first_stage cong: exceptions.case_cong if_cong)
  apply(simp_all only: choice_def Un_iff, safe)
  apply(simp_all only: sync_def sync_proj_simps)
  apply(simp_all add: first_stage cong: exceptions.case_cong if_cong)
  apply(simp_all only: choice_def Un_iff, safe)
  apply(simp_all only: maybe_mess_up_admin_def)
  apply(simp_all add: first_stage get_arrow_proj_simps cong: exceptions.case_cong if_cong)
  apply(simp_all only: choice_def Un_iff, safe)
  using [[simp_depth_limit=0]]
  using [[simproc del: Product_Type.split_beta]]
  apply(clarsimp_all simp add: brute_force sync_defs get_arrow_defs
    ind_writable_in_view_def in_view_def min_def arrow_is_def
    split: exceptions.split_asm split_if_asm)
  apply(iterative_simp)+
  done

lemma maybe_mess_up_admin_redundancy_NN:
  "\<lbrace>ind_writable_in_view pind'\<rbrace> maybe_mess_up_admin pind \<lbrace>>N K (ind_writable_in_view pind')\<rbrace>"
  apply(auto simp add: Hoare_alt Hoare_def Box_def)
  apply(auto simp add: maybe_mess_up_admin_def get_arrow_defs brute_force 
    ind_writable_in_view_def in_view_def min_def)
  done

lemma check_pub_region_establishes_redundancy_NN:
  "\<lbrace>P\<rbrace> check_pub_region pind \<lbrace>>N K (ind_writable_in_view pind) \<rbrace>"
   apply(auto simp add: Abs4_StartupDefs.check_pub_region_def K_beta
     intro!: bind_ruleNN 
     get_arrow_arrow_post_NN check_pub_same_establishes_redundancy_NN
     just_sync_silence_deg'_establishes_redundancy_NN
     maybe_mess_up_admin_redundancy_NN
     intro: ex_falsumNN
   )
   apply(auto simp add: K_beta intro!: 
     check_pub_same_establishes_redundancy_NN
     maybe_mess_up_admin_redundancy_NN
     intro: ex_falsumNN
   )
   apply(case_tac x, simp_all)
  done

lemmas unfold_Hoare = Hoare_alt Hoare_def Box_def K_def

lemma get_arrow_redundancy_inv_NN:
  "\<lbrace>ind_writable_in_view pind'\<rbrace> get_arrow pind \<lbrace>>N K (ind_writable_in_view pind') \<rbrace>"
  apply(auto simp add: unfold_Hoare)
  apply(auto simp add: get_arrow_defs brute_force ind_writable_in_view_def in_view_def
    min_def)
  done

lemma just_sync_silence_deg'_redundancy_inv_NN:
  "pind' \<noteq> pind \<Longrightarrow>
  \<lbrace>ind_writable_in_view pind'\<rbrace> 
    just_sync_silence_deg' to from pind 
  \<lbrace>>N K (ind_writable_in_view pind')\<rbrace>"
  apply(auto simp add: unfold_Hoare)
  apply(simp_all only: just_sync_silence_deg_def')
  apply(simp_all add: first_stage cong: exceptions.case_cong if_cong)
  apply(simp_all only: choice_def Un_iff, safe)
  apply(simp_all only: sync_def sync_proj_simps)
  apply(simp_all add: first_stage cong: exceptions.case_cong if_cong)
  apply(simp_all only: choice_def Un_iff, safe)
  apply(simp_all only: maybe_mess_up_admin_def)
  apply(simp_all add: first_stage get_arrow_proj_simps cong: exceptions.case_cong if_cong)
  apply(simp_all only: choice_def Un_iff, safe)
  using [[simp_depth_limit=0]]
  using [[simproc del: Product_Type.split_beta]]
  apply(clarsimp_all simp add: brute_force sync_defs get_arrow_defs
    ind_writable_in_view_def in_view_def min_def arrow_is_def
    split: exceptions.split_asm split_if_asm)
  apply(auto)
  done

lemma check_pub_region_redundancy_inv_NN:
  "pind' \<noteq> pind \<Longrightarrow>
  \<lbrace>ind_writable_in_view pind'\<rbrace> check_pub_region pind \<lbrace>>N K (ind_writable_in_view pind') \<rbrace>"
   apply(auto simp add: Abs4_StartupDefs.check_pub_region_def K_beta
     intro!: bind_ruleNN 
     get_arrow_redundancy_inv_NN check_pub_same_redundancy_inv_NN
     just_sync_silence_deg'_redundancy_inv_NN
     maybe_mess_up_admin_redundancy_NN
     intro: ex_falsumNN
   )
  done

lemma check_pub_region_establishes_redundancy_NE:
  "\<lbrace>P\<rbrace> check_pub_region pind \<lbrace>@N K (ind_writable_in_view pind) \<rbrace>"
  apply(rule conseqNE_rule[OF _ check_pub_region_post_NE])
  apply(auto simp add: ind_writable_in_view_def K_def sv_abs_mode_equals_def)
  done

lemma check_all_public_redundancy_NN:
  "\<lbrace>UNIV\<rbrace> check_all_public \<lbrace>>N K writable_in_view \<rbrace>"
proof(subst check_all_public_def, rule bind_ruleNN[OF chooseN_ruleNN], intro allI)
  fix l
  show "\<lbrace>if l \<in> order_set UNIV then UNIV else {}\<rbrace> mapM' check_pub_region l \<lbrace>>N K writable_in_view \<rbrace>"
  proof(cases "l \<in> order_set UNIV")
    case True
    thus ?thesis
    proof(simp)
      have characterization: "writable_in_view = (\<Inter>x' \<in> set l. ind_writable_in_view x')"
        using order_set_set[OF True]
        apply(auto simp add: writable_in_view_def ind_writable_in_view_def)
        apply (metis (full_types) INST.exhaust)
        done
      show "\<lbrace>UNIV\<rbrace> mapM' check_pub_region l \<lbrace>>N K writable_in_view\<rbrace>"
        by(auto simp add: characterization
          intro!: mapM'_ruleNN check_pub_region_establishes_redundancy_NN true_postNN
          check_pub_region_redundancy_inv_NN)
    qed
  qed(auto simp add: ex_falsumNN)
qed

lemma check_all_public_redundancy_NE:
  "\<lbrace>UNIV\<rbrace> check_all_public \<lbrace>@N K writable_in_view \<rbrace>"
  apply(rule conseqNE_rule[OF _ check_all_public_post_NE])
  apply(auto simp add: writable_in_view_def K_def sv_abs_mode_equals_def)
  done

lemma startup1_redundancy_NE:
  "\<lbrace>UNIV\<rbrace> startup1 \<lbrace>@N K writable_in_view\<rbrace>"
  apply(rule conseqNE_rule[OF _ startup1_post_NE])
  apply(auto simp add: writable_in_view_def K_def sv_abs_mode_equals_def)
  done

lemma startup_redundancy_NE:
  "\<lbrace>UNIV\<rbrace> startup \<lbrace>@N K writable_in_view\<rbrace>"
  apply(auto simp add: startup_def startup2_def throw_abs_mode_error_def
    K_beta HoareNE_throw' HoareNN_return'
    intro!:
    bind_ruleNE
    bind_ruleNN
    startup1_redundancy_NE
    check_all_public_redundancy_NN
    check_all_public_redundancy_NE
    HoareNE_return
    HoareNN_throw
    HoareNE_vol_ops
    HoareNN_get_abs_mode 
  )
  apply(auto intro: true_postNN[simplified K_def])
  done

lemma throw_abs_mode_error_inv_NN:
  "\<lbrace>P\<rbrace> throw_abs_mode_error e \<lbrace>>N K P\<rbrace>"
  by(auto simp add: unfold_Hoare throw_abs_mode_error_def brute_force)

lemma throw_abs_mode_error_inv_NE:
  "\<lbrace>P\<rbrace> throw_abs_mode_error e \<lbrace>@N K P\<rbrace>"
  by(auto simp add: unfold_Hoare throw_abs_mode_error_def brute_force)

lemma throw_abs_mode_error_NN:
  "\<lbrace>P\<rbrace> throw_abs_mode_error (EB False) \<lbrace>>N K (P \<inter> sv_abs_mode_equals ACNormal) \<rbrace>"
  apply(auto simp add: unfold_Hoare throw_abs_mode_error_def brute_force sv_abs_mode_equals_def)
  apply(case_tac "abs_card_mode a", simp_all)
  done

lemma check_sizes_post_NN:
  "\<lbrace>P\<rbrace> 
    check_sizes upd_f 
  \<lbrace>>N K (if (\<forall>ind \<in> dom upd_f. size (the (upd_f ind)) \<le> capacity (Public ind)) then P else {}) \<rbrace>"
  by(auto simp add: unfold_Hoare check_sizes_alt check_sizes'_def brute_force)

lemma check_sizes_post_NE:
  "\<lbrace>P\<rbrace> 
    check_sizes upd_f 
  \<lbrace>@N \<lambda>e. if e = InvalidInput then P else {} \<rbrace>"
  by(auto simp add: unfold_Hoare check_sizes_alt check_sizes'_def brute_force)

definition writable_in_view_except_upd where
  "writable_in_view_except_upd \<equiv> {(sv, sp). abs_card_mode sv \<noteq> ACFail \<longrightarrow>
    (\<forall>ind. 
        (ind \<notin> abs_updated sv \<longrightarrow> (\<forall>inst. (ind, inst) \<in> writable sp \<longrightarrow> (ind, inst) \<in> in_view sp))
    )
  }"

definition ind_sources_in_view where
  "ind_sources_in_view ind \<equiv> {(sv, sp). abs_card_mode sv \<noteq> ACFail \<longrightarrow>
    (\<forall>inst. inst \<in> arrow_srcs (arrow sp ind) \<longrightarrow> (ind, inst) \<in> writable sp \<longrightarrow> (ind, inst) \<in> in_view sp)
  }"

definition upd_sources_in_view where
  "upd_sources_in_view \<equiv> {(sv, sp). abs_card_mode sv \<noteq> ACFail \<longrightarrow> (\<forall>ind. ind \<in> abs_updated sv \<longrightarrow>
    (\<forall>inst. inst \<in> arrow_srcs (arrow sp ind) \<longrightarrow> (ind, inst) \<in> writable sp \<longrightarrow> (ind, inst) \<in> in_view sp))
  }"


lemma sync_by_arrow_silence_deg_post_mode_NE:
  "\<lbrace>P\<rbrace> sync_by_arrow_silence_deg ind \<lbrace>@N K (sv_abs_mode_equals ACFail) \<rbrace>"
  apply(auto simp add: unfold_Hoare)
  apply(auto simp add: sync_by_arrow_silence_deg_def first_stage)
  apply(simp_all only: get_arrow_def)
  apply(simp_all add: first_stage get_arrow_proj_simps cong: if_cong exceptions.case_cong)
  apply(simp_all only: choice_def Un_iff, safe)
  apply(simp_all only: maybe_mess_up_admin_def)
  apply(simp_all add: first_stage if_choice get_arrow_proj_simps cong: if_cong exceptions.case_cong)
  apply(simp_all only: just_sync_silence_deg_def')
  apply(simp_all add: first_stage if_choice sync_proj_simps cong: if_cong exceptions.case_cong)
  apply(simp_all only: choice_def Un_iff, safe)
  apply(simp_all only: maybe_mess_up_admin_def)
  apply(simp_all add: first_stage if_choice get_arrow_proj_simps cong: if_cong exceptions.case_cong)
  using [[simp_depth_limit=0]]
  using [[simproc del: Product_Type.split_beta]]
  apply(clarsimp_all simp add: sync_by_arrow_silence_deg_def 
    maybe_mess_up_admin_def sv_abs_mode_equals_def
    get_arrow_defs brute_force sync_defs
    split: split_if_asm)
  done

lemma mapM_sync_post_writable:
  assumes l_def: "l \<in> order_set upd"
  shows 
  "\<lbrace>writable_in_view_except_upd \<inter> abs_updated_equals upd \<inter> upd_sources_in_view\<rbrace>
    mapM' sync_by_arrow_silence_deg l
    \<lbrace>>N K writable_in_view\<rbrace>
  "
proof-
  have dist: "distinct l" using l_def
    by (rule order_set_distinct) simp

  have end_result:
    "\<lbrace>\<Inter>x \<in> set l. ind_sources_in_view x\<rbrace>
        mapM' sync_by_arrow_silence_deg l
    \<lbrace>>N K (\<Inter>x \<in> set l. ind_writable_in_view x)\<rbrace>"
  proof(rule mapM'_distinct_ruleNN[OF dist], clarsimp_all)
    fix ind
    assume "ind \<in> set l"
    show "\<lbrace>ind_sources_in_view ind\<rbrace> sync_by_arrow_silence_deg ind \<lbrace>>N K (ind_writable_in_view ind)\<rbrace>"
      apply(auto simp add: unfold_Hoare)
      apply(auto simp add: sync_by_arrow_silence_deg_def first_stage)
      apply(simp_all only: get_arrow_def)
      apply(simp_all add: first_stage get_arrow_proj_simps cong: if_cong exceptions.case_cong)
      apply(simp_all only: choice_def Un_iff, safe)
      apply(simp_all only: maybe_mess_up_admin_def)
      apply(simp_all add: first_stage if_choice get_arrow_proj_simps cong: if_cong exceptions.case_cong)
      apply(simp_all only: choice_def Un_iff, safe)
      apply(simp_all only: just_sync_silence_deg_def')
      apply(simp_all add: first_stage if_choice sync_proj_simps cong: if_cong exceptions.case_cong)
      apply(simp_all only: choice_def Un_iff, safe)
      apply(simp_all only: maybe_mess_up_admin_def)
      apply(simp_all add: first_stage if_choice get_arrow_proj_simps cong: if_cong exceptions.case_cong)
      apply(simp_all only: choice_def Un_iff, safe)
      using [[simp_depth_limit=0]]
      using [[simproc del: Product_Type.split_beta]]
      apply(clarsimp_all simp add: sync_by_arrow_silence_deg_def 
        maybe_mess_up_admin_def 
        get_arrow_defs brute_force sync_defs
        split: split_if_asm)
      apply(tactic {* distinct_subgoals_tac *})
      apply(clarsimp_all simp add: ind_writable_in_view_def ind_sources_in_view_def in_view_def
        min_def split: split_if_asm)
      apply(iterative_simp)+
      using [[simp_depth_limit=10]]
      apply(case_tac[!] "arrow b ind")
      apply(auto)
      done
  next
    fix ind ind' :: pub_indx
    assume "ind' \<noteq> ind"
    thus "\<lbrace>ind_sources_in_view ind'\<rbrace> sync_by_arrow_silence_deg ind \<lbrace>>N K (ind_sources_in_view ind')\<rbrace>"
      apply(auto simp add: unfold_Hoare)
      apply(auto simp add: sync_by_arrow_silence_deg_def first_stage)
      apply(simp_all only: get_arrow_def)
      apply(simp_all add: first_stage get_arrow_proj_simps cong: if_cong exceptions.case_cong)
      apply(simp_all only: choice_def Un_iff, safe)
      apply(simp_all only: maybe_mess_up_admin_def)
      apply(simp_all add: first_stage if_choice get_arrow_proj_simps cong: if_cong exceptions.case_cong)
      apply(simp_all only: choice_def Un_iff, safe)
      apply(simp_all only: just_sync_silence_deg_def')
      apply(simp_all add: first_stage if_choice sync_proj_simps cong: if_cong exceptions.case_cong)
      apply(simp_all only: choice_def Un_iff, safe)
      apply(simp_all only: maybe_mess_up_admin_def)
      apply(simp_all add: first_stage if_choice get_arrow_proj_simps cong: if_cong exceptions.case_cong)
      apply(simp_all only: choice_def Un_iff, safe)
      using [[simp_depth_limit=0]]
      using [[simproc del: Product_Type.split_beta]]
      apply(clarsimp_all simp add: sync_by_arrow_silence_deg_def 
        maybe_mess_up_admin_def 
        get_arrow_defs brute_force sync_defs
        split: split_if_asm)
      apply(tactic {* distinct_subgoals_tac *})
      apply(clarsimp_all simp add: ind_writable_in_view_def ind_sources_in_view_def in_view_def
        min_def split: split_if_asm)
      apply(iterative_simp)+
      using [[simp_depth_limit=10]]
      apply(case_tac[!] "arrow b ind")
      apply(auto)
      done
  next
    fix ind ind' :: pub_indx
    assume "ind' \<noteq> ind"
    thus "\<lbrace>ind_writable_in_view ind'\<rbrace> sync_by_arrow_silence_deg ind \<lbrace>>N K (ind_writable_in_view ind')\<rbrace>"
      apply(auto simp add: unfold_Hoare)
      apply(auto simp add: sync_by_arrow_silence_deg_def first_stage)
      apply(simp_all only: get_arrow_def)
      apply(simp_all add: first_stage get_arrow_proj_simps cong: if_cong exceptions.case_cong)
      apply(simp_all only: choice_def Un_iff, safe)
      apply(simp_all only: maybe_mess_up_admin_def)
      apply(simp_all add: first_stage if_choice get_arrow_proj_simps cong: if_cong exceptions.case_cong)
      apply(simp_all only: choice_def Un_iff, safe)
      apply(simp_all only: just_sync_silence_deg_def')
      apply(simp_all add: first_stage if_choice sync_proj_simps cong: if_cong exceptions.case_cong)
      apply(simp_all only: choice_def Un_iff, safe)
      apply(simp_all only: maybe_mess_up_admin_def)
      apply(simp_all add: first_stage if_choice get_arrow_proj_simps cong: if_cong exceptions.case_cong)
      apply(simp_all only: choice_def Un_iff, safe)
      using [[simp_depth_limit=0]]
      using [[simproc del: Product_Type.split_beta]]
      apply(clarsimp_all simp add: sync_by_arrow_silence_deg_def 
        maybe_mess_up_admin_def 
        get_arrow_defs brute_force sync_defs
        split: split_if_asm)
      apply(tactic {* distinct_subgoals_tac *})
      apply(clarsimp_all simp add: ind_writable_in_view_def in_view_def
        min_def split: split_if_asm)
      apply(iterative_simp)+
      using [[simp_depth_limit=10]]
      apply(case_tac[!] "arrow b ind")
      apply(auto)
      done
  qed
  have inv: 
    "\<lbrace>writable_in_view_except_upd \<inter> abs_updated_equals upd \<rbrace> 
        mapM' sync_by_arrow_silence_deg l
    \<lbrace>>N K (writable_in_view_except_upd \<inter> abs_updated_equals upd)\<rbrace>"
    apply(intro mapM'_invNN allI)
    apply(auto simp add: unfold_Hoare)
    apply(auto simp add: sync_by_arrow_silence_deg_def first_stage)
    apply(simp_all only: get_arrow_def)
    apply(simp_all add: first_stage get_arrow_proj_simps cong: if_cong exceptions.case_cong)
    apply(simp_all only: choice_def Un_iff, safe)
    apply(simp_all only: maybe_mess_up_admin_def)
    apply(simp_all add: first_stage if_choice get_arrow_proj_simps cong: if_cong exceptions.case_cong)
    apply(simp_all only: choice_def Un_iff, safe)
    apply(simp_all only: just_sync_silence_deg_def')
    apply(simp_all add: first_stage if_choice sync_proj_simps cong: if_cong exceptions.case_cong)
    apply(simp_all only: choice_def Un_iff, safe)
    apply(simp_all only: maybe_mess_up_admin_def)
    apply(simp_all add: first_stage if_choice get_arrow_proj_simps cong: if_cong exceptions.case_cong)
    apply(simp_all only: choice_def Un_iff, safe)
    using [[simp_depth_limit=0]]
    using [[simproc del: Product_Type.split_beta]]
    apply(clarsimp_all simp add: sync_by_arrow_silence_deg_def 
      maybe_mess_up_admin_def 
      get_arrow_defs brute_force sync_defs
      split: split_if_asm)
    apply(tactic {* distinct_subgoals_tac *})
    apply(clarsimp_all simp add: writable_in_view_except_upd_def in_view_def abs_updated_equals_def
      min_def split: split_if_asm)
    apply(iterative_simp)+
    apply (smt arrow_srcs.simps(1) less_eq_abs_card_mode.simps(1) singleton_iff point_arrow_to.cases)+
    done
  
  have weaken: 
    "(writable_in_view_except_upd \<inter> abs_updated_equals upd \<inter> (\<Inter>x \<in> set l. ind_writable_in_view x))
    \<subseteq> writable_in_view"
    apply(auto simp add: writable_in_view_except_upd_def ind_writable_in_view_def writable_in_view_def
      abs_updated_equals_def
      order_set_set[OF l_def])
    by (metis (full_types) point_arrow_to.cases)
  
  have char:
    "writable_in_view_except_upd \<inter> abs_updated_equals upd \<inter> upd_sources_in_view
     = writable_in_view_except_upd \<inter> abs_updated_equals upd \<inter> 
        (\<Inter>ind \<in> set l. ind_sources_in_view ind)"
    apply(auto)
    apply(auto simp add: upd_sources_in_view_def abs_updated_equals_def 
      ind_sources_in_view_def order_set_set[OF l_def])
    done

  show ?thesis
    apply(subst char)
    apply(rule conseqNN_rule[where 
      R="K (writable_in_view_except_upd \<inter> abs_updated_equals upd \<inter> 
        (\<Inter>x \<in> set l. ind_writable_in_view x))", OF order_refl])
    apply(rule HoareNN_Int)
    apply(rule inv)
    apply(rule conseqNN_rule[OF _ end_result])
    apply(auto simp add: K_beta del: subsetI intro!: weaken)
    done
qed
  
lemma sync_updated_writable_NN:
  "\<lbrace>writable_in_view_except_upd \<inter> upd_sources_in_view\<rbrace> 
    sync_updated 
  \<lbrace>>N K writable_in_view\<rbrace>"
  apply(auto simp add: sync_updated_def)
  apply(rule bind_ruleNN)
  apply(rule 
    HoareNN_join[OF get_abs_updated_post_NN get_abs_updated_post_NN'[where P=UNIV], simplified])
  apply(auto simp add: K_beta)
  apply(rule bind_ruleNN[OF chooseN_ruleNN])
  apply(auto intro: ex_falsumNN)
  apply(rule bind_ruleNN)
  apply(rule_tac conseqNN_rule[OF _ mapM_sync_post_writable])
  apply(auto simp add: K_beta abs_updated_equals_def)
  apply(auto simp add: unfold_Hoare brute_force writable_in_view_def)
  done

lemma sync_updated_mode_post_NE:
  "\<lbrace>P\<rbrace> sync_updated \<lbrace>@N K (sv_abs_mode_equals ACFail)\<rbrace>"
  by(auto simp add: K_beta sync_updated_def intro!: bind_ruleNE true_postNN
    HoareNE_vol_ops chooseN_ruleNE mapM'_ruleNE sync_by_arrow_silence_deg_post_mode_NE)

lemma rollback_writable_NE:
  "\<lbrace>writable_in_view_except_upd \<inter> upd_sources_in_view\<rbrace> 
    rollback
  \<lbrace>@N K writable_in_view\<rbrace>"
  apply(auto simp add: rollback_def)
  apply(rule bind_ruleNE)
  apply(rule conseqNE_rule[OF order_refl sync_updated_mode_post_NE])
  apply(auto simp add: sv_abs_mode_equals_def writable_in_view_def K_def)[1]
  apply(auto intro!: sync_updated_writable_NN simp add: K_beta HoareNE_throw')
  done

definition ok_sizes where
  "ok_sizes upd_f \<equiv> \<forall>ind \<in> dom upd_f. size (the (upd_f ind)) \<le> capacity (Public ind)"

lemma Int_INT_subset:
  "B \<inter> (\<Inter>x \<in> A. C x) \<subseteq> (\<Inter>x \<in> A. B \<inter> C x)"
  by (metis INT_simps(2) order_refl subset_UNIV)

lemma HoareNN_preserves_Inter:
  assumes
  preserves: "\<forall>x'. x' \<in> A \<longrightarrow> \<lbrace> P x' \<rbrace> m x \<lbrace>>N K (Q x')\<rbrace>"
  and not_elem: "x \<notin> A"
  and subset: "A \<subseteq> B"
  shows "\<lbrace>\<Inter>x' \<in> B. P x'\<rbrace> m x \<lbrace>>N K (\<Inter>x' \<in> A. Q x')\<rbrace>"
proof-
  show ?thesis using assms
    apply(clarsimp simp add: HoareNN_alt Hoare_def Box_def K_beta projectNN_def)
    apply(smt mem_Collect_eq set_mp)
    done
qed


lemma mapM'_distinct_ruleNE:
  assumes
  distinct: "distinct l"
  and establishes: "\<forall>x \<in> set l. \<lbrace>P x\<rbrace> m x \<lbrace>@N Q\<rbrace>"
  and preservesP: "\<forall>x x'. x \<in> set l \<and> x' \<in> set l \<and> x \<noteq> x' \<longrightarrow> \<lbrace> P x \<inter> P x' \<rbrace> m x' \<lbrace>>N K (P x)\<rbrace>"
  shows "\<lbrace>\<Inter>x'\<in> set l. P x'\<rbrace> mapM' m l \<lbrace>@N Q\<rbrace>"
proof(induct l rule: list_distinct_set_induct)
  show "distinct l" using distinct .
next
  case Nil
  show "\<lbrace>\<Inter>x'\<in>set []. P x'\<rbrace> mapM' m [] \<lbrace>@N Q\<rbrace>"
    by(auto simp add: Hoare_alt Hoare_def Box_def unfold_monad project_defs)
next
  case (Cons x xs)
  have rewr: "(\<Inter>x'\<in>set (x # xs). P x') = (\<Inter>x' \<in> set (x#xs). P x \<inter> P x')"
    by(auto)
  have Qx: "\<lbrace>P x\<rbrace> m x \<lbrace>@N Q\<rbrace>" using Cons establishes
    by(blast)
  have P_Int: "\<lbrace>(\<Inter>x'\<in>set (x # xs). P x')\<rbrace> m x \<lbrace>>N K (\<Inter>x\<in>set xs. P x)\<rbrace>"
    apply(subst rewr)
    apply(simp only: Int_commute)
    apply(intro HoareNN_preserves_Inter Cons preservesP, auto)
    by (metis Cons.hyps(1) Cons.hyps(2) Cons.hyps(3) preservesP set_rev_mp)
  show "\<lbrace>\<Inter>x'\<in>set (x # xs). P x'\<rbrace> mapM' m (x # xs) \<lbrace>@N Q\<rbrace>" using Cons Qx P_Int
    apply(simp)
    apply(rule bind_ruleNE)
    apply(erule conseqNE_rule[rotated 1], auto simp add: K_beta)
    done
qed

definition notin_abs_updated where
  "notin_abs_updated ind \<equiv> {(sv, sp). ind \<notin> abs_updated sv}"

lemma mapM'_write_new_redundancy_NE:
  assumes
  l_def: "l \<in> order_set (dom upd_f)"
  and ok_sz: "ok_sizes upd_f"
  shows
  "\<lbrace>writable_in_view_except_upd \<inter> upd_sources_in_view \<inter> abs_updated_equals {}\<rbrace> 
    mapM' (write_new' upd_f) l 
  \<lbrace>@N K (writable_in_view_except_upd \<inter> upd_sources_in_view) \<rbrace>"
proof-
  have subs:
    "writable_in_view_except_upd \<inter> upd_sources_in_view \<inter> abs_updated_equals {}
    \<subseteq> (\<Inter>ind \<in> set l. writable_in_view_except_upd \<inter> upd_sources_in_view \<inter> notin_abs_updated ind)"
    by(auto simp add: order_set_set[OF l_def] abs_updated_equals_def notin_abs_updated_def)

  have dist: "distinct l"
    by (rule order_set_distinct[OF l_def]) simp
  
  have 
    "\<lbrace>\<Inter>ind \<in> set l. writable_in_view_except_upd \<inter> upd_sources_in_view \<inter> notin_abs_updated ind \<rbrace>
        mapM' (write_new' upd_f) l 
    \<lbrace>@N K (writable_in_view_except_upd \<inter> upd_sources_in_view) \<rbrace>"
  proof(rule mapM'_distinct_ruleNE[OF dist], safe, simp_all add: Int_commute Int_left_commute Int_assoc)
    fix ind
    assume "ind \<in> set l"
    show 
      "\<lbrace>upd_sources_in_view \<inter> (writable_in_view_except_upd \<inter> notin_abs_updated ind)\<rbrace> 
        write_new' upd_f ind
      \<lbrace>@N K (upd_sources_in_view \<inter> writable_in_view_except_upd)\<rbrace>"
      apply(auto simp add: unfold_Hoare)
      apply(rename_tac[!] sv sp e sv' sp')
      apply(simp_all only: write_new'_def write_new_def)
      apply(simp_all add: first_stage if_choice 
        cong: if_cong exceptions.case_cong)
      apply(simp_all only: choice_def Un_iff, safe)
      apply(tactic {* distinct_subgoals_tac *})
      apply(clarsimp_all simp add: brute_force write_new_defs)
      apply(iterative_simp)+
      apply(clarsimp_all simp add: writable_in_view_except_upd_def upd_sources_in_view_def
        min_def in_view_def 
        order_set_set
        ok_sizes_def
        split: split_if_asm
      )
      apply(clarsimp_all simp add: notin_abs_updated_def)
      apply(case_tac[!] "abs_card_mode sv", clarsimp_all)
      apply(case_tac[!] x, clarsimp_all)
      apply (metis point_arrow_to.cases)+
      done
  next
    fix ind ind' :: pub_indx
    assume "ind \<in> set l" "ind' \<in> set l" "ind' \<noteq> ind"
    thus 
      "\<lbrace>upd_sources_in_view \<inter> (writable_in_view_except_upd \<inter> (notin_abs_updated ind' \<inter>
             notin_abs_updated ind))\<rbrace>
        write_new' upd_f ind 
      \<lbrace>>N K (upd_sources_in_view \<inter> (writable_in_view_except_upd \<inter> notin_abs_updated ind')) \<rbrace>" 
      using ok_sz l_def
      apply(auto simp add: unfold_Hoare)
      apply(simp_all only: write_new'_def write_new_def)
      apply(simp_all add: first_stage if_choice 
        cong: if_cong exceptions.case_cong)
      apply(simp_all only: choice_def Un_iff, safe)
      apply(tactic {* distinct_subgoals_tac *})
      apply(clarsimp_all simp add: brute_force write_new_defs)
      apply(clarsimp_all simp add: writable_in_view_except_upd_def upd_sources_in_view_def
        min_def in_view_def 
        order_set_set
        ok_sizes_def
        split: split_if_asm
      )
      apply(clarsimp_all simp add: notin_abs_updated_def)
      done
  qed
  thus ?thesis
    apply-
    apply(erule conseqNE_rule[OF subs])
    apply(auto)
    done
next
qed

lemma set_abs_updated_post_NN:
  "\<lbrace>writable_in_view\<rbrace> set_abs_updated S \<lbrace>>N K (writable_in_view \<inter> abs_updated_equals S) \<rbrace>"
  by(auto simp add: unfold_Hoare brute_force abs_updated_equals_def writable_in_view_def)

lemma mapM'_write_new_post_NE:
  "\<lbrakk> ok_sizes upd_f; l \<in> order_set (dom upd_f) \<rbrakk> \<Longrightarrow>
  \<lbrace>UNIV\<rbrace> 
    mapM' (write_new' upd_f) l 
  \<lbrace>@N \<lambda>e. if e = FailMode 
    then sv_abs_mode_equals ACFail 
    else if (\<exists>v. e = Degraded v)
    then UNIV
    else {}
  \<rbrace>"
  apply(rule mapM'_ruleNE)
  apply(auto simp add: unfold_Hoare)
  apply(simp_all only: write_new'_def write_new_def)
  apply(simp_all add: first_stage if_choice 
    cong: if_cong exceptions.case_cong)
  apply(simp_all only: choice_def Un_iff, safe)
  apply(tactic {* distinct_subgoals_tac *})
  apply(clarsimp_all simp add: brute_force write_new_defs)
  apply(clarsimp_all simp add: sv_abs_mode_equals_def
    min_def
    order_set_set
    ok_sizes_def
    split: split_if_asm
  )
  apply (metis domI leD the.simps)
  done

lemma write_new_rollback:
  "\<lbrakk>ok_sizes upd_f; x \<in> order_set (dom upd_f)\<rbrakk> \<Longrightarrow> 
        \<lbrace>writable_in_view \<inter> abs_updated_equals {}\<rbrace> 
            <try> mapM' (write_new' upd_f) x 
            <catch> (\<lambda>e. case e of Degraded x \<Rightarrow> rollback
                                       | _ \<Rightarrow> throw e) 
        \<lbrace>@N K writable_in_view\<rbrace>"
  apply(subgoal_tac
    "
        \<lbrace>writable_in_view_except_upd \<inter> upd_sources_in_view \<inter> abs_updated_equals {} \<rbrace>
            <try> mapM' (write_new' upd_f) x 
            <catch> (\<lambda>e. case e of Degraded x \<Rightarrow> rollback
                                       | _ \<Rightarrow> throw e) 
        \<lbrace>@N K writable_in_view\<rbrace>"
  )
  apply(erule conseqNE_rule[rotated 1])
  apply(auto simp add: writable_in_view_def writable_in_view_except_upd_def upd_sources_in_view_def
    abs_updated_equals_def)[2]
  apply(rule try_catch_ruleNE[OF
    HoareNE_join[OF mapM'_write_new_redundancy_NE mapM'_write_new_post_NE, simplified]]
  )
  apply(auto split: exceptions.split intro: ex_falsumNE simp add: K_beta HoareNE_throw' 
    intro!: rollback_writable_NE)
  apply(auto simp add: writable_in_view_def writable_in_view_except_upd_def upd_sources_in_view_def
    abs_updated_equals_def sv_abs_mode_equals_def)[1]
  done

lemma pre_commit_writable_NE:
  "ok_sizes upd_f \<Longrightarrow>
  \<lbrace>writable_in_view\<rbrace> pre_commit upd_f \<lbrace>@N K writable_in_view \<rbrace>"
  apply(auto simp add: pre_commit_def)
  apply(intro bind_ruleNE HoareNE_vol_ops)
  apply(rule set_abs_updated_post_NN)
  apply(auto simp add: K_beta)
  apply(intro bind_ruleNE chooseN_ruleNE)
  apply(rule chooseN_ruleNN)
  apply(auto intro: ex_falsumNE write_new_rollback)
  done

lemma rollforward_writable_NN:
  "\<lbrace>writable_in_view_except_upd \<inter> upd_sources_in_view\<rbrace> 
    rollforward
  \<lbrace>>N K writable_in_view\<rbrace>"
  by(auto simp only: rollforward_def intro: sync_updated_writable_NN)

fun is_arrow_tgt_alt :: "sync_direction \<Rightarrow> INST \<Rightarrow> bool" where
  "is_arrow_tgt_alt SR Secondary = True"
  | "is_arrow_tgt_alt SL Primary = True"
  | "is_arrow_tgt_alt SEq _ = True"
  | "is_arrow_tgt_alt _ _ = False"


definition upd_arrow_all_reliable where
  "upd_arrow_all_reliable \<equiv> {(sv, sp). \<forall>ind \<in> abs_updated sv. arrow sp ind \<noteq> SBot 
    \<and> (\<forall>inst. (ind, inst) \<in> reliable sp)}"

lemma switch_arrows_writable_NN:
  "\<lbrace>sv_abs_mode_equals ACNormal \<inter> all_reliable_inv \<inter> abs_updated_equals x \<inter> 
        writable_in_view_except_upd\<rbrace> 
    switch_arrows x 
  \<lbrace>>N K (writable_in_view_except_upd \<inter> upd_sources_in_view)\<rbrace>"
  apply(auto simp add: unfold_Hoare)
  apply(auto simp add: switch_arrows_def first_stage)
  apply(simp_all only: choice_def Un_iff, safe)
  apply(clarsimp_all simp add: switch_arrows_defs brute_force)
  apply(clarsimp_all simp add: writable_in_view_except_upd_def abs_updated_equals_def
    sv_abs_mode_equals_def all_reliable_inv_def
    in_view_def upd_sources_in_view_def)
  done

lemma switch_arrows_writable_NE:
  "\<lbrace>sv_abs_mode_equals ACNormal \<inter> all_reliable_inv \<inter> abs_updated_equals x \<inter> 
        writable_in_view_except_upd\<rbrace> 
    switch_arrows x 
  \<lbrace>@N \<lambda>e. if e = FailMode then sv_abs_mode_equals ACFail 
        else if (\<exists>v. e = Degraded v) 
            then writable_in_view_except_upd \<inter> upd_sources_in_view
        else {}\<rbrace>"
  apply(auto simp add: unfold_Hoare)
  apply(auto simp add: switch_arrows_def first_stage)
  apply(simp_all only: choice_def Un_iff, safe)
  apply(tactic {* distinct_subgoals_tac *})
  apply(clarsimp_all simp add: switch_arrows_defs brute_force)
  apply(clarsimp_all simp add: writable_in_view_except_upd_def abs_updated_equals_def
    all_reliable_inv_def
    sv_abs_mode_equals_def
    in_view_def upd_sources_in_view_def)
  apply(iterative_simp)+
  done

(* TODO: miracle cure:
  apply(metis (no_types) finite infinite_UNIV)
    *)

lemma do_commit_writable_NN:
  "\<lbrace>sv_abs_mode_equals ACNormal \<inter> all_reliable_inv \<inter> 
        writable_in_view_except_upd\<rbrace> 
    do_commit
  \<lbrace>>N K (writable_in_view_except_upd \<inter> upd_sources_in_view) \<rbrace>"
  apply(auto simp add: do_commit_def)
  apply(rule bind_ruleNN)
  apply(rule HoareNN_join[OF get_abs_updated_post_NN'[where P=UNIV] get_abs_updated_post_NN, simplified])
  apply(auto simp add: K_beta)
  apply(auto simp add: K_beta Int_commute Int_left_commute)
  apply(rule try_catch_ruleNN)
  apply(rule conseqNN_rule[OF _ switch_arrows_writable_NN])
  apply(auto simp add: K_beta)[2]
  apply(rule switch_arrows_writable_NE[simplified Int_commute Int_left_commute])
  apply(auto split: exceptions.split simp add: K_beta HoareNN_return' intro!: HoareNN_throw 
    rollback_post_NN)
  done

lemma do_commit_writable_NE:
  "\<lbrace>sv_abs_mode_equals ACNormal \<inter> all_reliable_inv \<inter> 
        writable_in_view_except_upd\<rbrace> 
    do_commit
  \<lbrace>@N K writable_in_view \<rbrace>"
  apply(auto simp add: do_commit_def)
  apply(rule bind_ruleNE[OF HoareNE_vol_ops(6)])
  apply(rule HoareNN_join[OF get_abs_updated_post_NN'[where P=UNIV] get_abs_updated_post_NN, simplified])
  apply(auto simp add: K_beta)
  apply(auto simp add: K_beta Int_commute Int_left_commute)
  apply(rule try_catch_ruleNE)
  apply(rule switch_arrows_writable_NE[simplified Int_commute Int_left_commute])
  apply(auto split: exceptions.split simp add: K_beta HoareNE_throw' intro!: HoareNE_return 
    rollback_post_NN)
  apply(auto simp add: sv_abs_mode_equals_def upd_sources_in_view_def writable_in_view_def)[1]
  apply(rule rollback_writable_NE[simplified Int_commute Int_left_commute])
  done

lemma mapM'_write_reliable_NN:
  assumes l_def: "l \<in> order_set (dom upd_f)"
  shows
  "\<lbrace>sv_abs_mode_equals ACNormal \<inter> all_reliable_inv \<inter> writable_in_view \<inter> abs_updated_equals {}\<rbrace> 
    mapM' (write_new' upd_f) l
  \<lbrace>>N K (sv_abs_mode_equals ACNormal \<inter> all_reliable_inv \<inter>  writable_in_view_except_upd) \<rbrace>"
proof-
  have dist: "distinct l"
    by (rule order_set_distinct[OF l_def]) simp
  have subs:
    "sv_abs_mode_equals ACNormal \<inter> all_reliable_inv \<inter> 
        writable_in_view \<inter> abs_updated_equals {}
    \<subseteq> sv_abs_mode_equals ACNormal \<inter> all_reliable_inv \<inter> 
        writable_in_view_except_upd"
    by(auto simp add: writable_in_view_except_upd_def writable_in_view_def
      upd_arrow_all_reliable_def abs_updated_equals_def)
  have
    "\<lbrace>sv_abs_mode_equals ACNormal \<inter> all_reliable_inv \<inter> writable_in_view_except_upd \<rbrace>
        mapM' (write_new' upd_f) l 
    \<lbrace>>N K (sv_abs_mode_equals ACNormal \<inter> all_reliable_inv \<inter>  writable_in_view_except_upd) \<rbrace>"
    apply(rule mapM'_invNN)
    apply(auto simp add: unfold_Hoare)
    apply(simp_all only: write_new'_def write_new_def)
    apply(simp_all add: first_stage if_choice 
      cong: if_cong exceptions.case_cong)
    apply(simp_all only: choice_def Un_iff, safe)
    apply(tactic {* distinct_subgoals_tac *})
    apply(clarsimp_all simp add: brute_force write_new_defs)
    apply(clarsimp_all simp add: writable_in_view_except_upd_def
      notin_abs_updated_def
      sv_abs_mode_equals_def all_reliable_inv_def
      min_def in_view_def 
      order_set_set
      ok_sizes_def
      insert_UNIV
      split: split_if_asm
    )
    done
  from this[THEN conseqNN_rule[OF subs]] show ?thesis
    by(simp)
qed
    
lemma set_abs_updated_post_NN':
  "\<lbrace>sv_abs_mode_equals ACNormal \<inter> all_reliable_inv \<inter> writable_in_view \<rbrace>
    set_abs_updated S
  \<lbrace>>N K (sv_abs_mode_equals ACNormal \<inter> all_reliable_inv \<inter> writable_in_view \<inter> abs_updated_equals S) \<rbrace>"
  by(auto simp add: unfold_Hoare brute_force sv_abs_mode_equals_def all_reliable_inv_def 
    abs_updated_equals_def writable_in_view_def)

lemma pre_commit_writable_NN:
  "\<lbrace>sv_abs_mode_equals ACNormal \<inter> all_reliable_inv \<inter> writable_in_view\<rbrace>
    pre_commit upd_f
  \<lbrace>>N K (sv_abs_mode_equals ACNormal \<inter> all_reliable_inv \<inter> writable_in_view_except_upd)\<rbrace> "
  apply(auto simp add: pre_commit_def K_beta
    intro!: 
    bind_ruleNN
    try_catch_ruleNN
    set_abs_updated_post_NN'
    mapM'_write_reliable_NN
    chooseN_ruleNN
    intro: ex_falsumNE
  )
  apply(rule ex_falsumNN)
  apply(rule true_postNE)
  apply(auto simp add: K_beta split: exceptions.split intro!: HoareNN_throw ex_falsumNE 
    rollback_post_NN)
  done

lemma throw_abs_mode_error_post_NN:
  "\<lbrace>P\<rbrace> throw_abs_mode_error v \<lbrace>>N K (sv_abs_mode_equals ACNormal \<inter> P)\<rbrace>"
  apply(auto simp add: unfold_Hoare throw_abs_mode_error_def sv_abs_mode_equals_def brute_force)
  apply(case_tac "abs_card_mode a", simp_all)
  done

lemma update_redundancy_NE:
  "\<lbrace>all_reliable_inv \<inter> writable_in_view\<rbrace>
    update upd_f
  \<lbrace>@N K writable_in_view\<rbrace>"
  apply(auto simp add: update_def)
  apply(rule bind_ruleNE)
  apply(auto simp add: unfold_Hoare throw_abs_mode_error_def brute_force writable_in_view_def)[1]
  apply(rule throw_abs_mode_error_post_NN)
  apply(auto simp add: K_beta)
  apply(rule bind_ruleNE)
  apply(auto simp add: unfold_Hoare check_sizes_alt check_sizes'_def brute_force writable_in_view_def)[1]
  apply(rule check_sizes_post_NN)
  apply(auto simp add: K_beta Int_commute Int_left_commute intro: ex_falsumNE)
  apply(rule bind_ruleNE)
  apply(rule conseqNE_rule[OF _ pre_commit_writable_NE])
  apply(auto simp add: ok_sizes_def)[3]
  apply(rule pre_commit_writable_NN[simplified Int_commute Int_left_commute])
  apply(auto simp add: K_beta Int_commute Int_left_commute intro: ex_falsumNE)
  apply(rule bind_ruleNE)
  apply(rule do_commit_writable_NE[simplified Int_left_commute Int_commute])
  apply(rule do_commit_writable_NN[simplified Int_left_commute Int_commute])
  apply(auto simp add: K_beta Int_commute Int_left_commute intro: ex_falsumNE)
  apply(rule bind_ruleNE)
  apply(simp add: rollforward_def)
  apply(rule conseqNE_rule[OF order_refl sync_updated_mode_post_NE])
  apply(auto simp add: sv_abs_mode_equals_def writable_in_view_def K_beta)[1]
  apply(rule rollforward_writable_NN[simplified Int_left_commute Int_commute])
  apply(auto simp add: unfold_Hoare throw_abs_mode_error_def brute_force writable_in_view_def)[1]
  done

lemma update_redundancy_NN:
  "\<lbrace>all_reliable_inv \<inter> writable_in_view\<rbrace>
    update upd_f
  \<lbrace>>N K writable_in_view\<rbrace>"
  apply(auto simp add: update_def)
  apply(rule bind_ruleNN)
  apply(rule throw_abs_mode_error_post_NN)
  apply(auto simp add: K_beta)
  apply(rule bind_ruleNN)
  apply(rule check_sizes_post_NN)
  apply(auto simp add: K_beta Int_commute Int_left_commute intro: ex_falsumNN)
  apply(rule bind_ruleNN)
  apply(rule pre_commit_writable_NN[simplified Int_commute Int_left_commute])
  apply(auto simp add: K_beta Int_commute Int_left_commute intro: ex_falsumNN)
  apply(rule bind_ruleNN)
  apply(rule do_commit_writable_NN[simplified Int_left_commute Int_commute])
  apply(auto simp add: K_beta Int_commute Int_left_commute intro: ex_falsumNN)
  apply(rule bind_ruleNN)
  apply(rule rollforward_writable_NN[simplified Int_left_commute Int_commute])
  apply(auto simp add: unfold_Hoare throw_abs_mode_error_def brute_force writable_in_view_def)[1]
  done

lemma get_arrow_writable_NN:
  "\<lbrace>sv_abs_mode_equals x \<inter> writable_in_view\<rbrace> 
        get_arrow ind 
  \<lbrace>>N K (writable_in_view)\<rbrace>"
  apply(auto simp add: unfold_Hoare sv_abs_mode_equals_def writable_in_view_def
    in_view_def get_arrow_defs brute_force min_def split: split_if_asm)
  done

lemma weaken_pre_NN:
  "\<lbrakk> P \<subseteq> Q; \<lbrace>Q\<rbrace> m \<lbrace>>N R\<rbrace> \<rbrakk> \<Longrightarrow> \<lbrace>P\<rbrace> m \<lbrace>>N R\<rbrace>"
  by(rule conseqNN_rule, auto)

definition writable_in_view_except where
  "writable_in_view_except S = {(sv, sp). abs_card_mode sv \<noteq> ACFail \<longrightarrow> writable sp - S \<subseteq> in_view sp}"

lemma read_writable_NE:
  "\<lbrace>writable_in_view\<rbrace> read ind inst 
  \<lbrace>@N \<lambda>e. 
    if e = FailRead 
    then writable_in_view_except {(ind, inst)}
    else writable_in_view 
  \<rbrace>"
  by(auto simp add: unfold_Hoare read_defs throw_abs_mode_error_def brute_force
    writable_in_view_except_def
    writable_in_view_def in_view_def min_def split: split_if_asm)

lemma fetch_same_writable_NN:
  "\<lbrace>writable_in_view\<rbrace> 
    fetch_same ind
  \<lbrace>>N K writable_in_view\<rbrace>"
  apply(auto simp add: unfold_Hoare K_def)
  apply(simp_all only: fetch_same_def)
  apply(simp_all add: first_stage cong: exceptions.case_cong if_cong)
  apply(simp_all only: choice_def Un_iff, safe)
  apply(simp_all only: read_def)
  apply(simp_all add: first_stage read_proj_simps cong: exceptions.case_cong if_cong)
  apply(simp_all only: choice_def Un_iff, safe)
  apply(simp_all only: sync_def)
  apply(simp_all add: first_stage sync_proj_simps cong: exceptions.case_cong if_cong)
  apply(auto simp add: brute_force read_defs sync_defs)
  apply(auto simp add: writable_in_view_def in_view_def)
  done
 
lemma fetch_same_writable_NE:
  "\<lbrace>sv_abs_mode_neq ACFail \<inter> writable_in_view\<rbrace> 
    fetch_same ind
  \<lbrace>@N K writable_in_view\<rbrace>"
  apply(auto simp add: unfold_Hoare K_def)
  apply(simp_all only: fetch_same_def)
  apply(simp_all add: first_stage cong: exceptions.case_cong if_cong)
  apply(simp_all only: read_def)
  apply(simp_all add: first_stage read_proj_simps cong: exceptions.case_cong if_cong)
  apply(simp_all only: choice_def Un_iff, safe)
  apply(simp_all only: sync_def)
  apply(simp_all add: first_stage sync_proj_simps cong: exceptions.case_cong if_cong)
  apply(simp_all only: choice_def Un_iff, safe)
  apply(clarsimp_all simp add: brute_force read_defs read_or_fail_defs sync_defs)
  apply(iterative_simp)+
  apply(clarsimp_all simp add: writable_in_view_def in_view_def sv_abs_mode_neq_def)
  apply (metis (lifting, full_types) INST.exhaust mem_Collect_eq set_mp split_conv)+
  done
  
lemma get_arrow_writable_NN':
  "x \<noteq> ACFail \<Longrightarrow>
    \<lbrace>sv_abs_mode_equals x \<inter> writable_in_view\<rbrace> 
        get_arrow ind 
  \<lbrace>>N K (sv_abs_mode_neq ACFail \<inter> writable_in_view)\<rbrace>"
  apply(auto simp add: unfold_Hoare sv_abs_mode_equals_def writable_in_view_def
    sv_abs_mode_neq_def
    in_view_def get_arrow_defs brute_force min_def split: split_if_asm)
  done

lemma fetch_redundancy_NN:
  "\<lbrace>writable_in_view\<rbrace>
    fetch ind
  \<lbrace>>N K writable_in_view\<rbrace>"
  apply(auto simp add: fetch_def)
  apply(rule bind_ruleNN[OF get_abs_mode_ruleNN])
  apply(auto simp add: K_beta intro: ex_falsumNN)
  apply(rule bind_ruleNN, auto intro!: ex_falsumNN HoareNN_throw)
  apply(rule bind_ruleNN_same)
  apply(simp add: HoareNN_return' K_beta)
  apply(auto)
  apply(rule bind_ruleNN)
  apply(rule get_arrow_writable_NN')
  apply(auto intro!: bind_ruleNN[OF get_arrow_arrow_post_NN] ex_falsumNN simp add: K_beta)
  apply(auto simp add: unfold_Hoare read_or_fail_defs throw_abs_mode_error_def brute_force
    writable_in_view_def in_view_def split: split_if_asm)[1]
  apply(rule bind_ruleNN)
  apply(rule weaken_pre_NN[OF _ fetch_same_writable_NN])
  apply(clarsimp)
  apply(auto intro!: bind_ruleNN_same HoareNN_get_abs_mode HoareNN_throw
    simp add: K_beta throw_abs_mode_error_def HoareNN_return')[1]
  apply(auto simp add: unfold_Hoare read_or_fail_defs throw_abs_mode_error_def brute_force
    writable_in_view_def in_view_def split: split_if_asm)[1]
  done

lemma fetch_redundancy_NE:
  "\<lbrace>writable_in_view\<rbrace>
    fetch ind
  \<lbrace>@N K writable_in_view\<rbrace>"
  apply(auto simp add: fetch_def)
  apply(rule bind_ruleNE[OF _ get_abs_mode_ruleNN])
  apply(rule HoareNE_vol_ops)
  apply(auto simp add: K_beta intro: ex_falsumNN)
  apply(rule bind_ruleNE, auto intro!: ex_falsumNN simp add: HoareNE_throw' K_beta 
    intro!: HoareNN_throw)
  apply(rule ex_falsumNE)
  apply(rule bind_ruleNE_same[OF HoareNE_return])
  apply(simp add: HoareNN_return' K_beta)
  apply(auto)
  apply(rule bind_ruleNE[OF _ get_arrow_writable_NN'])
  apply(auto simp add: unfold_Hoare get_arrow_defs brute_force writable_in_view_def)[2]
  apply(auto simp add: K_beta)
  apply(auto simp add: unfold_Hoare read_or_fail_defs throw_abs_mode_error_def brute_force
    writable_in_view_def in_view_def min_def split: split_if_asm)[1]
  apply(rule bind_ruleNE[OF fetch_same_writable_NE])
  apply(rule weaken_pre_NN[OF _ fetch_same_writable_NN])
  apply(clarsimp)
  apply(auto simp add: throw_abs_mode_error_def K_beta HoareNN_return' HoareNE_throw'
    intro!: bind_ruleNE_same bind_ruleNN_same
    HoareNN_get_abs_mode HoareNE_vol_ops
    HoareNN_throw HoareNE_return)[1]
  apply(auto simp add: unfold_Hoare read_or_fail_defs throw_abs_mode_error_def brute_force
    writable_in_view_def in_view_def min_def split: split_if_asm)[1]
  done

lemma try_catchR_ruleN:
  "\<lbrakk> \<lbrace>P\<rbrace> m \<lbrace>>R Q\<rbrace>; \<lbrace>P\<rbrace> m \<lbrace>@R Q'\<rbrace>; \<lbrace>Q'\<rbrace> h \<lbrace>>R Q\<rbrace> \<rbrakk> \<Longrightarrow>
  \<lbrace>P\<rbrace> <tryR> m <catchR> h \<lbrace>>R Q\<rbrace>"
  by(force simp add: Hoare_defs BoxN_def BoxR_def try_catchR_some_decompose)

lemma UNIV_subset: "(UNIV \<subseteq> X) = (X = UNIV)"
  by blast

lemma Collect_UNIV: "({x. P x} = UNIV) = (\<forall>x. P x)"
  by(auto)

lemma true_postR:
  "\<lbrace>P\<rbrace> m \<lbrace>@R UNIV\<rbrace>"
  by(auto simp add: HoareR_def BoxR_def)

lemma rec_tryR_establish_inv:
  "\<lbrace>UNIV\<rbrace> h \<lbrace>>R Q\<rbrace> \<Longrightarrow> \<lbrace>P\<rbrace> rec_tryR h \<lbrace>>R Q\<rbrace>"
  apply(auto simp add: unfold_Hoare project_defs UNIV_subset Collect_UNIV)
  apply(erule rec_tryR.cases, auto)
  done

lemma update_call_redundancy:
  "\<lbrace>all_reliable_inv \<inter> writable_in_view \<rbrace>
    <tryR> update upd_f <catchR> rec_tryR startup
  \<lbrace>>R K writable_in_view \<rbrace>
  "
  apply(auto intro!: try_catchR_ruleN[OF _ true_postR] rec_tryR_establish_inv)
  apply(auto simp add: decompose_HoareN
    update_redundancy_NN update_redundancy_NE rec_tryR_establish_inv
    startup_post_NN startup_redundancy_NE simp add: decompose_HoareN)
  done

lemma fetch_call_redundancy:
  "\<lbrace>writable_in_view \<rbrace>
    <tryR> fetch ind <catchR> rec_tryR startup
  \<lbrace>>R K writable_in_view \<rbrace>
  "
  apply(auto intro!: try_catchR_ruleN[OF _ true_postR] rec_tryR_establish_inv)
  apply(auto simp add: decompose_HoareN
    fetch_redundancy_NN fetch_redundancy_NE rec_tryR_establish_inv
    startup_post_NN startup_redundancy_NE simp add: decompose_HoareN)
  done

lemma idle_restart_redundancy:
  "\<lbrace>P\<rbrace>
    <tryR> restart_mangle_sv <catchR> rec_tryR startup
  \<lbrace>>R K writable_in_view \<rbrace>
  "
  apply(auto intro!: try_catchR_ruleN[OF _ true_postR] rec_tryR_establish_inv)
  apply(auto simp add: decompose_HoareN
    rec_tryR_establish_inv
    startup_post_NN startup_redundancy_NE simp add: decompose_HoareN)
  apply(auto simp add: unfold_Hoare brute_force)
  done

end

