theory Abs4_Specification
  imports Abs4_UpdateDefs Abs4_FetchDefs Abs4_StartupDefs  "../Pmm_Specification"
begin

definition abs4_trans 
  :: "((abs_vol_mem \<times> 'c abs4_state) \<times> (abs_vol_mem \<times> 'c :: size abs4_state))set" where
  "abs4_trans \<equiv> \<Union>upd_f ind. set_fun_into_rel (
    ((try_rec_tryR (Abs4_UpdateDefs.update upd_f) Abs4_StartupDefs.startup)\<Down>SN)
    [+] ((try_rec_tryR (Abs4_FetchDefs.fetch ind) Abs4_StartupDefs.startup)\<Down>SN)
    [+] ((try_rec_tryR 
        (restart_mangle_sv :: (unit, 'c)abs4_monad)
        Abs4_StartupDefs.startup)\<Down>SN)
  )"

definition abs4_init :: "(abs_vol_mem \<times> 'c :: size abs4_state)set" where
  "abs4_init \<equiv> {(sv, sp). \<forall>ind. 
    (arrow sp ind = SEq \<and> (ind, Primary) \<in> reliable sp \<and> (ind, Secondary) \<in> reliable sp \<longrightarrow>
        abs4_state.memory sp ind Primary = abs4_state.memory sp ind Secondary)
    \<and> ((ind, Primary) \<in> in_view sp \<longrightarrow> abs4_state.admin_state sp \<noteq> LDead)
    \<and> ((ind, Secondary) \<in> in_view sp \<longrightarrow> abs4_state.admin_state sp \<noteq> LDead)
  }"

definition abs4_ts 
  :: "(abs_vol_mem \<times> 'c :: size abs4_state)TS" where
  "abs4_ts \<equiv> \<lparr> 
    init = abs4_init, 
    init_trans = set_fun_into_rel 
        ((Abs4_StartupDefs.startup :: (unit, 'c)abs4_monad)\<Down>SN), 
    trans = abs4_trans 
  \<rparr>"

definition abs4_spec :: "(abs_vol_mem \<times> 'c abs4_state, abs_vol_mem \<times> 'c :: size abs4_state)spec" where
  "abs4_spec \<equiv> TS.extend abs4_ts (spec.fields id)"

end
