theory Abs4_StartupDefs
imports Abs4_CommonDefs "../Composition"
begin

definition startup1_NN
  :: "(unit, abs_vol_mem \<times> 'c abs4_state)nds_monad"
  where
  "startup1_NN \<equiv>
  (\<lambda>(sv, sp). {((), sv', sp)|sv'.
    (\<forall>ind. arrow sp ind \<noteq> SBot)
    \<and> admin_state sp = LOK
    \<and> sv' = \<lparr> abs_card_mode = ACNormal, abs_updated = {} \<rparr>
  })
  [+]
  (\<lambda>(sv, sp). {((), sv', sp')|sv' sp' unwr.
    (\<forall>ind. arrow sp ind \<noteq> SBot)
    \<and> LDegraded \<le> admin_state sp
    \<and> sp' = sp\<lparr>
        writable := writable sp - unwr,
        admin_state := LDegraded
    \<rparr>
    \<and> sv' = \<lparr> abs_card_mode = ACDegraded, abs_updated = {} \<rparr>
  })
  "

definition startup1_NE
  :: "('c exceptions, abs_vol_mem \<times> 'c abs4_state)nds_monad"
  where
  "startup1_NE \<equiv>
  (\<lambda>(sv, sp). {(FailMode, sv', sp')|sv' sp' unr unwr arr_del.
    sv' = \<lparr> abs_card_mode = ACFail, abs_updated = {} \<rparr>
    \<and> sp' = sp\<lparr>
        arrow := override_on (arrow sp) (K SBot) arr_del,
        reliable := reliable sp - unr,
        writable := writable sp - unwr,
        admin_state := LDead
    \<rparr>
  })
  "

definition startup1 :: "(unit, 'c)abs4_monad" where
  "startup1 \<equiv> compose startup1_NN startup1_NE empty"

definition read_or_fail_silence_deg
  :: "pub_indx \<Rightarrow> INST \<Rightarrow> ('c, 'c :: size)abs4_monad"
  where read_or_fail_silence_deg_def[monad_def]:
  "read_or_fail_silence_deg ind inst \<equiv>
    <try> read_or_fail ind inst <catch> (\<lambda>e. case e of
        Degraded v \<Rightarrow> return (get_exc_val_cnt v)
        | _ \<Rightarrow> throw e
    )
  "
 
definition check_pub_same
  :: "pub_indx \<Rightarrow> (unit, 'c :: size)abs4_monad" where
  check_pub_same_def[monad_def]:
  "check_pub_same pind \<equiv>
    <try> do {
        read pind Primary;
        (<try> do {
            read pind Secondary;
            return ()
        } <catch>
            (\<lambda>e. case e of
                FailRead \<Rightarrow> just_sync_silence_deg Secondary Primary pind 
                | Degraded _ \<Rightarrow> return ()
                | _ \<Rightarrow> throw e
            )
        )
   } <catch> (\<lambda>e. case e of
        FailRead \<Rightarrow> just_sync_silence_deg Primary Secondary pind 
        | Degraded v \<Rightarrow> (
            if v = EU
            then read_or_fail_silence_deg pind Secondary \<guillemotright> return ()
            else
                return ()
        )
        | _ \<Rightarrow> throw e
    )
  "

definition check_pub_region ::
  "pub_indx \<Rightarrow> (unit, 'c :: size)abs4_monad" where
  check_pub_region_def[monad_def]:
  "check_pub_region pind \<equiv> do {
    arr \<leftarrow> get_arrow pind;
    if arr = SEq
    then do { check_pub_same pind; maybe_mess_up_admin pind }
    else 
        if arr = SR
        then just_sync_silence_deg' Secondary Primary pind 
        else just_sync_silence_deg' Primary Secondary pind 
  }"

definition check_all_public :: 
  "(unit, 'c :: size) abs4_monad" where
  check_all_public_def[monad_def]:
  "check_all_public \<equiv> do {
    l \<leftarrow> chooseN (order_set UNIV);
    mapM' check_pub_region l
  }"

definition startup2 :: "('a, 'c :: size)abs4_monad" where
  startup2_def[monad_def]:
  "startup2 \<equiv> do {
    check_all_public;
    throw_abs_mode_error EU;
    throw StartedExc
  }"
  
definition startup :: "('a, 'c :: size)abs4_monad" where
  startup_def[monad_def]:
  "startup \<equiv> do {
    startup1;
    startup2
  }"

end
            

