theory Abs5_Specification
  imports Abs5_UpdateDefs Abs5_FetchDefs Abs5_StartupDefs "../Pmm_Specification"
begin

definition abs5_trans 
  :: "(('c abs5_vol_state \<times> 'c abs5_state) \<times> ('c abs5_vol_state \<times> 'c :: size abs5_state))set" where
  "abs5_trans \<equiv> \<Union>upd_f ind. set_fun_into_rel (
    ((try_rec_tryR (Abs5_UpdateDefs.update upd_f) Abs5_StartupDefs.startup)\<Down>SN)
    [+] ((try_rec_tryR (Abs5_FetchDefs.fetch ind) Abs5_StartupDefs.startup)\<Down>SN)
    [+] ((try_rec_tryR 
        (restart_mangle_sv :: (unit, 'c)abs5_monad)
        Abs5_StartupDefs.startup)\<Down>SN)
  )"

definition abs5_ts 
  :: "('c abs5_vol_state \<times> 'c :: size abs5_state)TS" where
  "abs5_ts \<equiv> \<lparr> 
    init = UNIV, 
    init_trans = set_fun_into_rel 
        ((Abs5_StartupDefs.startup :: (unit, 'c)abs5_monad)\<Down>SN), 
    trans = abs5_trans 
  \<rparr>"

fun abs5_obs where
  "abs5_obs (sv, sp) = (abs_card_mode sv, abs_mem_obs sp)"

definition abs5_spec 
  :: "('c abs5_vol_state \<times> 'c abs5_state, abs_card_mode \<times> 'c :: size obs_abs_mem)spec" 
  where
  "abs5_spec \<equiv> TS.extend abs5_ts (spec.fields abs5_obs)"

end