theory Abs5_StartupDefs
imports Abs5_CommonDefs "../Composition"
begin

definition startup1_NN
  :: "(unit, 'c abs5_vol_state \<times> 'c abs5_state)nds_monad"
  where
  "startup1_NN \<equiv>
  (\<lambda>(sv, sp). {((), sv', sp)|sv'.
    admin_state sp = LOK
    \<and> sv' = \<lparr> abs_card_mode = ACNormal, abs_updated = {}, upd_mem = Map.empty \<rparr>
  })
  [+]
  (\<lambda>(sv, sp). {((), sv', sp')|sv' sp' reg_state'.
    LDegraded \<le> admin_state sp
    \<and> (\<forall>ind. reg_state' ind \<le> reg_state sp ind)
    \<and> sp' = sp\<lparr>
        reg_state := reg_state',
        admin_state := LDegraded
    \<rparr>
    \<and> sv' = \<lparr> abs_card_mode = ACDegraded, abs_updated = {}, upd_mem = Map.empty \<rparr>
  })
  "

definition startup1 :: "(unit, 'c)abs5_monad" where
  "startup1 \<equiv> compose startup1_NN (((set_abs_updated {} :: (unit, 'c)abs5_monad) \<guillemotright>N fail_admin)\<Down>NE) empty"

definition check_pub_region ::
  "pub_indx \<Rightarrow> (unit, 'c)abs5_monad" where
  check_pub_region_def[monad_def]:
  "check_pub_region pind \<equiv> do {
    maybe_mess_up_admin_silence_deg \<guillemotright> chooseN (UNIV :: sync_direction set);
    access_silence_deg pind;
    maybe_mess_up_admin_silence_deg
  }"

definition check_all_public :: 
  "(unit, 'c) abs5_monad" where
  check_all_public_def[monad_def]:
  "check_all_public \<equiv> do {
    l \<leftarrow> chooseN (order_set UNIV);
    mapM' check_pub_region l
  }"

definition startup2 :: "('a, 'c)abs5_monad" where
  startup2_def[monad_def]:
  "startup2 \<equiv> do {
    check_all_public;
    throw_abs_mode_error EU;
    throw StartedExc
  }"
  
definition startup :: "('a, 'c)abs5_monad" where
  startup_def[monad_def]:
  "startup \<equiv> do {
    startup1;
    startup2
  }"

end
            

