theory Abs6_CommonDefs
  imports Abs6Defs
begin

definition abs6_degrade where
  "abs6_degrade \<equiv> (\<lambda>(cmode, sp).
  {(Some (Inr ()), min cmode ACDegraded, sp')|sp' a_st' deg.
    a_st' \<le> admin_state sp
    \<and> (a_st' = LDead \<longrightarrow> admin_state sp = LDead)
    \<and> (a_st' = LDegraded \<or> deg \<noteq> {})
    \<and> sp' = sp\<lparr>
        reg_state := override_on (reg_state sp) ((min LDegraded) o (reg_state sp)) deg,
        admin_state := a_st'
    \<rparr>
  })"

definition abs6_fail where
  "abs6_fail \<equiv> \<lambda>(_, sp).
    {(Some (Inl FailMode), ACFail, sp')|sp' reg_state' a_st'.
        (\<forall>ind. reg_state' ind \<le> reg_state sp ind)
        \<and> a_st' \<le> admin_state sp
        \<and> (a_st' = LDead \<or> (LDead \<in> range reg_state'))
        \<and> sp' = sp\<lparr>
            reg_state := reg_state',
            admin_state := a_st'
        \<rparr>
    }
  "

definition read_success :: "pub_indx \<Rightarrow> ('c, 'c)abs6_monad" where
  "read_success ind \<equiv> \<lambda>(cmode, sp).
    {(Some (Inr cnt), cmode, sp)|cnt.
        reg_state sp ind \<ge> LDegraded
        \<and> cnt = memory sp ind
  }"
        
definition restart_mangle_sp :: "('a, 'c)abs6_monad" where
  "restart_mangle_sp \<equiv> \<lambda>(cmode, sp).
    {(None, cmode', sp')|cmode' sp' reg_state' adm_state'.
        (\<forall>ind. reg_state' ind \<le> reg_state sp ind)
        \<and> adm_state' \<le> admin_state sp
        \<and> sp' = sp\<lparr> reg_state := reg_state', admin_state := adm_state' \<rparr>
    }"

definition throw_mode_error :: "'c exc_val \<Rightarrow> (unit, 'c)abs6_monad" where
  "throw_mode_error val \<equiv> do {
    mode \<leftarrow> getsV id;
    if mode = ACFail
    then throw FailMode
    else if mode = ACDegraded
    then throw (Degraded val)
    else return ()
  }"

end