theory Abs6_SpecRef
  imports "../abs5/Abs5_Specification" Abs6_Specification "../SpecRef_Lemmas" Abs6_Ref
begin

lemma projectN_eq_imp_projectNN_eq: "(x\<Down>N) = (y\<Down>N) \<Longrightarrow> (x\<Down>NN) = (y\<Down>NN)"
  by(auto simp add: project_defs intro!: ext dest: fun_cong)

lemma projectN_eq_imp_projectNE_eq: "(x\<Down>N) = (y\<Down>N) \<Longrightarrow> (x\<Down>NE) = (y\<Down>NE)"
  by(auto simp add: project_defs intro!: ext dest: fun_cong)

lemma sim_norm_ext_try_rec_tryR:
  "sim_norm_ext R (rec_tryR ma) (rec_tryR mc) Sn Se
  = sim_norm_ext R (try_rec_tryR ma ma) (try_rec_tryR mc mc) Sn Se"
  by(auto simp add: sim_norm_ext_def try_rec_tryR_def 
    try_rec_tryR_same[THEN projectN_eq_imp_projectNN_eq]
    try_rec_tryR_same[THEN projectN_eq_imp_projectNE_eq]
  )

theorem abs5_refines_abs6:
  "refines abs6_abs5_strel id abs6_spec abs5_spec"
proof(intro refinesI)
  show "obs_consistent abs6_abs5_strel id abs6_spec abs5_spec"
    by(auto simp add: obs_consistent_def abs6_spec_def abs5_spec_def 
      abs6_abs5_strel_def obs_ts abs_mem.truncate_def abs_vol_mem.truncate_def intro!: ext)
next
  show "PO_refines abs6_abs5_strel abs6_spec abs5_spec"
  proof(rule refine_basic)
    show "init_trans abs5_spec `` init abs5_spec
        \<subseteq> abs6_abs5_strel `` init_trans abs6_spec `` init abs6_spec"
      apply(simp add: abs5_spec_def abs5_ts_def abs6_spec_def abs6_ts_def TS.defs spec.defs)
      apply(rule sim_norm_init_inclusion)
      apply(rule Abs6_Ref.startup_ref[THEN sim_imp_sim_norm, simplified sim_norm_def])
      apply(auto simp add: abs6_abs5_strel_def all_conj)
      done
  next
    have restart_ref:
      "sim abs6_abs5_strel
      restart_mangle_sv restart_mangle_sv
      "
      by(auto simp add: sim_def sim_ext_def simN_wpc_def simS_wpc_def brute_force
        abs6_abs5_strel_def)
    show "{abs6_abs5_strel} 
            TS.trans abs6_spec, TS.trans abs5_spec 
        {> abs6_abs5_strel}"
      apply(simp add: abs6_spec_def abs6_ts_def abs5_spec_def abs5_ts_def spec.defs TS.defs 
        abs6_trans_def abs5_trans_def)
      apply(intro relhoare_UN_lockstep allI relhoare_set_fun_choice_lockstep)
      apply(auto intro!: sim_norm_ext_imp_PO_rhoare 
        Abs6_Ref.fetch_reduced_ref
        Abs6_Ref.update_reduced_ref
        abs6_startup_full_ref_N
        Abs6_Ref.startup_reduced_ref
        simp add: try_rec_tryR_def sim_norm_def[THEN symmetric])
      apply(rule sim_norm_try_catchRI[OF restart_ref])
      apply(rule sim_norm_mono_abs[OF _ startup_reduction[THEN allI]])
      apply(simp add: sim_norm_def sim_norm_ext_try_rec_tryR try_rec_tryR_def)
      apply(rule Abs6_Ref.startup_full_ref[THEN sim_imp_sim_norm, simplified sim_norm_def])
      done
  qed
qed

theorem abs5_implements_abs6:
  "implements id abs6_spec abs5_spec"
  by(intro abs5_refines_abs6 refinement_soundness[where R="abs6_abs5_strel"])

end