theory Abs6_Specification
  imports Abs6_UpdateDefs Abs6_StartupDefs Abs6_FetchDefs "../Pmm_Specification"
begin

definition abs6_trans 
  :: "((abs_card_mode \<times> 'c abs_mem) \<times> (abs_card_mode \<times> 'c :: size abs_mem))set" where
  "abs6_trans \<equiv> \<Union>upd_f ind. set_fun_into_rel (
    ((try_catchR (Abs6_UpdateDefs.update upd_f) Abs6_StartupDefs.startup)\<Down>SN)
    [+] ((try_catchR (Abs6_FetchDefs.fetch ind) Abs6_StartupDefs.startup)\<Down>SN)
    [+] ((try_catchR (restart_mangle_sv :: (unit, 'c)abs6_monad) Abs6_StartupDefs.startup)\<Down>SN)
  )"

definition abs6_ts 
  :: "(abs_card_mode \<times> 'c :: size abs_mem)TS" where
  "abs6_ts \<equiv> \<lparr> 
    init = UNIV, 
    init_trans = set_fun_into_rel 
        ((Abs6_StartupDefs.startup :: (unit, 'c)abs6_monad)\<Down>SN), 
    trans = abs6_trans 
  \<rparr>"

fun abs6_obs :: "abs_card_mode \<times> 'c abs_mem \<Rightarrow> abs_card_mode \<times> ('c :: size) obs_abs_mem" where
  "abs6_obs (sv, sp) = (sv, abs_mem_obs sp)"

definition abs6_spec :: "(abs_card_mode \<times> 'c abs_mem, abs_card_mode \<times> 'c :: size obs_abs_mem)spec" 
  where
  "abs6_spec \<equiv> TS.extend abs6_ts (spec.fields abs6_obs)"

end

