theory Abs6_StartupDefs
imports Abs6Defs Abs6_CommonDefs "../Composition"
begin

definition abs6_startup_normal where
  "abs6_startup_normal \<equiv> (\<lambda>(_, sp).
  {(Some (Inl StartedExc), ACNormal, sp')|deg sp'.
    admin_state sp = LOK
    \<and> LDead \<notin> range (reg_state sp)
    \<and> sp' = sp\<lparr>
        reg_state := override_on (reg_state sp) (K LDegraded) deg
    \<rparr>
  })"

definition abs6_startup_degrade where
  "abs6_startup_degrade \<equiv> (\<lambda>(_, sp).
  {(Some (Inl (Degraded EU)), ACDegraded, sp')|sp' a_st' deg.
    a_st' \<le> admin_state sp
    \<and> a_st' \<noteq> LDead
    \<and> LDead \<notin> range (reg_state sp)
    \<and> (a_st' = LDegraded \<or> deg \<noteq> {})
    \<and> sp' = sp\<lparr>
        reg_state := override_on (reg_state sp) (K LDegraded) deg,
        admin_state := a_st'
    \<rparr>
  })"

definition startup where
  "startup \<equiv>
    abs6_startup_normal
    [+] abs6_startup_degrade
    [+] abs6_fail
    [+] restart_mangle_sp
  "
  
lemmas startup_defs =
  startup_def
  abs6_startup_normal_def
  abs6_startup_degrade_def
  abs6_fail_def

end 
            

