theory ConcreteDefs
imports "../PmmDefs" "../Inst_State"
begin

text {*

  \DefineSnippet{state_def}{

*}

record 'a state =
  memory :: "indx \<Rightarrow> INST \<Rightarrow> 'a"
  hw_state :: "indx \<Rightarrow> INST \<Rightarrow> hw_state"

text {*
  }%EndSnippet
*}

type_synonym ('a, 'sv, 'c)pmm_monad = "('a, 'c exceptions, 'sv, 'c state)pre_monad"

definition hash_of_hinst :: "'a :: contents_cl state \<Rightarrow> INST \<Rightarrow> 'a hash" where
  "hash_of_hinst s inst \<equiv> snd (parse_hinst (memory s (Admin HASH_REG) inst))"

definition ok_hash_cnt :: "'a :: contents_cl \<Rightarrow> bool" where
  "ok_hash_cnt cnt \<equiv> let parsed = parse_hinst cnt in snd parsed = Hash (fst parsed)"

definition ok_hash_reg_read :: "('a :: contents_cl) state \<Rightarrow> INST \<Rightarrow> bool" where
  "ok_hash_reg_read s inst \<equiv> ok_hash_cnt (memory s (Admin HASH_REG) inst) 
  \<and> hw_state s (Admin HASH_REG) inst \<noteq> IDead"

text {*
  @{text "written_hash"} gives us the written hash (contained in the HASH_REG) of any
  region. Note that this SHOULDN'T be used with HASH_REG itself! (use @{term "hash_of_hash"}
  instead.
*}

definition written_hash :: "('a :: contents_cl) state \<Rightarrow> INST \<Rightarrow> 'a htable" 
  where
  "written_hash s inst \<equiv> (parse_htable o fst o parse_hinst) (memory s (Admin HASH_REG) inst)"

definition ptr_f :: "'c :: contents_cl state \<Rightarrow> INST \<Rightarrow> pub_indx set" where
  "ptr_f s inst \<equiv> parse_ptr (memory s (Admin PTR_REG) inst)"

end

