theory Concrete_Specification
  imports "../Pmm_Specification" UpdateDefs StartupDefs FetchDefs "../abs1/HTable2"
begin

fun htable2_to_htable :: "'c htable2 \<Rightarrow> 'c :: serialization_cl htable" where
  "htable2_to_htable (HTable2 pub_h ptr_h) =
    HTable pub_h (\<lambda>inst. Hash (serialize_ptr (ptr_h inst)))"

definition pmm_trans 
  :: "((pmm_vol_mem \<times> ('c :: contents_cl) state) \<times> (pmm_vol_mem \<times> 'c state))set" where
  "pmm_trans \<equiv> \<Union>upd_f ind. set_fun_into_rel (
    ((try_rec_tryR (UpdateDefs.update upd_f) StartupDefs.startup)\<Down>SN)
    [+] ((try_rec_tryR (FetchDefs.fetch ind) StartupDefs.startup)\<Down>SN)
    [+] ((try_rec_tryR 
        (restart_mangle_sv :: (unit, pmm_vol_mem, 'c)pmm_monad)
        StartupDefs.startup)\<Down>SN)
  )"

definition pmm_matches_hash :: "'c :: contents_cl state \<Rightarrow> INST \<Rightarrow> indx \<Rightarrow> INST \<Rightarrow> bool" where
  "pmm_matches_hash sp hinst ind inst \<equiv>
    matches_htable (ConcreteDefs.written_hash sp hinst) ind inst (state.memory sp ind inst)"

definition pmm_init :: "(pmm_vol_mem \<times> 'c :: contents_cl state)set" where
  "pmm_init \<equiv> {(sv, sp). \<forall>inst. 
    (ok_hash_reg_read sp inst \<longrightarrow> (
        state.hw_state sp (Admin HASH_REG) inst \<noteq> IUnwr
        \<and> (state.hw_state sp (Admin PTR_REG) Primary \<noteq> IOK \<longrightarrow> 
            \<not> pmm_matches_hash sp inst (Admin PTR_REG) Primary))
        \<and> (state.hw_state sp (Admin PTR_REG) Secondary \<noteq> IOK \<longrightarrow> 
            \<not> pmm_matches_hash sp inst (Admin PTR_REG) Secondary)
        \<and> (\<exists>ht2. memory sp (Admin HASH_REG) inst = htable_to_hinst_cnt (htable2_to_htable ht2))
    )
    \<and> (\<forall>ind inst. size (memory sp ind inst) \<le> capacity ind)
    \<and> (\<forall>inst. \<exists>ptr_set. memory sp (Admin PTR_REG) inst = serialize_ptr (ptr_set))
  }"

definition pmm_ts :: "(pmm_vol_mem \<times> 'c :: contents_cl state)TS" where
  "pmm_ts \<equiv> \<lparr> 
    init = pmm_init, 
    init_trans = set_fun_into_rel 
        ((rec_tryR StartupDefs.startup :: (unit, pmm_vol_mem, 'c)pmm_monad)\<Down>SN), 
    trans = pmm_trans 
  \<rparr>"

definition pmm_spec :: "((pmm_vol_mem \<times> 'c :: contents_cl state), (pmm_vol_mem \<times> 'c state))spec" where
  "pmm_spec \<equiv> TS.extend pmm_ts (spec.fields id)"


end