val antiq_setup =
  Thy_Output.antiquotation @{binding record} (Args.type_name false)
    (fn {source = src, context = ctxt, ...} => fn rco =>
      let
        val thy = Proof_Context.theory_of ctxt;
        (*
        val _ = tracing ("Type name: " ^ rco);
        *)
        val {parent = parent, fields = fields, args = targs, ... } = Record.the_info thy rco;
        (* val fbrk = Pretty.str "\n"; *)
        (* This doesn't work with latex output *)
        val fbrk = Pretty.fbrk;
        val fbreaks = Library.separate fbrk;
        val ty = Type (rco, map TFree targs);
        val maybe_pretty_parent = case parent of
                                      SOME p => Syntax.pretty_typ ctxt (Type (swap p)) 
                                    | NONE => Pretty.str ""
            
        fun pretty_field (name, typ) =
            Pretty.block [
                Syntax.pretty_term ctxt (Const (name, typ))
                , Pretty.brk 1
                , Pretty.str "::"
                , Pretty.brk 1
                , Syntax.pretty_typ ctxt typ
            ]
        val pretty_record = 
            Pretty.block (
                Pretty.command "record" :: Pretty.brk 1
                 :: Syntax.pretty_typ ctxt ty
                 :: Pretty.str " =" :: Pretty.brk 1 
                 :: maybe_pretty_parent 
                 :: fbrk
                 :: fbreaks (map pretty_field fields)
            )
      (*
        val fields = Record.get_recT_fields thy rco;
        val f0 = nth (fst fields) 0;
      *)
          (*
        val thy = Proof_Context.theory_of ctxt;
        val parent = Record.
        val (vs, cos) = the_spec thy dtco;
        val ty = Type (dtco, map TFree vs);
        val pretty_typ_bracket = Syntax.pretty_typ (Config.put pretty_priority 1001 ctxt);
        fun pretty_constr (co, tys) =
          Pretty.block (Pretty.breaks
            (Syntax.pretty_term ctxt (Const (co, tys ---> ty)) ::
              map pretty_typ_bracket tys));
        val pretty_datatype =
          Pretty.block
           (Pretty.command "datatype" :: Pretty.brk 1 ::
            Syntax.pretty_typ ctxt ty ::
            Pretty.str " =" :: Pretty.brk 1 ::
            flat (separate [Pretty.brk 1, Pretty.str "| "] (map (single o pretty_constr) cos)));
          *)
      in
          (*
          tracing "Parent: ";
          tracing (PolyML.makestring parent);
          *)
          (*
          tracing "Fields: ";
          tracing (PolyML.makestring fields);
          tracing "End of fields";
          *)
          (*
          tracing "F0";
          pprint (pretty_term ctxt (Const f0));
          *)
          (*
          Thy_Output.output ctxt []
          *)
          (* pprint pretty_record; *)
        Thy_Output.output ctxt
          (Thy_Output.maybe_pretty_source (K (K pretty_record)) ctxt src [()])
      end);

